<?php

class DPageDef
{

	protected $_pageDef = [];
	protected $_fileDef = [];
	protected $_tabDef = [];

	protected function __construct()
	{
		$this->defineAll();
	}

	public static function GetInstance()
	{
		if (!isset($GLOBALS['_DPageDef_'])) {
			$GLOBALS['_DPageDef_'] = new DPageDef();
		}
		return $GLOBALS['_DPageDef_'];
	}

	public function GetFileDef($type)
	{
		if (!isset($this->_fileDef[$type])) {
			$funcname = 'add_FilePage_' . $type;
			$this->$funcname();
		}
		return $this->_fileDef[$type];
	}

	public function GetPageDef($type, $pid)
	{
		return $this->_pageDef[$type][$pid];
	}

	public function GetTabDef($type)
	{
		return $this->_tabDef[$type];
	}

	protected function add_FilePage_serv()
	{
		$pages = [];
		$pages[] = new DFileSect([
			'SERV_PROCESS', 'SERV_GENERAL',
			'SERV_LOG', 'SERV_ACLOG', 'A_GEOIP', 'SERV_IP2LOCATION',
			'SERV_TUNING_OS', 'SERV_TUNING_CONN', 'SERV_TUNING_REQ', 'SERV_TUNING_GZIP', 'SERV_TUNING_SSL', 'SERV_TUNING_SSLSNI', 'SERV_QUIC',
			'SERV_SEC_DOS', 'SERV_SEC_WP', 'SERV_SEC_CONN', 'SERV_SEC_CC', 'A_SEC_CR', 'SERV_SEC_RECAP', 'A_SECAC',
			'SERV_CACHE_STORAGE', 'SERV_CACHE_POLICY', 'A_CACHE_NCURL', 'SERV_CACHE_NCDOMAIN',
			'SERV_PAGESPEED',
			'ZCONF_GENERAL', 'ZCONF_WORKER', 'ZCONF_L', 'ZCONF_LOG', 'ZCONF_ACLOG', 'ZCONF_AC',
			'VH_TOP_D', 'SERVICE_SUSPENDVH',
		]);

		$pages[] = new DFileSect(
				['LB_SEL_FILE'],
				'loadBalancerList:loadBalancer', 'clusters', 'name');

		$pages[] = new DFileSect(
				['L_SEL_FILE'],
				'listenerList:listener', 'listeners', 'name');


		$pages[] = new DFileSect(
				['TP', 'TP_ZCONF', 'TP_MEMBER'],
				'vhTemplateList:vhTemplate', 'tpTop', 'name');

		$this->_fileDef['serv'] = $pages;
	}

	protected function add_FilePage_vh()
	{
		$pages = [];
		$pages[] = new DFileSect([
			'VH_GENERAL', 'VH_LOG', 'VH_ACLOG', 'VH_ERRPG',
			'VH_SEC_WP', 'TP_SEC_BD', 'TP_SEC_CONN', 'VH_SEC_RECAP', 'A_SECAC', 'VH_REALM_SEL',
			'VH_SEC_CC', 'A_SEC_CR',
			'VH_CACHE_STORAGE', 'VH_CACHE_POLICY', 'A_CACHE_NCURL',
			'VH_CTX_SEL',
			'VH_REWRITE_CTRL', 'VH_REWRITE_MAP', 'VH_REWRITE_RULE',
			'VH_SSL_CERT', 'VH_SSL_SSL', 'VH_SSL_FEATURE', 'VH_SSL_OCSP', 'VH_SSL_CLIENT_VERIFY',
			'VH_PAGESPEED'
		]);
		$this->_fileDef['vh'] = $pages;
	}

	protected function add_FilePage_tp()
	{
		$pages = [];
		$pages[] = new DFileSect(
				['TP_GENERAL1']);

		$pages[] = new DFileSect([
			'TP_GENERAL2', 'TP_LOG', 'TP_ACLOG', 'VH_ERRPG',
			'VH_SEC_WP', 'TP_SEC_BD', 'TP_SEC_CONN', 'VH_SEC_RECAP', 'A_SECAC', 'TP_REALM_SEL',
			'VH_SEC_CC', 'A_SEC_CR',
			'VH_CACHE_STORAGE', 'VH_CACHE_POLICY', 'A_CACHE_NCURL',
			'VH_CTX_SEL',
			'VH_REWRITE_CTRL', 'VH_REWRITE_MAP', 'VH_REWRITE_RULE',
			'VH_SSL_CERT', 'VH_SSL_SSL', 'VH_SSL_FEATURE', 'VH_SSL_OCSP', 'VH_SSL_CLIENT_VERIFY',
			'VH_PAGESPEED',
				],
				'virtualHostConfig');

		$this->_fileDef['tp'] = $pages;
	}

	protected function add_FilePage_admin()
	{
		$pages = [];
		$pages[] = new DFileSect(
				['ADMIN_PHP', 'VH_LOG', 'VH_ACLOG', 'A_SECAC']);

		$pages[] = new DFileSect(
				['ADMIN_L_GENERAL', 'L_SSL_CERT', 'L_SSL', 'L_SSL_FEATURE', 'L_SSL_CLIENT_VERIFY'],
				'listenerList:listener', 'listeners', 'name');

		$this->_fileDef['admin'] = $pages;
	}

	function add_FilePage_ha()
	{
		$pages = [];
		$pages[] = new DFileSect(['HA_CONF_REPLICATION', 'HA_CONF']);

		$this->_fileDef['ha'] = $pages;
	}

	protected function defineAll()
	{
		$page = new DPage('serv', 'general', 'General',
				'Server General Settings',
				['SERV_PROCESS', 'SERV_GENERAL', 'A_GEOIP_TOP', 'SERV_IP2LOCATION']);
		$page->_helpLink = 'LB_ServGeneral_Help.html';
		$this->_pageDef['serv'][$page->_id] = $page;

		$page = new DPage('serv', 'log', 'Log',
				'Server Log Settings',
				['SERV_LOG', 'SERV_ACLOG']);
		$page->_helpLink = 'LB_ServGeneral_Help.html';
		$this->_pageDef['serv'][$page->_id] = $page;

		$page = new DPage('serv', 'tuning', 'Tuning',
				'Server Tuning Settings',
				['SERV_TUNING_OS', 'SERV_TUNING_CONN', 'SERV_TUNING_REQ', 'SERV_TUNING_GZIP', 'SERV_TUNING_SSL', 'SERV_TUNING_SSLSNI', 'SERV_QUIC']);
		$page->_helpLink = 'LB_ServTuning_Help.html';
		$this->_pageDef['serv'][$page->_id] = $page;

		$page = new DPage('serv', 'security', 'Security',
				'Server Security Settings',
				['SERV_SEC_DOS', 'SERV_SEC_WP', 'SERV_SEC_CC', 'A_SEC_CR_TOP', 'SERV_SEC_CONN', 'SERV_SEC_RECAP', 'A_SECAC']);
		$page->_helpLink = 'LB_ServSecurity_Help.html';
		$this->_pageDef['serv'][$page->_id] = $page;

		$page = new DPage('serv', 'cache', 'Cache',
				'Server Cache Settings',
				['SERV_CACHE_STORAGE', 'SERV_CACHE_POLICY', 'A_CACHE_NCURL', 'SERV_CACHE_NCDOMAIN']);
		$page->_helpLink = 'Cache_Help.html';
		$this->_pageDef['serv'][$page->_id] = $page;

		$page = new DPage('serv', 'modpagespeed', 'PageSpeed',
				'PageSpeed Settings',
				['SERV_PAGESPEED']);
		$page->_helpLink = 'PageSpeed_Help.html';
		$this->_pageDef['serv'][$page->_id] = $page;

		$page = new DPage('serv', 'zconf', 'ZeroConf',
				'ZeroConfig Settings',
				['ZCONF_GENERAL', 'ZCONF_WORKER', 'ZCONF_L_TOP', 'ZCONF_LOG', 'ZCONF_ACLOG', 'ZCONF_AC']);
		$page->_helpLink = 'ZeroConf_Help.html';
		$this->_pageDef['serv'][$page->_id] = $page;

		$page = new DPage('lbtop', 'cluster', 'Clusters',
				'Clusters',
				['LB_TOP']);
		$page->_helpLink = 'LB_LoadBalancer_Help.html';
		$this->_pageDef['lbtop'][$page->_id] = $page;

		$page = new DPage('lb', 'lbgeneral', 'General',
				'Load Balancer General Settings',
				['LB_GENERAL', 'LB_SESSION', 'LB_ERRMSG']);
		$page->_helpLink = 'LB_LoadBalancer_Help.html';
		$this->_pageDef['lb'][$page->_id] = $page;

		$page = new DPage('lb', 'lbworker', 'Worker Group',
				'Load Balancer Worker Group Settings',
				['LB_WORKERGRP_TOP']);
		$page->_helpLink = 'LB_LoadBalancer_Help.html';
		$this->_pageDef['lb'][$page->_id] = $page;

		$page = new DPage('lb4', 'lb4general', 'General',
				'Load Balancer General Settings',
				['LB4_GENERAL']);
		$page->_helpLink = 'LB_LoadBalancer_Help.html';
		$this->_pageDef['lb4'][$page->_id] = $page;

		$page = new DPage('lb4', 'lb4worker', 'Worker Group',
				'Load Balancer Worker Group Settings',
				['LB4_WORKERGRP_TOP']);
		$page->_helpLink = 'LB_LoadBalancer_Help.html';
		$this->_pageDef['lb4'][$page->_id] = $page;

		$page = new DPage('tptop', 'tpTop', 'Virtual Host Templates',
				'Virtual Host Templates',
				['TP_TOP']);
		$page->_helpLink = 'Templates_Help.html';
		$this->_pageDef['tptop'][$page->_id] = $page;

		$page = new DPage('vhtop', 'vhTop', 'Virtual Hosts',
				'Virtual Hosts Settings',
				['VH_TOP']);
		$page->_helpLink = 'LB_VirtualHosts_Help.html';
		$this->_pageDef['vhtop'][$page->_id] = $page;

		$page = new DPage('sltop', 'slTop', 'Server Listeners',
				'Listeners Settings',
				['L_TOP']);
		$page->_helpLink = 'Listeners_Help.html';
		$this->_pageDef['sltop'][$page->_id] = $page;

		$page = new DPage('sl', 'lgeneral', 'General',
				'Listener General Settings',
				['L_GENERAL', 'L_VHMAP_TOP']);
		$page->_helpLink = 'Listeners_Help.html';
		$this->_pageDef['sl'][$page->_id] = $page;

		$page = new DPage('sl', 'lsecure', 'SSL',
				'Listener SSL Settings',
				['L_SSL_CERT', 'L_SSL', 'L_SSL_FEATURE', 'L_SSL_OCSP', 'L_SSL_CLIENT_VERIFY']);
		$page->_helpLink = 'Listeners_Help.html';
		$this->_pageDef['sl'][$page->_id] = $page;

		$page = new DPage('sl4', 'ltgeneral', 'General',
				'TCP Listener General Settings',
				['LT_GENERAL', 'LT_CLMAP']);
		$page->_helpLink = 'Listeners_Help.html';
		$this->_pageDef['sl4'][$page->_id] = $page;

		$page = new DPage('vh', 'base', 'Basic',
				'Virtual Host Base',
				['VH_BASE']);
		$this->_pageDef['vh'][$page->_id] = $page;

		$page = new DPage('tp', 'member', 'Template',
				'Template Settings',
				['TP', 'TP_ZCONF', 'TP_MEMBER_TOP']);
		$page->_helpLink = 'Templates_Help.html';
		$this->_pageDef['tp'][$page->_id] = $page;

		$page = new DPage('vh', 'general', 'General',
				'Virtual Host General Settings',
				['VH_GENERAL', 'VH_LOG', 'VH_ACLOG', 'VH_ERRPG_TOP']);
		$page->_helpLink = 'LB_VHGeneral_Help.html';
		$this->_pageDef['vh'][$page->_id] = $page;

		$page = new DPage('tp', 'general', 'General',
				'Template General Settings',
				['TP_GENERAL', 'TP_LOG', 'TP_ACLOG', 'VH_ERRPG_TOP']);
		$page->_helpLink = 'VHGeneral_Help.html';
		$this->_pageDef['tp'][$page->_id] = $page;

		$page = new DPage('vh', 'security', 'Security',
				'Virtual Host Security Settings',
				['VH_SEC_WP', 'VH_SEC_CC', 'A_SEC_CR_TOP',
			'TP_SEC_BD', 'TP_SEC_CONN', 'VH_SEC_RECAP', 'A_SECAC', 'VH_REALM_TOP']);
		$page->_helpLink = 'VHSecurity_Help.html';
		$this->_pageDef['vh'][$page->_id] = $page;

		$page = new DPage('tp', 'security', 'Security',
				'Template Security Settings',
				['VH_SEC_WP', 'VH_SEC_CC', 'A_SEC_CR_TOP',
			'TP_SEC_BD', 'TP_SEC_CONN', 'VH_SEC_RECAP', 'A_SECAC', 'TP_REALM_TOP']);
		$page->_helpLink = 'VHSecurity_Help.html';
		$this->_pageDef['tp'][$page->_id] = $page;

		$page = new DPage('vh', 'cache', 'Cache',
				'Virtual Host Cache Settings',
				['VH_CACHE_STORAGE', 'VH_CACHE_POLICY', 'A_CACHE_NCURL']);
		$page->_helpLink = 'Cache_Help.html';
		$this->_pageDef['vh'][$page->_id] = $page;
		$this->_pageDef['tp'][$page->_id] = $page;

		$page = new DPage('vh', 'rewrite', 'Rewrite',
				'Virtual Host Rewrite Settings',
				['VH_REWRITE_CTRL', 'VH_REWRITE_MAP_TOP', 'VH_REWRITE_RULE']);
		$page->_helpLink = 'LB_Rewrite_Help.html';
		$this->_pageDef['vh'][$page->_id] = $page;
		$this->_pageDef['tp'][$page->_id] = $page;

		$page = new DPage('vh', 'context', 'Context',
				'Virtual Host Context Settings',
				['VH_CTX_TOP']);
		$page->_helpLink = 'LB_Context_Help.html';
		$this->_pageDef['vh'][$page->_id] = $page;
		$this->_pageDef['tp'][$page->_id] = $page;

		$page = new DPage('vh', 'vhssl', 'SSL',
				'Virtual Host SSL Settings',
				['VH_SSL_CERT', 'VH_SSL_SSL', 'VH_SSL_FEATURE', 'VH_SSL_OCSP', 'VH_SSL_CLIENT_VERIFY']);
		$page->_helpLink = 'Listeners_Help.html';
		$this->_pageDef['vh'][$page->_id] = $page;
		$this->_pageDef['tp'][$page->_id] = $page;

		$page = new DPage('vh', 'modpagespeed', 'PageSpeed',
				'PageSpeed Settings',
				['VH_PAGESPEED']);
		$page->_helpLink = 'PageSpeed_Help.html';
		$this->_pageDef['vh'][$page->_id] = $page;
		$this->_pageDef['tp'][$page->_id] = $page;

		$page = new DPage('admin', 'general', 'General',
				'Web Admin Settings',
				['ADMIN_PHP', 'VH_LOG', 'VH_ACLOG']);
		$page->_helpLink = 'AdminGeneral_Help.html';
		$this->_pageDef['admin'][$page->_id] = $page;

		$page = new DPage('admin', 'security', 'Security',
				'Web Admin Security Settings',
				['A_SECAC', 'ADMIN_USR_TOP']);
		$page->_helpLink = 'AdminGeneral_Help.html';
		$this->_pageDef['admin'][$page->_id] = $page;

		$page = new DPage('altop', 'alTop', 'Admin Listeners',
				'Listeners Settings',
				['ADMIN_L_TOP']);
		$page->_helpLink = 'AdminListener_Help.html';
		$this->_pageDef['altop'][$page->_id] = $page;

		$page = new DPage('al', 'lgeneral', 'General',
				'Admin Listener General Settings',
				['ADMIN_L_GENERAL'],
				'listeners', 'mid');
		$page->_helpLink = 'AdminListener_Help.html';
		$this->_pageDef['al'][$page->_id] = $page;

		$page = new DPage('al', 'lsecure', 'SSL',
				'Listener SSL Settings',
				['L_SSL_CERT', 'L_SSL', 'L_SSL_FEATURE', 'L_SSL_CLIENT_VERIFY']);
		$page->_helpLink = 'AdminListener_Help.html';
		$this->_pageDef['al'][$page->_id] = $page;

		$page = new DPage('ha', 'haconfig', 'Config',
				'Config HA Settings',
				['HA_CONF_REPLICATION', 'HA_CONF_TOP']);
		//$page->_helpLink = 'LB_ServGeneral_Help.html';
		$this->_pageDef['ha'][$page->_id] = $page;

		$page = new DPage('ha', 'hastatus', 'Status',
				'HA Status',
				['HA_STATUS', 'HA_REPLSTATUS']);
		///$page->_helpLink = 'LB_ServTuning_Help.html';
		$this->_pageDef['ha'][$page->_id] = $page;

		$types = array_keys($this->_pageDef);
		foreach ($types as $type) {
			$pids = array_keys($this->_pageDef[$type]);
			foreach ($pids as $pid) {
				$this->_tabDef[$type][$pid] = $this->_pageDef[$type][$pid]->_name;
			}
		}
	}

}
