<?php

class DTblHAStatus extends DTbl
{

    public function PrintHtml( &$data, $ref, $disp, $isEdit )
    {
        $this->printViewHtml($data, $ref, $disp) ;
    }

    private function getPrintHeader()
    {
        // now use r, a, y, d
        $buf = <<<'EOD'
<script type="text/javascript">
function ha_apply(act, actId)
{
	document.confform.a.value = act;
	document.confform.t.value = "HA_STATUS";
	document.confform.r.value = actId;
	if (act == 'r') { //refresh
		document.confform.submit();
		return;
	}
	if (act == 'a')
		descr = "add the newly configured";
	else if (act == 'y')
		descr = 'enable (and also apply configuration changes to)';
	else if (act == 'z')
		descr = 'disable';
	else if (act == 'd')
		descr = 'remove';

	if ( confirm("Are you sure you want to " + descr + ' interface ' + actId + "?\nThis may take a few seconds, please be patient.") ) {
		document.confform.submit();
        }
}
</script>

EOD;

        $buf .= '<tr><td class=xtbl_header colspan="7">' ;

        // tooltip
        $table_help = ' ' ;

        $dhelp_item = DATTR_HELP::GetInstance()->GetItem($this->_helpKey) ;
        if ( $dhelp_item != NULL ) {
            $table_help = '&nbsp;&nbsp;&nbsp;&nbsp' . $dhelp_item->render($this->_helpKey) ;
        }
        $title = $this->_title ;
        $buf .= '<span class="xtbl_title">' . $title . $table_help . '</span>' ;
        $buf .= '<span class="xtbl_edit"><a href="javascript:ha_apply(\'r\',0);">Refresh</a></span>';
        $buf .= "</td></tr>\n" ;

        // use defined label later
        $sysClr = 'green';
        $cf = '<br/><span style="font-size:0.9em">Configured</span><br/><span style="color:' . $sysClr . ';font-size:0.9em;font-weight:bold">Live</span></td><td>';
        $buf .= '<tr class="xtbl_title2"><td align="center">Interface ID</td><td>Virtual IP' . $cf
                . 'VIP ID' . $cf . 'NIC Name' . $cf . 'Priority' . $cf
                . 'Internal Device' . $cf . 'Unicast Src' . $cf . 'Unicast Peers' . $cf
                . 'Status' . $cf . 'Actions</td></tr>' ;
        return $buf ;
    }

    private function printViewHtml(&$data, $ref, $disp)
	{
		$buf = '<div><table width="' . $this->_width . '" class="xtbl" border="0" cellpadding="5" cellspacing="1">' . "\n";

		$buf .= $this->getPrintHeader();

		$sysSpan = '<span style="color:green;font-weight:bold">';

		$newdata = $this->prepareData($data);
		foreach ($newdata as $d) {
			$buf .= '<tr class="xtbl_value">';
			$buf .= '<td align="center">' . $d['id'] . '</td><td>'
					. $d['vip'] . '<br/>' . $sysSpan . $d['sys_vip'] . '</span></td><td>'
					. $d['vipId'] . '<br/>' . $sysSpan . $d['sys_vipId'] . '</span></td><td>'
					. $d['nic'] . '<br/>' . $sysSpan . $d['sys_nic'] . '</span></td><td>'
					. $d['priority'] . '<br/>' . $sysSpan . $d['sys_priority'] . '</span></td><td>'
					. $d['internal_dev'] . '<br/>' . $sysSpan . $d['sys_internal_dev'] . '</span></td><td>'
					. $d['unicastSrcIp'] . '<br/>' . $sysSpan . $d['sys_unicastSrcIp'] . '</span></td><td>'
					. $d['unicastPeerIps'] . '<br/>' . $sysSpan . $d['sys_unicastPeerIps'] . '</span></td><td>'
					. $d['status'] . '<br/>' . $sysSpan . $d['sys_status'] . '</span></td><td>'
					. $d['action'];
			$buf .= '</tr>' . "\n";
		}

		$buf .= '</table></div>';
		echo "$buf \n";
	}

	private function loadHAStatus($conf)
	{
		$hastatus = [];
		$filename = $_SERVER['LS_SERVER_ROOT'] . 'conf/.hastatus';

		if (!file_exists($filename)) {
			// regnerate
			$buf = '';
			foreach ($conf as $id => $c) {
				if (empty($c['vipId']) || !$c['vipId']->HasVal() || empty($c['vip']) || !$c['vip']->HasVal()) {
					continue;
				}
				$vipId = $c['vipId']->GetVal();
				$vip = $c['vip']->GetVal();
				$priority = empty($c['priority']) ? '' : $c['priority']->GetVal();

				$buf .= sprintf("(ID,%s) (VIP,%s) (VIPID,%s) (PRIORITY,%s) (STATUS,standby)",
						$id, $vip, $vipId, $priority);

				if (!empty($c['nic']) && $c['nic']->HasVal()) {
					$buf .= ' (NIC,' . $c['nic']->GetVal() . ')';
				}

				if (!empty($c['internal_dev']) && $c['internal_dev']->HasVal()) {
					$buf .= ' (INT_DEV,' . $c['internal_dev']->GetVal() . ')';
				}

				if (!empty($c['unicastSrcIp']) && $c['unicastSrcIp']->HasVal()) {
					$buf .= sprintf(' (UNICAST_SRC,%s) (UNICAST_PEER,%s)', $c['unicastSrcIp']->GetVal(), $c['unicastPeerIps']->GetVal());
				}
				$buf .= "\n";
				//$buf2 = $buf; ////////////////////////////////////
			}
			if (file_put_contents($filename, $buf) !== false) {
				ConfCenter::singleton()->haControlCommand('r', '', '');
			} else {
				error_log("fail to write to $filename");
				return $hastatus;
			}
		}

		//$tmpf = $_SERVER['LS_SERVER_ROOT'] . 'conf/hatmp';//////////////////////////////////////////////////////
		//file_put_contents($tmpf, $buf2 . var_export($conf, 1)); //////////////////////////////////////////

		$lines = file($filename);
		if ($lines == false) {
			return $hastatus;
		}
		/*
		  freebsd
		 * (ID,5) (VIP,192.168.0.200) (VIPID,60) (PRIORITY,70) (STATUS,master)
		  Linux
		 * (ID,1) (VIP,192.168.0.200) (VIPID,60) (PRIORITY,70) (STATUS,master) (NIC,eth0)
		  (ID,2) (VIP,192.168.0.201) (VIPID,1) (PRIORITY,60) (STATUS,standby) (NIC,eth1)
		 * */
		foreach ($lines as $line) {
			$line = trim($line);
			if ($line != '') {
				$pairs = explode(' ', $line);
				$entry = [];
				$id = '';
				foreach ($pairs as $p) {
					$m = [];
					if (preg_match("/\(([A-Z_]+),(.+)\)/", $p, $m)) {
						switch ($m[1]) {
							case 'ID':
								$id = $m[2];
								$entry['sys_id'] = $id;
								break;
							case 'VIP':
								$entry['sys_vip'] = $m[2];
								break;
							case 'VIPID':
								$entry['sys_vipId'] = $m[2];
								break;
							case 'PRIORITY':
								$entry['sys_priority'] = $m[2];
								break;
							case 'STATUS':
								$entry['sys_status'] = $m[2];
								break;
							case 'NIC':
								$entry['sys_nic'] = $m[2];
								break;
							case 'INT_DEV':
								$entry['sys_internal_dev'] = $m[2];
								break;
							case 'UNICAST_SRC':
								$entry['sys_unicastSrcIp'] = $m[2];
								break;
							case 'UNICAST_PEER':
								$entry['sys_unicastPeerIps'] = $m[2];
								break;

							default:
								error_log("not found , " . print_r($m, 1));
						}
					}
				}
				if ($id != '') {
					$hastatus[$id] = $entry;
				}
			}
		}
		ksort($hastatus);
		reset($hastatus);

		return $hastatus;
	}

	private function prepareData($data)
    {
        //process special
        $conf = is_array($data) ? $data : [] ;
        $sys = $this->loadHAStatus($conf) ;

        $ids = array_merge(array_keys($conf), array_keys($sys)) ;
        $status = [] ;
        foreach ( $ids as $id ) {
            $conf_status = '' ;
            $action = '' ;
            $s = [] ;
            $s['id'] = $id ;
            if ( isset($conf[$id]) ) {
                $c = $conf[$id];
                $s['vip'] = empty($c['vip']) ? '' : $c['vip']->GetVal() ;
                $s['vipId'] = empty($c['vipId']) ? '' : $c['vipId']->GetVal() ;
                $s['vipToken'] = empty($c['vipToken']) ? '' : $c['vipToken']->GetVal() ;
                $s['priority'] = empty($c['priority']) ? '' : $c['priority']->GetVal() ;
                $s['nic'] = empty($c['nic']) ? '' : $c['nic']->GetVal() ;
                $s['internal_dev'] = empty($c['internal_dev']) ? '' : $c['internal_dev']->GetVal() ;
                $s['unicastSrcIp'] = empty($c['unicastSrcIp']) ? '' : $c['unicastSrcIp']->GetVal() ;
                $s['unicastPeerIps'] = empty($c['unicastPeerIps']) ? '' : $c['unicastPeerIps']->GetVal() ;
                $s['note'] = empty($c['note']) ? '' : $c['note']->GetVal() ;
            }
            if ( isset($sys[$id]) ) {
                $s['sys_vip'] = $sys[$id]['sys_vip'] ;
                $s['sys_vipId'] = $sys[$id]['sys_vipId'] ;
                $s['sys_priority'] = $sys[$id]['sys_priority'] ;
                $s['sys_status'] = $sys[$id]['sys_status'] ;
                $s['sys_nic'] = $sys[$id]['sys_nic'] ;
                $s['sys_internal_dev'] = isset($sys[$id]['sys_internal_dev']) ? $sys[$id]['sys_internal_dev'] : '' ;
                $s['sys_unicastSrcIp'] = isset($sys[$id]['sys_unicastSrcIp']) ? $sys[$id]['sys_unicastSrcIp'] : '' ;
                $s['sys_unicastPeerIps'] = isset($sys[$id]['sys_unicastPeerIps']) ? $sys[$id]['sys_unicastPeerIps'] : '' ;

                // compare if $s['unicastPeerIps'] match
                $unipeermatched = false;
                if (($s['unicastPeerIps'] == $s['sys_unicastPeerIps']) && ($s['unicastSrcIp'] == $s['sys_unicastSrcIp'])) {
                    $unipeermatched = true;
                }
                else {
                    $a = preg_split("/[\s,]+/", trim($s['unicastPeerIps']), -1, PREG_SPLIT_NO_EMPTY);
                    $b = preg_split("/[\s,]+/", trim($s['sys_unicastPeerIps']), -1, PREG_SPLIT_NO_EMPTY);
                    if (count($a) == count($b) && $s['unicastSrcIp'] == $s['sys_unicastSrcIp']) {
                        $c = array_intersect($a, $b);
                        if (count($c) == count($b)) {
                            $unipeermatched = true;
                        }
                    }
                }

                if ( ! isset($s['vip']) ) {
                    $conf_status = 'Not in Config File' ;
                    $action = '<a href="javascript:ha_apply(\'d\',\'' . $id . '\');">Delete</a>';
                    /*if ( $s['sys_status'] == 'active' )
                        $action = 'z' ; // Disable
                    else
                        $action = 'd' ; // Delete
                    */
                }
                else {
                    if ( $s['vip'] != $s['sys_vip'] || $s['vipId'] != $s['sys_vipId']
                            || $s['priority'] != $s['sys_priority']
                            || $s['nic'] != $s['sys_nic']
                            || $s['internal_dev'] != $s['sys_internal_dev']
                            || $s['unicastSrcIp'] != $s['sys_unicastSrcIp']
                            || !$unipeermatched
                            ) {
                        $conf_status = 'Not match with System' ;
                        //$action = 'z' ; // Disable
                        $action = '<a href="javascript:ha_apply(\'y\',\'' . $id . '\');">Apply Changes</a>';
                    }
                    else {
                        $conf_status = 'Matched' ;
                        /*
                        if ( $s['sys_status'] == 'active' )
                            $action = 'z' ; // Disable
                        else
                            $action = 'y' ; // Enable/Apply
                         */

                    }
                }
            }
            else {
                $conf_status = 'Newly Configured' ;
                $action = '<a href="javascript:ha_apply(\'a\',\'' . $id . '\');">Add</a>';
            }
            $s['status'] = $conf_status ;
            $s['action'] = $action ;
            $status[$id] = $s ;
        }
        return $status ;
    }

}
