<?php

class DTblReplStatus extends DTbl
{

    public function PrintHtml( &$data, $ref, $disp, $isEdit )
    {
        $this->printViewHtml($data, $ref, $disp) ;
    }

    private function getPrintHeader()
    {
        $buf = '<tr><td class=xtbl_header colspan="4">' ;

        // tooltip
        $table_help = ' ' ;

        $dhelp_item = DATTR_HELP::GetInstance()->GetItem($this->_helpKey) ;
        if ( $dhelp_item != null ) {
            $table_help = '&nbsp;&nbsp;&nbsp;&nbsp' . $dhelp_item->render($this->_helpKey) ;
        }
        $title = $this->_title ;
        $buf .= '<span class="xtbl_title">' . $title . $table_help . '</span>' ;
        $buf .= "</td></tr>\n" ;

        // use defined label later
        $sysClr = 'green';
        $cf = '<br/><span style="font-size:0.9em">Configured</span><br/><span style="color:' . $sysClr . ';font-size:0.9em;font-weight:bold">Live</span></td><td>';
        $buf .= '<tr class="xtbl_title2"><td align="center">Server Address</td><td align="center">Status</td><td>File Cache</td> <td>SSL Session</td><td>ID Session</td> <td>Purge Cache</td></tr>';
        return $buf ;
    }

    private function printViewHtml( &$data, $ref, $disp )
    {
        $buf = '<div><table width="' . $this->_width . '" class="xtbl" border="0" cellpadding="5" cellspacing="1">' . "\n" ;

        $buf .= $this->getPrintHeader() ;

        $sysSpan = '<span style="color:green;font-weight:bold">' ;

        $replstatus = $this->loadReplStatus();
        foreach ( $replstatus as $addr => $d ) {
            $buf .= '<tr class="xtbl_value"><td align="center">';
            if ($d->firstUp == 'Yes')
                $buf .= '<span style="background-color:yellow;margin:5px;padding:5px;font-size:0.9em;font-weight:700" title="Replication Source node">SRC</span> ';
            $buf .= $addr;
            $buf .= '</td><td align="center"><span style="color:' ;
            $buf .= ($d->status == 'in Sync') ? 'green' : 'red';
            $buf .= '">' . $d->status . '</span></td><td>';
            $buf .= $d->session->FileCache . '</td><td>';
            $buf .= $d->session->SslSess . '</td><td>';
            foreach ($d->session->IdSess as $id => $n) {
                    $buf .= $id . ': ' . $n . '<br/>';
            }
            $buf .= '</td><td>';
            foreach ($d->session->PurgeCache as $id => $n) {
                    $buf .= $id . ': ' . $n . '<br/>';
            }
            $buf .= '</td></tr>' . "\n";
        }

        $buf .= '</table></div>' ;
        echo "$buf \n" ;
    }

    private function loadReplStatus()
    {
        $status = [] ;
        $filename = '/tmp/lslbd/.replstatus' ;
        if ($data = file_get_contents('/tmp/lslbd/.replstatus')) {
            $status = json_decode($data);
        }

        return $status ;
    }

}
