<?php

class ZconfStatus
{
	public function getSummary()
	{
		$cmd = 'status:rpt=zconf&type=sum';
		$d = Service::retrieveCommandData($cmd);
        //$d = '{"sum":{"cntSrcActive":2,"cntSrcInactive":0,"cntSslDomains":1584,"cntNonSslDomains":836,"cntUniqueDomains":1625}}';
        $data = json_decode($d, true);
        return $data;
	}

	public function getSources()
	{
		$cmd = 'status:rpt=zconf&type=src';
		$d = Service::retrieveCommandData($cmd);
        //$d = '{"src":{"zero:cpanel-153":{"status":"active"},"zero:cpanel-201":{"status":"active"}}}';
        $data = json_decode($d, true);
        return $data;
	}

    public function getDomains($name, $src, $limit)
	{
        //Query ?rpt=zconf&type=dom&limit=10&src=zero:notexist returned {"dom":[]}
		$cmd = 'status:rpt=zconf&type=dom'; //&limit=500&name=cp153';
        if ($limit !== null && $limit !== '' && $limit != 0) {
            $cmd .= "&limit=$limit";
        }
        if ($name != '') {
            $cmd .= '&name=' . urlencode($name);
        }
        if ($src != '') {
            $cmd .= '&src=' . urlencode($src);
        }
		$d = Service::retrieveCommandData($cmd);
        //$d = '{"dom":["www.dom3cp153.com","mail.dom4cp153.com","mail.dom3cp153.com","mail.dom2cp153.com","cpanel.cp153dom1.com","webmail.dom4cp153.com","webmail.dom3cp153.com","webmail.cp153dom1.com","webmail.dom2cp153.com","www.dom4cp153.com","www.dom2cp153.com"]}';
        $data = json_decode($d, true);
        return $data;
	}

	public function getDomainInfo($domain)
	{
		$cmd = 'status:rpt=zconf&type=dmi&name=' . urlencode($domain);
		$d = Service::retrieveCommandData($cmd);
        //$d = '{"dmi":{"dom2cp153.com":{"backends":"10.10.40.153:443,10.10.40.153:80","ssl_cert":"3E:EF:E3:1C:FC:B7:D3:45:F2:81:D5:18:0A:9C:D5:F6:33:8D:5F:92","ssl_bundle":""}}}';
        $data = json_decode($d, true);
        return $data;
	}


}

