<?php

function getSelectOptions($selType, $selValue)
{
	if ($selType == 'LIMIT')
	{
		$options = array(
			'10'=>'10', '50'=>'50', '100'=>'100', '500' => '500', '1000' => '1000', '0' => 'All');
	}
	return DUtil::genOptions($options, $selValue);
}

$za = DUtil::getGoodVal(DUtil::grab_input("request","za"));
if ($za == null) {
    $za = '5';
}

$zconf = new ZconfStatus();

$cur_time = gmdate("D M j H:i:s T");
$server_info = "snapshot at $cur_time for server {$service->serv['name']}";
$failedtext = '<p class="field_error">Failed to retrieve data!</p>';

$num = 0;

switch($za) {
    case '5s':
        $title = 'Feed Sources';
        $data = $zconf->getSources();
        $activesrc = '';
        $activenum = 0;
        $inactivesrc = '';
        $inactivenum = 0;
        if ($data == null) {
            $activesrc = $inactivesrc = $failedtext;
        } elseif (isset($data['src'])) {
            foreach ($data['src'] as $n => $d) {
                if ($d['status'] == 'active') {
                    $activenum ++ ; // rpt=zconf&type=dom&limit=10&src=zero:notexist
                    $activesrc .= '<a href="#" onclick="zconfGo(\'5d\',\'' . $n . '\')" title="click to see all domains from this source">' . $n . '</a> &nbsp;&nbsp ';
                } else {
                    $inactivenum ++;
                    $inactivesrc .= $n . ' &nbsp;&nbsp ';
                }
            }
        }
        break;
    case '5d':
        $title = 'Registered Domain List';
        $src = DUtil::getGoodVal(DUtil::grab_input('request','srcname','string'));
        $domain = DUtil::getGoodVal(DUtil::grab_input('request',"domain_filter",'string'));
        $limit = DUtil::getGoodVal(DUtil::grab_input('request','dm_limit','string'));
        if ($limit === null) {
            $limit = '10';
        }
        $data = $zconf->getDomains($domain, $src, $limit);
        $domains  = '';
        if ($data == null) {
            $domains = $failedtext;
        } elseif (isset($data['dom'])) {
            $num = count($data['dom']);
            if ($num > 0 && $num == $limit) {
                $num .= " (limit $limit)";
            }
            // rpt=zconf&type=dmi&name=
            foreach ($data['dom'] as $dom) {
                $domains .= '<a href="#" onclick="zconfGo(\'5i\',\'' . $dom . '\')" title="click to see the detailed info for this domain">' . $dom . '</a> &nbsp;&nbsp ';
            }
        }
        break;
    case '5i':
        $title = 'Domain Details';
        $domain = DUtil::getGoodVal(DUtil::grab_input("request","domain","string"));
        $data = $zconf->getDomainInfo($domain);
        $backends = '';
        $ssl_cert = '';
        $ssl_bundle = '';
        if ($data == null) {
            $th = $failedtext;
        } elseif (empty($data['dmi'][$domain]) || $data['dmi'][$domain]['backends'] == '') {
            $th = 'Nothing found!';
        } else {
            $th = 'Details for ' . $domain;
            $d = $data['dmi'][$domain];
            $backends = $d['backends'];
            $ssl_cert = $d['ssl_cert'];
            $ssl_bundle = $d['ssl_bundle'];
        }
        break;
    case '5':
    default:
        $za = '5';
        $title = 'Status Summary';
        $data = $zconf->getSummary();
}

?>
<form name="zconfform" method="post"><input type="hidden" name="vl" value="5"><input type="hidden" name="za" value="<?php echo $za; ?>">
<script>
    function zconfGo(act, f) {
        if (act == '5d' && document.zconfform.za.value == '5s' && f != '') {
            document.zconfform.srcname.value = f;
        }
        if (act == '5i'&& f != '') {
            document.zconfform.domain.value = f;
        }
        document.zconfform.za.value = act;
        document.zconfform.submit();
    }
    function dsearch(ele, act) {
        if (event.keyCode === 13) {
            zconfGo(act, '');
        }
    }
    function dmfClear() {
        document.zconfform.domain_filter.value = '';
        document.zconfform.srcname.value = '';
    }
</script>

<div class="bottom_bar">
    <span  class="h2_font"><a href="serviceMgr.php?vl=5" title="ZeroConf Status Summary">ZeroConfig</a> - <?php echo $title; ?></span> <?php echo $server_info;?>
<span style="float:right"><input name="refresh" value="Refresh" type="submit"></span>
</div>
<?php if ($za == '5') { ?>
<div style="margin-top:20px;">
	<div style="width:450px;display:inline-block;vertical-align:top;margin-right:20px;">
		<table class="xtbl" width="100%" border="0" cellpadding="3" cellspacing="1">
			<tr>
                <td class="xtbl_title" colspan="2">Feed Sources &nbsp;&nbsp;&nbsp;<a href="#" onclick="zconfGo('5s','')">Details</a></td>
			</tr>
			<tr><td class="xtbl_label_vert">Active Sources</td><td class="xtbl_value" align="right">
                    <?php if ($data != null) { echo $data['sum']['cntSrcActive']; } ?>
			</td></tr>
			<tr><td class="xtbl_label_vert">Inactive Sources</td><td class="xtbl_value" align="right">
                    <?php if ($data != null) { echo $data['sum']['cntSrcInactive']; } ?>
			</td></tr>
	</table>
        <?php if ($data == null) { echo $failedtext; } ?>
    </div>
	<div style="width:450px;display:inline-block;">
		<table class="xtbl" width="100%" border="0" cellpadding="3" cellspacing="1">
			<tr>
				<td class="xtbl_title" colspan="2">Registered Domains &nbsp;&nbsp;&nbsp;<a href="#" onclick="zconfGo('5d','')">Details</a></td>
			</tr>
			<tr><td class="xtbl_label_vert">SSL Domains</td><td class="xtbl_value" align="right">
                    <?php if ($data != null) { echo $data['sum']['cntSslDomains']; } ?>
			</td></tr>
			<tr><td class="xtbl_label_vert">Non-SSL Domains</td><td class="xtbl_value" align="right">
                    <?php if ($data != null) { echo $data['sum']['cntNonSslDomains']; } ?>
			</td></tr>
			<tr><td class="xtbl_label_vert">Unique Domains</td><td class="xtbl_value" align="right">
                    <?php if ($data != null) { echo $data['sum']['cntUniqueDomains']; } ?>
			</td></tr>
            <tr class="xtbl_label">
                <td colspan="2"><b>Search:</b> (allow partial match) <span style="float:right">Limit: <select class="th-clr" name="dm_limit">'
		 <?php echo getSelectOptions('LIMIT', '10')?>
                        </select></span></td>
			</tr>
			<tr class="xtbl_value"><td colspan="2"><input type="text" onkeydown="dsearch(this, '5d')" name="domain_filter" size="50">
                   &nbsp;&nbsp;&nbsp;<input name="search" value="Search" onclick="zconfGo('5d','')" type="button"/>
			</td></tr>
	</table></div>
</div>
    <div class="stat_filter">
        <div><b>Check Domain Detail: </b> (require exact match)
            <div>Domain Name: <input type="text" onkeydown="dsearch(this, '5i')" name="domain" size="60">&nbsp;&nbsp;&nbsp;
                <input name="check" value="Check" onclick="zconfGo('5i','')" type="button"/>
            </div></div></div>

<?php } elseif ($za == '5s') { ?>
    <div><b>Active Sources</b> (count = <?php echo $activenum; ?>)</div><input type="hidden" name="srcname"/>
    <div style="margin-top:10px;"><?php echo $activesrc ?></div>
    <div style="margin-top:20px;"><b>Inactive Sources</b> (count = <?php echo $inactivenum; ?>)</div>
    <div style="margin-top:10px;"><?php echo $inactivesrc ?></div>

<?php } elseif ($za == '5d') { ?>
    <div class="stat_filter">
        <div><b>Search Domains</b><div style="float:right">
                <input name="check" value="Search" type="submit"/> &nbsp;&nbsp;&nbsp;
                <input name="clear" value="Clear" onclick="dmfClear()" type="button"/>&nbsp;&nbsp;&nbsp;
                Limit: <select class="th-clr" name="dm_limit"><?php echo getSelectOptions('LIMIT', $limit)?></select>
            </div></div><input type="hidden" name="domain"/>
            <div>Domain Name (allow partial match): <input type="text" name="domain_filter" value="<?php echo $domain; ?>" size="50">&nbsp;&nbsp;&nbsp;
        </div><div>Source Name (require exact match): <input type="text" value="<?php echo $src; ?>" name="srcname" size="50">&nbsp;&nbsp;&nbsp;
            </div>
    </div>
    <div style="margin:15px 0 10px;">Found <?php echo $num; ?></div>
    <div><?php echo $domains; ?></div>
<?php } elseif ($za == '5i') { ?>
    <div class="stat_filter">
        <div><b>Check Domain Detail</b>
            <div>Domain Name (require exact match): <input type="text" name="domain" value="<?php echo $domain; ?>" size="60">&nbsp;&nbsp;&nbsp;<input name="check" value="Check" type="submit"/>
            </div></div></div>
    <div style="margin-top:20px;">
		<table class="xtbl" width="100%" border="0" cellpadding="3" cellspacing="1">
			<tr>
                <td class="xtbl_title" colspan="2"><?php echo $th; ?></td>
			</tr>
			<tr><td class="xtbl_label_vert">Backends</td><td class="xtbl_value">
                    <?php echo $backends; ?>
			</td></tr>
			<tr><td class="xtbl_label_vert">SSL Certificate</td><td class="xtbl_value">
                    <?php echo $ssl_cert; ?>
			</td></tr>
			<tr><td class="xtbl_label_vert">SSL Bundle</td><td class="xtbl_value">
                    <?php echo $ssl_bundle; ?>
			</td></tr>
	</table></div>

<?php } ?>
</form>
