

CURDIR=`dirname "$0"`
cd $CURDIR
CURDIR=`pwd`
LSLBHOME=`dirname $CURDIR`
LSLBHOME=`dirname $LSLBHOME`

CURTIME=`date "+[%Y-%m-%d %k:%M:%S]"`

test_license()
{
	if [ -f "$LSLBHOME/conf/license.key" ] && [ ! -f "./license.key" ]; then
		cp "$LSLBHOME/conf/license.key" "./license.key"
	fi
	if [ -f "$LSLBHOME/conf/serial.no" ] && [ ! -f "./serial.no" ]; then
		cp "$LSLBHOME/conf/serial.no" "./serial.no"
	fi
	if [ -f "$LSLBHOME/conf/trial.key" ] && [ ! -f "./trial.key" ]; then
		cp "$LSLBHOME/conf/trial.key" "./trial.key"
	fi
	if [ -f "./license.key" ] && [ -f "./serial.no" ]; then
		output=`bin/lslbd -t`
        if [ $? -ne 0 ]; then
            echo $output >> $LOGFILE
	        echo "[ERROR] License key verification failed" >> $LOGFILE
	        exit 1
        fi
	fi
}




if [ "x$2" = "x" ]; then
	
	cat <<EOF
Usage: update.sh VERSION PLATFORM
  Upgrade to another version of LiteSpeed Load Balancer. the package file must 
  exist under $LSLBHOME/autoupdate/
  Package file should be lslb-VERSION-PLATFORM.tar.gz

EOF
	exit 1
fi

LOGFILE=$LSLBHOME/autoupdate/update.log
cd $LSLBHOME/autoupdate/

echo "$CURTIME Extracting package file" >> $LOGFILE

PACKAGEFILE=$LSLBHOME/autoupdate/lslb-$1-$2.tar.gz
if [ -f $PACKAGEFILE ]; then
	gunzip -c $PACKAGEFILE | tar xf -
else
	echo "$CURTIME [ERROR] Package file $PACKAGEFILE does not exist." >> $LOGFILE
	exit 1
fi

cd $LSLBHOME/autoupdate/lslb-$1
if [ $? -ne 0 ]; then
	echo "$CURTIME [ERROR] Failed to change current directory to $LSLBHOME/autoupdate/lslb-$1" >> $LOGFILE
	exit 1
fi

if [ "x$3" = "xdebug" ]; then
    cp bin/lslbd.dbg bin/lslbd
fi

. ./functions.sh
if [ $? != 0 ]; then
    echo "$CURTIME [ERROR] Can not include 'functions.sh'." >> $LOGFILE
    exit 1
fi

init
LSLB_HOME=$LSLBHOME
INTSTALL_TYPE="upgrade"
readCurrentConfig
test_license
installation
echo "$CURTIME Upgrade to $1 successfully." >> $LOGFILE

rm -rf $LSLBHOME/autoupdate/lslb-$1
rm -f $PACKAGEFILE

exit 0

