<?php 
$this->db['CACertFile'] = new DATTR_HELP_ITEM("CA Certificate File", 'Specifies the file that contains all certificates of certification authorities (CAs) for chained certificates. This file is simply the concatenation of PEM-encoded certificate files, in order of preference. This can be used as an alternative or in addition to &quot;CA Certificate Path&quot;. Those certificates are used for client certificate authentication and constructing the server certificate chain, which will be sent to browsers in addition to the server certificate.', '', 'Filename which can be an absolute path or a relative path to $SERVER_ROOT.', '');
$this->db['CACertPath'] = new DATTR_HELP_ITEM("CA Certificate Path", 'Specifies the directory where the certificates of certification authorities (CAs) are kept. Those certificates are used for client certificate authentication and constructing the server certificate chain, which will be sent to browsers in addition to the server certificate.', '', 'path', '');
$this->db['ClusterErrMsg'] = new DATTR_HELP_ITEM("Custom Error Messages", 'Specify a custom error message in case error occured during distributing request to backend servers. Custom error messages configured at virtual host level will override this configuration.', '', '', '');
$this->db['DHParam'] = new DATTR_HELP_ITEM("DH Parameter", 'Specifies the location of the Diffie-Hellman parameter file necessary for DH key exchange.', '', 'Filename which can be an absolute path or a relative path to $SERVER_ROOT.', '');
$this->db['GroupDBLocation'] = new DATTR_HELP_ITEM("Group DB Location", 'Specifies the location of the group database.<br/><br/>Group information can be set either in the user database or in this standalone group DB. For user authentication, the user DB will be checked first. If the user DB also contains group information, then the group DB will not be checked.<br/><br/>For the DB type Password File, the group DB location should be the path to the flat file containing group definitions. You can edit this file through the WebAdmin console by clicking on the filename.<br/><br/>Each line of a group file should contain a groupname followed by a colon, followed by space delimited group of usernames. Example:<br/><blockquote><code>testgroup: user1 user2 user3</code></blockquote><br/><br/>For the DB type LDAP, the group DB location should be the LDAP URL to query for group information. For each valid group, one and only one record should be returned in the LDAP search request based on this URL and the group name specified in &quot;Require (Authorized Users/Groups)&quot;. &quot;$k&quot; must be specified in the filter part of the URL and it will be replaced with the group name. The name of the attribute that specifies members in this group is specified by the &quot;Group Member Attribute&quot;.<br/><br/>Example: If objectClass posixGroup is being used to store group information. The following URL could be used:<br/><blockquote><code>ldap://localhost/ou=GroupDB,dc=example,dc=com???(&(objectClass=*)(cn=$k))</code></blockquote>', ' It is recommended to store a group file outside the document tree. If it has to be placed inside document tree, simply name it with a leading &quot;.ht&quot; like .htgroup, to prevent the file being served as a static file. LiteSpeed Web Server does not serve files prefixed with &quot;.ht&quot;.', 'Filename which can be an absolute path or a relative path to $SERVER_ROOT, $VH_ROOT.', '');
$this->db['HAInterface'] = new DATTR_HELP_ITEM("HA Virtual Interface Configuration", 'Additions/Deletions/Changes made will not take effect until applied through HA -> Status page.', '', '', '');
$this->db['HAStatus'] = new DATTR_HELP_ITEM("HA Status", 'Displays the configuration and status of currently configured/live high availability interfaces by their unique <b>Interface ID</b>. The current configured settings for each interface are shown as well as the actual &quot;live&quot; settings in green. The &quot;Status&quot; field will contain 1-2 of the following values:<br/><ul>   <li>     <b>Newly Configured:</b> The interface is configured but has not yet been created. Click &quot;Add&quot; to create this interface.   </li>   <li>     <b>Not in Config File:</b> There is currently no interface configuration with a matching <b>Interface ID</b> for this     interface. You can click &quot;Delete&quot; to delete this interface.   </li>   <li>     <b>Matched:</b> The current configuration settings for this <b>Interface ID</b> match the configuration settings of the     corresponding live interface.   </li>   <li>     <b>Not match with System:</b> The current configuration settings for this <b>Interface ID</b> do not match the     configuration settings of the corresponding live interface. Click &quot;Apply Changes&quot; to overwrite the live settings with the     configured settings.   </li>   <li><b>master:</b> Indicates that this interface has the role of master.</li>   <li><b>standby:</b> Indicates that this interface has the role of slave.</li> </ul>', 'Configuration changes made to a high availability interface in the config section will not be applied until clicking &quot;Apply Changes&quot; next to the affected interface. The same applies to adding new interfaces and deleting existing interfaces, changes will not be applied until clicking &quot;Add/Delete&quot; respectively.', '', '');
$this->db['LDAPBindDN'] = new DATTR_HELP_ITEM("LDAP Bind DN", 'Specifies a DN used to bind to the server. If the LDAP server requires authentication, a bind DN and password must be specified. If not specified, anonymous bind will be used.', '', 'string', '');
$this->db['LDAPBindPasswd'] = new DATTR_HELP_ITEM("LDAP Bind Password", 'Specifies a password used to bind to the server. If the LDAP Server requires authentication, a bind DN and password must be specified.', '', 'string', '');
$this->db['UDBgroup'] = new DATTR_HELP_ITEM("Groups", 'A comma seperated list of groups that this user belongs to. The user will only be able to access resources belonging to these groups.<br/><br/>If group information is added here, this information will be used for resource authorization and any group database settings involving this user will be ignored.', '', '', '');
$this->db['UDBpass'] = new DATTR_HELP_ITEM("New Password", 'Password can be any length and contain any characters.', '', '', '');
$this->db['UDBpass1'] = new DATTR_HELP_ITEM("Retype Password", 'Password can be any length and contain any characters.', '', '', '');
$this->db['UDBusername'] = new DATTR_HELP_ITEM("User Name", 'A user name containing only letters and numbers. (no special characters)', '', '', '');
$this->db['VHlsrecaptcha'] = new DATTR_HELP_ITEM("reCAPTCHA Protection", 'reCAPTCHA Protection is a service provided as a way to mitigate heavy server load. reCAPTCHA Protection will activate after one of the below situations is hit. Once active, all requests by NON TRUSTED(as configured) clients will be redirected to a reCAPTCHA validation page. After validation, the client will be redirected to their desired page.<br/><br/>The following situations will activate reCAPTCHA Protection:<br/>1. The server or vhost concurrent requests count passes the configured connection limit.<br/>2. Anti-DDoS is enabled and a client is hitting a url in a suspicious manner. The client will redirect to reCAPTCHA first instead of getting denied when triggered.<br/>3. WordPress Brute Force Attack Protection is enabled and action is set to &#039;CAPTCHA or Drop’. When a brute force attack is detected, the client will redirect to reCAPTCHA first. After max tries is reached, the connection will be dropped, as per the ‘drop’ option.<br/>4. WordPress Brute Force Attack Protection is enabled and action is set to &#039;WP Login CAPTCHA Full Protection&#039;. The client will always redirect to reCAPTCHA first.<br/>5. A new rewrite rule environment is provided to activate reCAPTCHA via RewriteRules. &#039;verifycaptcha&#039; can be set to redirect clients to reCAPTCHA. A special value &#039;: deny&#039; can be set to deny the client if it failed too many times. For example, [E=verifycaptcha] will always redirect to reCAPTCHA until verified. [E=verifycaptcha: deny] will redirect to reCAPTCHA until Max Tries is hit, after which the client will be denied.', '', '', '');
$this->db['accessAllowed'] = new DATTR_HELP_ITEM("Access Allowed", 'Specifies which IPs or sub-networks are allowed to access resources under this context. Together with &quot;Access Denied&quot; and server/virtual host level access control, accessibility is determined by the smallest scope that a client&#039;s IP address falls into.', '', 'Comma-delimited list of IPs/sub-networks.', 'Sub-networks can be written as 192.168.1.0/255.255.255.0, 192.168.1, or 192.168.1.*.');
$this->db['accessControl'] = new DATTR_HELP_ITEM("Access Control", 'Specifies what sub networks and/or IP addresses can access the server. At the server level, this setting will affect all virtual hosts. You can also set up access control unique to each virtual host at the virtual host level. Virtual host level settings will NOT override server level settings.<br/><br/>Blocking/Allowing an IP is determined by the combination of the allowed list and the denied list. If you want to block only certain IPs or sub-networks, put * or ALL in the &quot;Allowed List&quot; and list the blocked IPs or sub-networks in the &quot;Denied List&quot;. If you want to allow only certain IPs or sub-networks, put * or ALL in the &quot;Denied List&quot; and list the allowed IPs or sub-networks in the &quot;Allowed List&quot;. The setting of the smallest scope that fits for an IP will be used to determine access.<br/><br/><b>Server Level:</b> Trusted IPs or sub-networks must be specified in the &quot;Allowed List&quot; by adding a trailing &quot;T&quot;. Trusted IPs or sub-networks are not affected by connection/throttling limits. Only server level access control can set up trusted IPs/sub-networks.', ' Use this at the server level for general restrictions that apply to all virtual hosts.', '', '');
$this->db['accessControl_allow'] = new DATTR_HELP_ITEM("Allowed List", 'Specifies the list of IPs or sub-networks allowed. * or ALL are accepted.', ' Trusted IPs or sub-networks set at the server level access control will be excluded from connection/throttling limits.', 'Comma delimited list of IP addresses or sub-networks. A trailing &quot;T&quot; can be used to indicate a trusted IP or sub-network, such as 192.168.1.*T.', '<b>Sub-networks:</b> 192.168.1.0/255.255.255.0, 192.168.1.0/24, 192.168.1, or 192.168.1.*<br/><b>IPv6 addresses:</b> ::1 or [::1]<br/><b>IPv6 subnets:</b> 3ffe:302:11:2:20f:1fff:fe29:717c/64 or [3ffe:302:11:2:20f:1fff:fe29:717c]/64');
$this->db['accessControl_deny'] = new DATTR_HELP_ITEM("Denied List", 'Specifies the list of IPs or sub-networks disallowed.', '', 'Comma delimited list of IP addresses or sub-networks. * or ALL are accepted.', '<b>Sub-networks:</b> 192.168.1.0/255.255.255.0, 192.168.1.0/24, 192.168.1, or 192.168.1.*<br/><b>IPv6 addresses:</b> ::1 or [::1]<br/><b>IPv6 subnets:</b> 3ffe:302:11:2:20f:1fff:fe29:717c/64 or [3ffe:302:11:2:20f:1fff:fe29:717c]/64');
$this->db['accessDenied'] = new DATTR_HELP_ITEM("Access Denied", 'Specifies which IPs or sub-networks are NOT allowed to access resources under this context. Together with &quot;Access Allowed&quot; and server/virtual host-level access control, accessibility is determined by the smallest scope that a client&#039;s IP address falls into.', '', 'Comma-delimited list of IPs/sub-networks.', 'Sub-networks can be written as 192.168.1.0/255.255.255.0, 192.168.1, or 192.168.1.*.');
$this->db['accessLog_bytesLog'] = new DATTR_HELP_ITEM("Bytes Log", 'Specifies the path to the bandwidth bytes log file. When specified, a cPanel compatible bandwidth log will be created. This will log  the total bytes transferred for a request including both the request and reply bodies.', ' Put the log file on a separate disk.', 'Filename which can be an absolute path or a relative path to $SERVER_ROOT.', '');
$this->db['accessLog_fileName'] = new DATTR_HELP_ITEM("File Name", 'The access log filename.', ' Put access log file on a separate disk.', 'Filename which can be an absolute path or a relative path to $SERVER_ROOT.', '');
$this->db['accessLog_logFormat'] = new DATTR_HELP_ITEM("Log Format", ' Specifies the log format for the access log. When log format is set, it will override the &quot;Log Headers&quot; setting.', '', 'String. The syntax of log format is compatible with Apache 2.0&#039;s custom  <a href="http://httpd.apache.org/docs/current/mod/mod_log_config.html#formats" target="_blank" rel="noopener noreferrer">log format</a>.', '<b>Common Log Format (CLF)</b><br/>    &quot;%h %l %u %t \&quot;%r\&quot; %>s %b&quot;<br/><br/><b>Common Log Format with Virtual Host</b><br/>    &quot;%v %h %l %u %t \&quot;%r\&quot; %>s %b&quot;<br/><br/><b>NCSA extended/combined log format</b><br/>    &quot;%h %l %u %t \&quot;%r\&quot; %>s %b \&quot;%{Referer}i\&quot; \&quot;%{User-agent}i\&quot; <br/><br/><b>Log cookie value of Foobar</b><br/>    &quot;%{Foobar}C&quot;');
$this->db['accessLog_logHeader'] = new DATTR_HELP_ITEM("Log Headers", 'Specifies whether to log HTTP request headers: Referer, UserAgent, and Host.', ' Turn this off if you do not need these headers in the access log.', 'Select from checkbox', '');
$this->db['accessLog_pipedLogger'] = new DATTR_HELP_ITEM("Piped Logger", 'Specifies an external application that will receive the access log data sent by LiteSpeed through a pipe on its STDIN stream (file handle 0). When specified, the access log will be sent to the logger application instead of the access log file specified in previous entry.<br/><br/>LiteSpeed load balancer  performs simple load balancing among multiple logger applications if more than one instance of a logger application is configured.  LiteSpeed Web Server always attempts to keep the number of logger processes as low as possible. Only when  one logger application fails to process access log entries in time  will the server attempt to spawn another logger application instance.<br/><br/>If a logger process crashes, the server will start another instance but the log data in the stream buffer will be lost. It is possible to lose log data if external loggers cannot keep up   with the speed and volume of the log stream.<br/>File path to the logger application should be given here, and optionally, the number of application instances can be set before the file path, followed by &#039;|&#039;.', '', '[&lt;intances&gt;|]&lt;path_to_logger_app&gt;', '4|/path/to/logger/app <br/>tells the server to start up to 4 logger processes.<br/><br/>/path/to/logger/app<br/>tells the server to start only one logger process.');
$this->db['aclogUseServer'] = new DATTR_HELP_ITEM("Log Control", 'Where the access log should be written. There are three options:  <ol> <li>Write to the server&#039;s access log</li> <li>Create an access log for this virtual host</li> <li>Disable access logging</li> </ol>', '', 'Select from drop down list', '');
$this->db['addDefaultCharset'] = new DATTR_HELP_ITEM("Add Default Charset", 'Specifies whether to add a character set tag to the 	   &quot;Content-Type&quot; response header, when content type is either 	   &quot;text/html&quot; or &quot;text/plain&quot; without any parameters. 	   When set to Off,  this function is disabled. When set to 	   On, either the character set specified by 	   &quot;Customized Default Charset&quot; or the default &quot;iso-8859-1&quot; will be added.', '', 'Select from radio box', '');
$this->db['adminEmails'] = new DATTR_HELP_ITEM("Administrator Email", 'Specifies the server administrator&#039;s email address(es). If specified, administrators will be notified by email of important events (for example, when the LiteSpeed service is restarted automatically due to crash detection or when license is expiring).', 'Email alert feature will only work if the server has an active MX server such as postfix, exim, or sendmail.', 'Comma delimited list of email address.', '');
$this->db['adminUser'] = new DATTR_HELP_ITEM("WebAdmin User", 'Change the username and password for the WebAdmin Console.  The old password must be entered and verified in order to save changes.', '', '', '');
$this->db['allowQuic'] = new DATTR_HELP_ITEM("Open HTTP3/QUIC (UDP) port", 'Allows the use of the HTTP3/QUIC network protocol for virtual hosts mapped to this listener. For this setting to take effect, &quot;Enable HTTP3/QUIC&quot; must also be set to Yes at the server level. Default value is Yes.', 'When this setting is set to Yes, HTTP3/QUIC can still be disabled at the virtual host level through the &quot;Enable HTTP3/QUIC&quot; setting.', '', '');
$this->db['antiddos_blocked_ip'] = new DATTR_HELP_ITEM("Anti-DDoS Blocked IP", 'A comma-separated list of IP addresses blocked by Anti-DDoS protection, each ending with a semi-colon and reason code indicating why the IP address was blocked.<br/><br/>Potential Reason Codes: <ul>   <li>A: BOT_UNKNOWN</li>   <li>B: BOT_OVER_SOFT</li>   <li>C: BOT_OVER_HARD</li>   <li>D: BOT_TOO_MANY_BAD_REQ</li>   <li>E: BOT_TOO_MANY_DOS_URL</li>   <li>F: BOT_CAPTCHA</li>   <li>G: BOT_FLOOD</li>   <li>H: BOT_REWRITE_RULE</li>   <li>I: BOT_TOO_MANY_BAD_STATUS</li>   <li>J: BOT_WAF_DETECTED</li>   <li>K: BOT_BRUTE_FORCE</li> </ul><br/><br/>The full list of blocked IPs is also available in the Real-Time Stats report file /tmp/lshttpd/.rtreport.', '', '&lt;blocked_ip_address&gt;;&lt;reason_code&gt;', '1.0.100.50;E, 1.0.100.60;D, 1.0.100.70;F');
$this->db['authName'] = new DATTR_HELP_ITEM("Authentication Name", 'Specifies an alternative name for the authorization realm for the current context. If not specified, the original realm name will be used. The authentication name is displayed on the browser&#039;s login pop-up.', '', '', '');
$this->db['autoUpdateDownloadPkg'] = new DATTR_HELP_ITEM("Download Updates", 'Specifies whether to auto-download a new product release package file when available. If a new package has been successfully downloaded, an online one-click upgrade can be performed via the WebAdmin console under Service Manager - &quot;Version Management&quot;.', '', 'Select from drop down list', '');
$this->db['autoUpdateInterval'] = new DATTR_HELP_ITEM("Check For Update", 'Specifies how often the update agent will check for a new product release. Options are &quot;Daily&quot;, &quot;Weekly&quot;, &quot;Monthly&quot; and &quot;Disable&quot;.', '', 'Select from drop down list', '');
$this->db['banPeriod'] = new DATTR_HELP_ITEM("Banned Period (sec)", 'Specifies how long new connections will be rejected from an IP if, after the &quot;Grace Period (sec)&quot; has elapsed, the number of connections is still more than the &quot;Connection Soft Limit&quot;. If IPs are getting banned repeatedly, we suggest that you increase your banned period to stiffen the penalty for abuse.', '', 'Integer number', '');
$this->db['bindIPv6Only'] = new DATTR_HELP_ITEM("Bind IPv6 Only", 'Only bind IPv6 for IPv6 wildcard IP addresses. When set to &quot;Yes&quot;, IPv4 IP addresses will not be bound and will need their own listeners.<br/><br/>Default value: Yes', '', 'Select from radio box', '');
$this->db['blockBadReq'] = new DATTR_HELP_ITEM("Block Bad Request", 'Block IPs that keep sending badly-formated HTTP requests for the &quot;Banned Period (sec)&quot;. Default is Yes. This helps to block botnet attacks that repeatedly sending junk requests.', '', 'Select from radio box', '');
$this->db['cacheMgrStorePath'] = new DATTR_HELP_ITEM("Cache Manager Path", 'Specifies the directory used to store cache manager files. These files are stored in <b>Storage Path</b> by default.', ' A separate location on a fast disk is recommended to prevent the accidental removal of cache manager files. Only set to a location on a RAM disk if cache storage is also saved on a RAM disk.', 'path', '');
$this->db['cachePolicy:cacheKeyMod'] = new DATTR_HELP_ITEM("Cache Key Modifications", 'Makes some requests more cache-friendly by allowing junk query string parameters to be dropped from URLs.', '', 'clear discards all previous configurations, -qs:[string] drop all query strings where the name matches [string] exactly, or -qs:utm* drop all query strings where the name part starts with [string]. Input one rule per line.', '-qs:utm* drops all query strings where the name part starts with &quot;utm&quot;.<br/>-qs:gclid drops all query strings where the name matches &quot;gclid&quot; exactly.');
$this->db['cachePolicy:cacheStaticFile'] = new DATTR_HELP_ITEM("Cache Static Files", 'Cache the static file types selected for the amount of time set in &quot;Cache Expire Time (seconds)&quot;.<br/><br/>Default value: All unchecked', '', 'Select from checkbox', '');
$this->db['cachePolicy:cacheStaticVary'] = new DATTR_HELP_ITEM("Vary for Static Files", 'Allow cache vary for static files.<br/><br/>Default value: No', ' Turn this option on when you need to cache different copies of a static file based on provided vary values.', 'Select from radio box', '');
$this->db['cachePolicy:enableCache'] = new DATTR_HELP_ITEM("Publicly Cache All", 'Publicly cache all URLs served under the current context (virtual host, or context level).<br/><br/>Virtual hosts configured through Apache&#039;s httpd.conf can use the &quot;CacheEnable&quot; and &quot;CacheDisable&quot; directives at the server, virtual host, context, file, and location level or in .htaccess. &quot;CacheEnable&quot; and &quot;CacheDisable&quot; directives are compatible with Apache mod_cache directives. However, when used at the context, file, or location level, or in .htaccess, &quot;CacheEnable&quot; and &quot;CacheDisable&quot; will only be applied to directories below the current level. URL parameters will be ignored.', 'Disabled by default. Do not enabled this setting if you are using any LSCache plugins.', 'Select from radio box', '');
$this->db['cachePolicy:enablePostCache'] = new DATTR_HELP_ITEM("Enable POST cache", 'Specifies if POST requests can be cached using the &quot;x-litespeed-cache-control&quot; header.<br/><br/>Default value: No', '', 'Select from radio box', '');
$this->db['cachePolicy:enablePrivateCache'] = new DATTR_HELP_ITEM("Privately Cache All", 'Privately cache all URLs served under the current context (virtual host, or context level).<br/><br/>A separate cached copy will be made per user based on their IP and set cookies.<br/><br/>Virtual hosts configured through Apache&#039;s httpd.conf can use the &quot;CacheEnable private /url&quot; and &quot;CacheDisable private /url&quot; directives at server, virtual host, directory, file, and location levels or in a .htaccess file. &quot;CacheEnable private&quot; and &quot;CacheDisable private&quot; are compatible with Apache&#039;s mod_cache directives and will be applied to all directories below the current level. However, when used at the directory, file, or location level, or in a .htaccess file, &quot;CacheEnable private&quot; and &quot;CacheDisable private&quot; will only be applied to directories below the current level. URL parameters will be ignored.', 'Disabled by default. Do not enabled this setting if you are using any LSCache plugins.', 'Select from radio box', '');
$this->db['cachePolicy:expireInSeconds'] = new DATTR_HELP_ITEM("Cache Expire Time (seconds)", 'Specifies how long an object will be cached. The default is &quot;86400&quot; seconds (one day).', '', 'Integer number', '');
$this->db['cachePolicy:maxCacheObjSize'] = new DATTR_HELP_ITEM("Max Object Size", 'Specifies the maximum size of an object, up to 100M, that can be stored in the cache directory.<br/><br/>Default value: 10M', '', 'Integer number', '');
$this->db['cachePolicy:maxStaleAge'] = new DATTR_HELP_ITEM("Cache Stale Age (seconds)", 'Specifies how long an object will continue to be served from cache after it has expired but before a new cached copy is available. The default is &quot;10&quot; seconds.', '', 'Integer number', '');
$this->db['cachePolicy:microCache5xx'] = new DATTR_HELP_ITEM("Micro Cache 5XX Response", 'Cache pages responding with HTTP status code 5xx (500, 503, etc) for 10 seconds when the cache response header indicates that the page is cacheable.<br/><br/>Default values:<br/><b>Server level:</b> Yes<br/><b>VH level:</b> Inherit Server level setting<br/><b>Context-level</b> Inherit VH level setting', ' Enabling this setting is useful for avoiding bad requests but can also act as some added DDoS protection.', 'Select from radio box', '');
$this->db['cachePolicy:privateExpireInSeconds'] = new DATTR_HELP_ITEM("Private Cache Expire Time (seconds)", 'Specifies how long an object will be cached in private cache. The default is &quot;60&quot; seconds.', '', 'Integer number', '');
$this->db['cacheStorePath'] = new DATTR_HELP_ITEM("Storage Path", 'Specifies the directory for holding cached objects. Currently, LiteSpeed Cache stores each object in its own file. The filename is a hash of the object key. Multiple levels of directories will be created in order to avoid holding too many files in one directory. This value must be set at the Server level in order to enable cache. Virtual Host level settings will override Server level settings.', ' Assign a dedicated disk or disk array as the cache storage. RAID0 is recommended.<br/><br/>It is recommended to set a different cache storage path for each Virtual Host to prevent purge all requests from affecting other Virtual Hosts.', 'path', '');
$this->db['censorLogLevel'] = new DATTR_HELP_ITEM("Log Level", 'Specifies the level of detail of the Web Application Firewall engine&#039;s debug output. This value ranges from 0 - 9. 0 disables logging. 9 produces the most detailed log. The the server and virtual host&#039;s error log &quot;Log Level&quot; must be set to at least INFO for this option to take effect. This is useful when testing request filtering rules.', '', 'Integer number', '');
$this->db['censorRuleSet'] = new DATTR_HELP_ITEM("Rules Definition", 'Specifies a list of censorship rules.', 'Rules configured here only work for vhosts configured in native LSWS configuration, not for vhosts from Apache httpd.conf.', 'String. Syntax of censoring rules follows that of Apache&#039;s mod_security directives. &quot;SecFilter&quot;, &quot;SecFilterSelective&quot;, and &quot;SecRule&quot; can be  used here.  You can copy and paste security rules from an Apache configuration file.<br/><br/>For more details about rule syntax, please refer to the  <a href="http://www.modsecurity.org/documentation/index.html" target="_blank" rel="noopener noreferrer">Mod Security documentation</a>.', '');
$this->db['censorRuleSetEnabled'] = new DATTR_HELP_ITEM("Enabled", 'Specifies whether to enable this rule set. With this option, a rule set can be quickly turned on and off without adding or removing the rule set. Default is &quot;Yes&quot;.', '', 'Select from radio box', '');
$this->db['censorRuleSetName'] = new DATTR_HELP_ITEM("Name", 'Give a group of censorship rules a name. For display only.', '', 'String', '');
$this->db['certChain'] = new DATTR_HELP_ITEM("Chained Certificate", 'Specifies whether the certificate is a chained certificate or not. The file that stores a certificate chain must be in PEM format, and the certificates must be in the chained order, from the lowest level (the actual client or server certificate) to the highest level (root) CA.', '', 'Select from radio box', '');
$this->db['certFile'] = new DATTR_HELP_ITEM("Certificate File", 'The filename of the SSL certificate file.', ' The certificate file should be placed in a secured directory, which allows read-only access to the user that the server runs as.', 'Filename which can be an absolute path or a relative path to $SERVER_ROOT.', '');
$this->db['checkPrivateCache'] = new DATTR_HELP_ITEM("Check Private Cache", 'Specifies whether to check against the private cache for URLs requested in the current context. Can be set at the server, virtual host, or context level.', '', 'Select from radio box', '');
$this->db['checkPublicCache'] = new DATTR_HELP_ITEM("Check Public Cache", 'Specifies whether to check against the public cache for URLs requested in the current context. Can be set at the server level, virtual host level, or context level.', '', 'Select from radio box', '');
$this->db['ciphers'] = new DATTR_HELP_ITEM("Ciphers", 'Specifies the cipher suite to be used when negotiating the SSL handshake. LSWS supports cipher suites implemented in SSL v3.0, TLS v1.0, TLS v1.2, and TLS v1.3.', ' We recommend leaving this field blank to use our default cipher which follows SSL cipher best practices.', 'Colon-separated string of cipher specifications.', 'ECDHE-RSA-AES128-SHA256:RC4:HIGH:!MD5:!aNULL:!EDH');
$this->db['clientVerify'] = new DATTR_HELP_ITEM("Client Verification", ' Specifies the type of client certifcate authentication. Available types are: <ul> <li><b>None:</b> No client certificate is required.</li> <li><b>Optional:</b> Client certificate is optional.</li> <li><b>Require:</b> The client must has valid certificate.</li> <li><b>Optional_no_ca:</b> Same as optional.</li> </ul> The default is &quot;None&quot;.', '&quot;None&quot; or &quot;Require&quot; are recommended.', 'Select from drop down list', '');
$this->db['compressibleTypes'] = new DATTR_HELP_ITEM("Compressible Types", 'Specifies what MIME types are allowed to be compressed. Leave this setting unset or enter default to use the server built-in default list which should already cover most mime-types.<br/><br/>Default value: text/*,application/x-javascript,application/javascript,application/xml,image/svg+xml,application/rss+xml, application/json,application/vnd.ms-fontobject,application/x-font,application/x-font-opentype, application/x-font-truetype,application/x-font-ttf,font/eot,font/opentype,font/otf,font/ttf,image/x-icon, image/vnd.microsoft.icon,application/xhtml+xml', ' Only allow types that will benefit from GZIP/Brotli compression. Binary files such as gif/png/jpeg images and flash files do not benefit from compression.', 'MIME type list separated by commas. Wild card &quot;*&quot; and negate sign &quot;!&quot; are allowed, such as text/*, !text/js.', 'If you want to compress text/* but not text/css, you can have a rule like text/*, !text/css. &quot;!&quot; will exclude that MIME type.');
$this->db['configFile'] = new DATTR_HELP_ITEM("Config File", 'The configuration filename and directory for this virtual host.', '$SERVER_ROOT/conf/vhosts/$VH_NAME.xml is recommended for easy management.', 'Filename which can be an absolute path or a relative path to $SERVER_ROOT, $VH_ROOT.', '');
$this->db['connTimeout'] = new DATTR_HELP_ITEM("Connection Timeout (secs)", 'Specifies the maximum connection idle time allowed during processing one request. The connection will be closed if it has been idle, i.e. no I/O activity, for this period of time.', ' Set this as low as you can to help recover dead connections during a potential DoS attack.', 'Integer number', '');
$this->db['consoleSessionTimeout'] = new DATTR_HELP_ITEM("Session Timeout (secs)", 'Customize the session timeout length of the WebAdmin Console.  The default is 60 seconds.', ' Set a proper value for production use, usually less than 300 seconds.', 'Integer number', '');
$this->db['cookieName'] = new DATTR_HELP_ITEM("Tracking Cookie Name", 'Specify the tracking cookie name.', '', 'string', '');
$this->db['crlFile'] = new DATTR_HELP_ITEM("Client Revocation File", ' Specifies the file containing PEM-encoded CA CRL files enumerating revoked client certificates. This can be used as an alternative or in addition to &quot;Client Revocation Path&quot;.', '', 'Filename which can be an absolute path or a relative path to $SERVER_ROOT.', '');
$this->db['crlPath'] = new DATTR_HELP_ITEM("Client Revocation Path", ' Specifies the directory containing PEM-encoded CA CRL files for revoked client certificates. The files in this directory have to be PEM-encoded. These files are accessed through hash filenames, hash-value.rN. Please refer to openSSL or Apache mod_ssl documentation regarding creating the hash filename.', '', 'path', '');
$this->db['ctxType'] = new DATTR_HELP_ITEM("Context Type", 'The type of context created determines it&#039;s usage.<br/><br/>The <b>Redirect</b> context is used to set up an internal or external redirect URI.<br> The <b>Load Balancer</b> context is used to assign a different cluster for that context.', '', '', '');
$this->db['defaultAction'] = new DATTR_HELP_ITEM("Default Action", 'Specifies the default actions that should be taken when a censoring rule is met. Default value is deny,log,status:403, which means to deny access with status code 403 and log the incident in the error log.', '', '', '');
$this->db['defaultCharsetCustomized'] = new DATTR_HELP_ITEM("Customized Default Charset", 'Specifies a character set to be used when &quot;Add Default Charset&quot; 	   is On. This is optional. The default value is iso-8859-1. 	   This entry has no effect when &quot;Add Default Charset&quot; is 	   Off.', '', 'Name of a character set.', 'utf-8');
$this->db['defaultCluster'] = new DATTR_HELP_ITEM("Default Cluster", 'Specifies the default cluster used for handling requests to this vhost.', '', 'Select from drop down list', '');
$this->db['defaultTargetPort'] = new DATTR_HELP_ITEM("Default Target Port", 'Specifies a default target port for connecting to the backend worker. It can be overriden in worker configuration.', '', 'Integer number', '');
$this->db['destinationuri'] = new DATTR_HELP_ITEM("Destination URI", 'Specifies the target location of the redirect. If this redirected URI maps to a URI in another redirect context, it will be redirected again.', '', 'This URI can either be a relative URI on the same web site starting with &quot;/&quot;, or an absolute URI pointing to different web site starting with &quot;http(s)://&quot;. If the &quot;URI&quot; contains regular expressions, the destination can reference the matched variables, such as $1 or $2.', '');
$this->db['disableInitLogRotation'] = new DATTR_HELP_ITEM("Disable Initial Log Rotation", 'Specifies whether to enable/disable rotation of server error log file at startup. Initial log rotation is enabled by default when using value &quot;Not Set&quot;.', '', 'Select from radio box', '');
$this->db['domainName'] = new DATTR_HELP_ITEM("Domains", 'Specifies the mapping domain names. Domain names are case insensitive and the leading &quot;www.&quot; will be removed. The wildcard characters &quot;*&quot; and &quot;?&quot; are allowed. &quot;?&quot; only represents one character. &quot;*&quot; represents any numbers of characters. Duplicated domain names are not allowed.', ' If a listener is dedicated to one virtual host, always use * for the domain name to avoid unnecessary checking. Domain names with wildcard characters  (other than the catchall domain) should be avoided whenever possible.', 'Comma-separated list.', 'www?.example.com<br/>&quot;*.mydomain.com&quot; will match all subdomains of mydomain.com.<br/>&quot;*&quot; by itself is the catchall domain and will match any unmatched domain names.');
$this->db['dynReqPerSec'] = new DATTR_HELP_ITEM("Requests/Second", 'Specifies the maximum number of requests for dynamically generated content coming from a single IP address that can be processed in each second, regardless of the number of connections established. When this limit is reached, all future requests for dynamic content are tar-pitted until the next second. The per client request limit can be set at the server or virtual host level where virtual host level settings override server level settings.', ' Trusted IPs or sub-networks are not effected', 'Integer number', '');
$this->db['enableAntiddos'] = new DATTR_HELP_ITEM("Enable Anti-DDoS Protection", 'This will enable bot detection and address them by denying or redirecting the client to reCAPTCHA. If firewall is enabled, the client IP will be denied at the firewall level.<br/><br/>Default value is Yes.', '', 'Select from radio box', '');
$this->db['enableBrCompress'] = new DATTR_HELP_ITEM("Brotli Compression Level", 'Controls the level of Brotli compression applied. Ranges from 0 (OFF) to 6 (highest).<br/><br/>This setting will only take effect when &quot;Enable Compression&quot; is enabled.<br/><br/>Default value: 2', '', 'Number between 0 and 6.', '');
$this->db['enableCensorship'] = new DATTR_HELP_ITEM("Enable WAF", 'Specifies whether to enable request content deep inspection. This feature is equivalent to Apache&#039;s mod_security, which can be used to detect and block requests with ill intention by matching them to known signatures.', '', 'Select from radio box', '');
$this->db['enableChroot'] = new DATTR_HELP_ITEM("Enable chroot", ' Specifies whether to start the server in chroot mode. The new root directory is set by &quot;Chroot Path&quot; during installation.', '', 'Select from radio box', '');
$this->db['enableCoreDump'] = new DATTR_HELP_ITEM("Enable Core Dump", 'Specifies whether to enable core dump when the server is started by &quot;root&quot; user.  For most modern Unix systems, processes that change user ID or group ID are not allowed to  dump a core file for security reasons. However, it is much easier to identify root  cause of a problem with a core dump. This option only works on Linux kernel 2.4 and up.   Solaris users should use the coreadm command to control this feature.', ' Only enable this when you see no core file created in   the server log file. Disable it immediately after producing the core file.   Please submit a bug report when a core dump has been created.', 'Select from radio box', '');
$this->db['enableDHE'] = new DATTR_HELP_ITEM("Enable DH Key Exchange", 'Allows use of Diffie-Hellman key exchange for further SSL encryption.', ' DH key exchange is more secure than using just an RSA key. ECDH and DH key exchange are equally secure.<br/><br/> Enabling DH key exchange will increase CPU load and is slower than ECDH key exchange and RSA. ECDH key exchange is preferred when available.', 'Select from radio box', '');
$this->db['enableECDHE'] = new DATTR_HELP_ITEM("Enable ECDH Key Exchange", 'Allows use of Elliptic Curve Diffie-Hellman key exchange for further SSL encryption.', ' ECDH key exchange is more secure than using just an RSA key. ECDH and DH key exchange are equally secure.<br/><br/> Enabling ECDH key exchange will increase CPU load and is slower than using just an RSA key.', 'Select from radio box', '');
$this->db['enableGzipCompress'] = new DATTR_HELP_ITEM("Enable Compression", 'Enables GZIP/Brotli compression.<br/><br/>Default value: Yes', ' Enable to save network bandwidth. On average, responses can be compressed down to half of their original size.', 'Select from radio box', '');
$this->db['enableIpGeo'] = new DATTR_HELP_ITEM("Enable GeoLocation Lookup", ' Specifies whether to enable/disable IP Geolocation lookup. Can be set at server, virtual host, or context level. IP Geolocation is disabled by default when using value &quot;Not Set&quot;.', '', 'Select from radio box', '');
$this->db['enableRecaptcha'] = new DATTR_HELP_ITEM("Enable reCAPTCHA", 'Enable the reCAPTCHA Protection feature at the current level. This setting must be set to Yes at the Server level before the reCAPTCHA Protection feature can be used.<br/><br/>Default values:<br/><b>Server-level:</b> Yes<br/><b>VH-Level:</b> Inherit Server level setting', '', 'Select from radio box', '');
$this->db['enableRewrite'] = new DATTR_HELP_ITEM("Enable Rewrite", 'Specifies whether to enable LiteSpeed&#039;s URL rewrite engine. This option can be customized at the virtual host or context level, and is inherited along the directory tree until it is explicitly overridden.', '', 'Select from radio box', '');
$this->db['enableSpdy'] = new DATTR_HELP_ITEM("ALPN", 'Selectively enable HTTP/3, HTTP/2, and SPDY HTTP network protocols.<br/><br/>If you wish to disable SPDY, HTTP/2, and HTTP3, check &quot;None&quot; and leave all other boxes unchecked.<br/><br/>Default value: All enabled', 'This setting can be set at the listener and virtual host levels.', 'Select from checkbox', '');
$this->db['enableStapling'] = new DATTR_HELP_ITEM("Enable OCSP Stapling", 'Determines whether to enable OCSP stapling, a more efficient way of verifying public key certificates.', '', 'Select from radio box', '');
$this->db['env'] = new DATTR_HELP_ITEM("Environment", 'Specifies extra environment variables for the external application.', '', 'Key=value. Multiple variables can be separated by &quot;ENTER&quot;', '');
$this->db['errCode'] = new DATTR_HELP_ITEM("Error Code", 'Specifies the HTTP status code for the error page. Only the selected HTTP status code will have this customized error page.', '', 'Select from drop down list', '');
$this->db['errMessage'] = new DATTR_HELP_ITEM("Custom Error Message", 'Specify a custom error message.', '', '', '');
$this->db['errPage'] = new DATTR_HELP_ITEM("Customized Error Pages", 'Whenever the server has a problem processing a request, the server will return an error code and an html page as an error message to the web client. Error codes are defined in the HTTP protocol (see RFC 2616). LiteSpeed Web Server has a built-in default error page for each error code, but a customized page can be configured for each error code as well. These error pages can be even further customized to be unique for each virtual host.', '', '', '');
$this->db['expuri'] = new DATTR_HELP_ITEM("URI", 'Specifies the URI for this context.', '', 'The URI can be a plain URI (starting with &quot;/&quot;) or a Perl compatible regular expression URI (starting with &quot;exp:&quot;). If a plain URI ends with a &quot;/&quot;, then this context will include all sub-URIs under this URI. If the context maps to a directory on the file system, a trailing &quot;/&quot; must be added.', '');
$this->db['extAppType'] = new DATTR_HELP_ITEM("Type", 'Specifies the type of external application. Choose from <ul>   <li>FastCGI: a FastCGI application with Responder role.</li>   <li>Servlet Engine: a Servlet engine with AJPv13 connector, such as tomcat.</li>   <li>HTTP Proxy: a web server or application server that supports the HTTP protocol.</li>   <li>HTTPS Proxy: a web server or application server that supports the HTTPS protocol.</li>   <li>LSAPI App: an application that communicates with the web server using the LSAPI protocol.</li> </ul>', '', 'Select from drop down list', '');
$this->db['extCluster'] = new DATTR_HELP_ITEM("Cluster", 'Specifies the cluster that handles requests to this context.', '', 'Select from drop down list', '');
$this->db['externalredirect'] = new DATTR_HELP_ITEM("External Redirect", 'Specifies whether this redirect is external. For external redirection, &quot;Status Code&quot; may be specified and &quot;Destination URI&quot; can start either with &quot;/&quot; or &quot;http(s)://&quot;. For internal redirection, &quot;Destination URI&quot; must start with &quot;/&quot;.', '', '', '');
$this->db['extraHeaders'] = new DATTR_HELP_ITEM("Header Operations", 'Specifies additional response/request headers to be added. Multiple header directives can be added with one directive per line. &quot;NONE&quot; can be used to disable parent header inheritance. If no directive is provided &#039;Header&#039; is assumed.', ' Syntax and usage are similar to <a href="https://httpd.apache.org/docs/2.2/mod/mod_headers.html#header" target="_blank" rel="noopener noreferrer">Apache&#039;s mod_headers directives</a> for supported operations.<br/><br/> The &#039;Header&#039; directive is is optional and can be excluded or left in when copying rules from elsewhere without issue.', '[Header]|RequestHeader [condition] set|append|merge|add|unset header [value] [early|env=[!]variable]', 'set Cache-control no-cache<br/>append Cache-control no-store<br/>Header set My-header cust_header_val<br/>RequestHeader set My-req-header cust_req_header_val');
$this->db['firewallEnable'] = new DATTR_HELP_ITEM("Enable Firewall Modifications", 'Enable firewall modifications via iptables. iptables must be enabled on this system for this setting to take effect.<br/><br/>If ipset is also installed and enabled on this system, it will be used to more efficiently manage firewall rulesets for iptables.<br/><br/>Default value is Yes.', ' ipset should be installed and enabled on the system to more efficiently manage firewall rulesets for iptables.', 'Select from radio box', '');
$this->db['forceSecureCookie'] = new DATTR_HELP_ITEM("Secure Cookie Control", 'Control whether to send cookies with the flag &quot;secure&quot;, attribute &quot;SameSite=Strict&quot;, and attribute &quot;SameSite=Lax&quot;.<br/><br/>If both &quot;SameSite=Strict&quot; and &quot;SameSite=Lax&quot; are selected, &quot;SameSite=Strict&quot; will be used.<br/><br/>Default value: &quot;secure&quot;', '', 'Select from checkbox', '');
$this->db['forwardByHeader'] = new DATTR_HELP_ITEM("Forwarded By Header", 'An additional header to be added to all proxy requests made to the backend server. This header&#039;s value will be set to the serverName value.<br/><br/>Default value: Not Set', '', 'String with allowed characters a-z, A-Z, 0-9, underscore(_), and hyphen(-)', 'X-Forwarded-By');
$this->db['forwardIpHeader'] = new DATTR_HELP_ITEM("Forward IP Header", 'An additional header to be added to all proxy requests made to the backend server. This header will use either the visiting IP or the value set in the &#039;X-Forwarded-For&#039; header as it&#039;s value, depending on the value set for &quot;Use Client IP in Header&quot;.<br/><br/>Default value: Not Set', '', 'String with allowed characters a-z, A-Z, 0-9, underscore(_), and hyphen(-)', 'X-Client-Ip');
$this->db['gdb_groupname'] = new DATTR_HELP_ITEM("Group Name", 'A group name containing only letters and numbers (no special characters).', '', 'string', '');
$this->db['gdb_users'] = new DATTR_HELP_ITEM("Users", 'Space separated list of users belonging to this group.', '', '', '');
$this->db['geoipDBFile'] = new DATTR_HELP_ITEM("DB File Path", 'Specifies the path to MaxMind GeoIP database.', '', 'Absolute path', '/usr/local/share/GeoIP/GeoLite2-Country.mmdb');
$this->db['geoipDBName'] = new DATTR_HELP_ITEM("DB Name", 'MaxMind GeoIP database name. As of GeoIP2, this setting is required.<br/><br/>When upgrading from a GeoIP to a GeoIP2, using values &quot;COUNTRY_DB&quot;, &quot;CITY_DB&quot;, or &quot;ASN_DB&quot; for this setting will automatically populate PHP&#039;s $_SERVER variable with some GeoIP compatible entries (listed by DB Name value below) to help ease this transition.<br/><br/><b>CITY_DB:</b> &#039;GEOIP_COUNTRY_CODE&#039;, &#039;GEOIP_COUNTRY_NAME&#039;, &#039;GEOIP_CONTINENT_CODE&#039;, &#039;GEOIP_COUNTRY_CONTINENT&#039;, &#039;GEOIP_DMA_CODE&#039;, &#039;GEOIP_METRO_CODE&#039;, &#039;GEOIP_LATITUDE&#039;, &#039;GEOIP_LONGITUDE&#039;, &#039;GEOIP_POSTAL_CODE&#039;, and &#039;GEOIP_CITY&#039;.<br/><b>COUNTRY_DB:</b> &#039;GEOIP_COUNTRY_CODE&#039;, &#039;GEOIP_COUNTRY_NAME&#039;, &#039;GEOIP_CONTINENT_CODE&#039;, and &#039;GEOIP_COUNTRY_CONTINENT&#039;.<br/><b>ASN_DB:</b> &#039;GEOIP_ORGANIZATION&#039; and &#039;GEOIP_ISP&#039;.', '', '', 'COUNTRY_DB');
$this->db['geolocationDB'] = new DATTR_HELP_ITEM("MaxMind GeoIP DB", 'Multiple MaxMind geolocation databases can be specified here. MaxMind has the following type of DBs: Country, Region, City, Organization, ISP and Netspeed. If multiple databases of types &quot;Country&quot;, &quot;Region&quot;, and &quot;City&quot; are configured, the last configuration will be effective.', '', '', '');
$this->db['gracePeriod'] = new DATTR_HELP_ITEM("Grace Period (sec)", 'Specifies how long new connections can be accepted after the number of connections established from one IP is over the &quot;Connection Soft Limit&quot;. Within this period, new connections will be accepted if the total connections is still below the &quot;Connection Hard Limit&quot;. After this period has elapsed, if the number of connections still higher than the &quot;Connection Soft Limit&quot;, then the offending IP will be blocked for the &quot;Banned Period (sec)&quot;.', ' Set to a proper number big enough for downloading a complete page but low enough to prevent deliberate attacks.', 'Integer number', '');
$this->db['groupDBCacheTimeout'] = new DATTR_HELP_ITEM("Group DB Cache Timeout (secs)", 'Specifies how often the backend group database will be checked for changes. For more detail please refer to &quot;User DB Cache Timeout (secs)&quot;.', '', 'Integer number', '');
$this->db['groupDBMaxCacheSize'] = new DATTR_HELP_ITEM("Group DB Max Cache Size", 'Specifies the maximum cache size of the group database.', ' As a larger cache will consume more memory, a higher value may or may not provide better performance. Set it to an appropriate size according to your user database size and site usage.', 'Integer number', '');
$this->db['groupDB_attrGroupMember'] = new DATTR_HELP_ITEM("Group Member Attribute", 'Specifies the name of the &quot;Member&quot; attribute for a group record stored in an LDAP server. The default value is memberUid.', '', 'string', '');
$this->db['gzipCompressLevel'] = new DATTR_HELP_ITEM("GZIP Compression Level", 'Specifies the level of GZIP compression applied. Ranges from 1 (lowest) to 9 (highest).<br/><br/>This setting will only take effect when &quot;Enable Compression&quot; is enabled.<br/><br/>Default value: 6', ' Higher compression level will use more memory and CPU cycles. You can set it to a higher level if your machine has additional power. There is not much difference between 6 and 9, except that 9 uses many more CPU cycles.', 'Number between 1 and 9.', '');
$this->db['haInterfaceId'] = new DATTR_HELP_ITEM("Name", 'A unique number that identifies a virtual interface.', '', 'Integer number', '');
$this->db['haInternalDev'] = new DATTR_HELP_ITEM("Internal Device", 'The Internal Device (such as eth0, eth1, etc..) to use for internal communication by unicast/multicast. If this is different than the NIC Name configuration, the Keepalived configuration will be adjusted accordingly.<br/><br/>Default value: Configured &quot;NIC Name&quot; value', '', 'Select from drop down list', '');
$this->db['haNic'] = new DATTR_HELP_ITEM("NIC Name", 'The NIC name (such as eth0, eth1, etc..) that the virtual IP will bind to. Required for Linux platforms.<br/><br/><b>Note:</b> Even though it is required, this setting will have no effect on FreeBSD platforms.', '', '', '');
$this->db['haPriority'] = new DATTR_HELP_ITEM("Priority", 'The priority for this load balancer server, where a higher number equals a higher priority. The highest priority load balancer will act as the master, with others in the cluster acting as slaves.<br/><br/><b>Note:</b> This is reversed for FreeBSD platforms where a lower number equals a higher priority.', ' A difference in priority of 50 or greater between two nodes will cause Keepalived (linux) to switch the Virtual IP back to the higher priority node upon recovery. For example, two nodes with priorities of 110 and 100 will start with the 110 priority node as the master. If that node dies and recovers, the 100 node will retain the Virtual IP. If on the other hand we have two nodes with priorities 200 and 100, the 200 node will reclaim the Virtual IP upon recovery.', 'Integer number', '');
$this->db['haRep_fileCacheLstnr'] = new DATTR_HELP_ITEM("File Cache Server Address", 'Select file cache server address.', '', 'IP:port', '');
$this->db['haRep_heartBeatInterval'] = new DATTR_HELP_ITEM("Heart Beat Interval (secs)", 'The time interval that &quot;I am alive&quot; messages will be sent.', '', 'Integer number', '');
$this->db['haRep_heartBeatTimeout'] = new DATTR_HELP_ITEM("Heart Beat Timeout (secs)", 'The time interval after which, if &quot;I am alive&quot; message is not sent, the replicator will be considered to have failed. Must be set higher than <b>Heart Beat interval (secs)</b>.', '', 'Integer number', '');
$this->db['haRep_isFileCached'] = new DATTR_HELP_ITEM("Enable Replication for Cached Data", 'Enable file cache replication.', '', 'Select from radio box', '');
$this->db['haRep_isGzipStream'] = new DATTR_HELP_ITEM("Is Gzip Stream", 'Enable Gzip compression for replicator traffic.', '', 'Select from radio box', '');
$this->db['haRep_maxAckDiff'] = new DATTR_HELP_ITEM("Max Sequence Number Difference", 'Compares to the difference between the last sequence number sent and the last sequence number acknowledged by the master. If the difference is larger than maxAckDiff, individual SHM updates are paused until the next bulk update is complete.<br/><br/>This difference indicates the busy-ness level of the master. If multiple nodes are syncing a significant amount of data with the master, this value ensures that the data sync is still manageable and performs at an optimal level.<br/><br/>Default value: 100', '', 'Number between 1 and 65535.', '');
$this->db['haRep_priority'] = new DATTR_HELP_ITEM("Data Master Priority", 'Indicates the *data sync priority*. The node with the highest priority is selected to be the data sync &#039;master&#039;, when there are no masters selected yet. If a master is already selected, that node will remain master. Note that this is for data sync ONLY. The priority value in the HA Interfaces configuration group is for Virtual IP priority.<br/><br/>Default value: 0', '', 'Number between -32766 and 32767.', '');
$this->db['haRep_replCluster'] = new DATTR_HELP_ITEM("Replication Cluster", 'List of replicators, by their IP Address and port number, that are a part of this replication cluster.', '', 'Comma separated list in the form IP:port', '');
$this->db['haRep_serverAddr'] = new DATTR_HELP_ITEM("Server Address", 'Local IP address and port used for replication.', '', 'IP:port', '');
$this->db['haRep_syncInterval'] = new DATTR_HELP_ITEM("Sync Interval", 'The time in seconds that a node will remain in the upgrading state before transitioning to master. This interval is used to allow the group to communicate with one another to ensure that the correct node is selected as master. It is strongly recommended that this is set to a longer interval than the Heart Beat Interval.<br/><br/>Default value: 30', '', 'Number between 1 and 255.', '');
$this->db['haUniPeerVips'] = new DATTR_HELP_ITEM("Unicast Peer Virtual IPs", 'List of peer virtual IPs to send Unicast messages to. There should be one peer IP entry for each node expected to handle request processing.<br/><br/>&quot;Unicast Source Virtual IP&quot; must also be set for Unicast to be used. (Multicast is used by default)', 'Unicast is generally slower and more resource intensive than Multicast.', 'comma separated list', '');
$this->db['haUniSrcVip'] = new DATTR_HELP_ITEM("Unicast Source Virtual IP", 'The local machine&#039;s virtual IP used to send Unicast messages.<br/><br/>&quot;Unicast Peer Virtual IPs&quot; must also be set for Unicast to be used. (Multicast is used by default)', 'Unicast is generally slower and more resource intensive than Multicast.', '', '');
$this->db['haVip'] = new DATTR_HELP_ITEM("Virtual IPs", 'A list of virtual IP addresses used to access the HA interface. These addresses can be either an IPv4 or IPv6 and must be on the same subnet as the real IP address.<br/><br/>Please verify proper usage with keepalived prior to using multiple Virtual IPs.', '', 'comma separated list', '');
$this->db['haVipId'] = new DATTR_HELP_ITEM("Virtual IP ID", 'The ID of the virtual IP address. Please use an integer number between 1 and 10. <b>Virtual IP</b>, <b>Virtual IP ID</b>, and <b>Virtual IP Token</b> must be the same for the same HA group.', '', '', '');
$this->db['haVipToken'] = new DATTR_HELP_ITEM("Virtual IP Token", 'A virtual IP address token is required to authenticate interface(carp/vrrp) advertisements. <b>Virtual IP</b>, <b>Virtual IP ID</b>, and <b>Virtual IP Token</b> must be same for the same HA group.', '', '', '');
$this->db['hardLimit'] = new DATTR_HELP_ITEM("Connection Hard Limit", 'Specifies the maximum number of allowed concurrent connections from a single IP address. This limit is always enforced and a client will never be able to exceed this limit. HTTP/1.0 clients usually try to set up as many connections as they need to download embedded content at the same time. This limit should be set high enough so that HTTP/1.0 clients can still access the site. Use &quot;Connection Soft Limit&quot; to set the desired connection limit.<br/><br/>The recommended limit is between 20 and 50 depending on the content of your web page and your traffic load.', ' A lower number will enable serving more distinct clients.<br/> Trusted IPs or sub-networks are not affected.<br/> Set to a high value when you are performing benchmark tests with a large number of concurrent client machines.', 'Integer number', '');
$this->db['hideSigInErrorPage'] = new DATTR_HELP_ITEM("Hide Error Page Signature", 'Specifies whether or not to show the lines <blockquote>Powered By LiteSpeed.<br/>LiteSpeed Technologies is not responsible for administration and contents of this web site!&quot;</blockquote> on your default error pages.', '', 'Select from radio box', '');
$this->db['inBandwidth'] = new DATTR_HELP_ITEM("Inbound Bandwidth (bytes/sec)", 'The maximum allowed incoming throughput from a single IP address, regardless of the number of connections established. The real bandwidth may end up being slightly higher than this setting for efficiency reasons. Bandwidth is allocated in 1KB units. Set to 0 to disable throttling. Per-client bandwidth limits (bytes/sec) can be set at the server or virtual host level where virtual host level settings override server level settings.', ' Trusted IPs or sub-networks are not affected.', 'Integer number', '');
$this->db['inMemBufSize'] = new DATTR_HELP_ITEM("Max I/O Buffer Size", 'Specifies the maximum buffer size that is used to store a request body and its dynamically generated response. When this limit is reached, the server will start to create temporary swapping files under &quot;Swapping Directory&quot;.', ' Set the buffer size large enough to accommodate all concurrent requests/replies to avoid memory to disk swapping. If there is frequent I/O activity to the swap directoy, by default /tmp/lshttpd/swap/, this buffer size is too low and LiteSpeed is swapping to disk.', 'Integer number', '');
$this->db['initTimeout'] = new DATTR_HELP_ITEM("Initial Request Timeout (secs)", 'Specifies the maximum time in seconds the server will wait for the external application to respond to the first request over a new established connection. If the server does not receive any data from the external application within this timeout limit, it will mark this connection as bad. This helps to identify communication problems with external applications as quickly as possible. If some requests take longer to process, increase this limit to avoid 503 error messages.<br/><br/>Default value: 600', '', 'Integer number', '');
$this->db['insertCookie'] = new DATTR_HELP_ITEM("Insert Tracking Cookie", 'Specify whether to insert a tracking cookie. The tracking cookie can be used to reconstruct session cache in case load balancer lost it.', '', 'Select from radio box', '');
$this->db['ip2locDBCache'] = new DATTR_HELP_ITEM("DB Cache Type", 'The caching method used. The default value is Memory.', '', 'Select from drop down list', '');
$this->db['ip2locDBFile'] = new DATTR_HELP_ITEM("IP2Location DB File Path", 'The location of a valid database file.', '', 'Filename which can be an absolute path or a relative path to $SERVER_ROOT.', '');
$this->db['keepAliveTimeout'] = new DATTR_HELP_ITEM("Keep-Alive Timeout (secs)", 'Specifies the maximum idle time between requests from a keep-alive connection. If no new request is received during this period of time, the connection will be closed. This setting only applies to HTTP/1.1 connections. HTTP/2 connections have long keep-alive timeouts by design and are not affected by this setting.', ' We recommend that you set this value just long enough to wait for subsequent requests from  a client when there are more assets referenced by a single page that need to be loaded. Do not set this too long hoping that  the next page will be served over the keep-alive connection. Keeping many idle keep-alive connections is a waste of server resources and could be taken advantage of by (D)DoS attacks. 2-5 seconds is a  reasonable range for most applications. LiteSpeed is highly efficient in a non-keep-alive environment.', 'Integer number', '');
$this->db['keyFile'] = new DATTR_HELP_ITEM("Private Key File", 'The filename of the SSL private key file. The key file should not be encrypted.', ' The private key file should be placed in a secured directory that allows read-only access to the user the server runs as.', 'Filename which can be an absolute path or a relative path to $SERVER_ROOT.', '');
$this->db['lb_mode'] = new DATTR_HELP_ITEM("Mode", 'Specifies which mode the load balancer operates in, &quot;Stateless&quot; or &quot;Stateful&quot;.<br/><br/>&quot;Stateful&quot; mode track sessions associated with each back-end server. It also called &quot;Session Affinity&quot;.<br/><br/>&quot;Stateless&quot; mode does not care about sessions.<br/><br/>For the Layer 4 Load Balancer, if the Mode is “Stateful”, it will track the IP address of the client to extract previous sessions.', '', 'Select from drop down list', '');
$this->db['lb_name'] = new DATTR_HELP_ITEM("Name", 'A unique name for a cluster.', '', '', '');
$this->db['lb_type'] = new DATTR_HELP_ITEM("Type", 'Specifies the type of cluster. <br><br> &quot;Layer7&quot; HTTP load balancing, also known as application-level load balancing, parses HTTP requests and distributes requests to servers based on different types of request contents. <br><br> &quot;Layer4&quot; load balancing is transport layer load balancing, such as TCP and UDP transport protocols. It does not look at the content when selecting a backend server. In theory, Layer 4 load balancing supports every application type.', '', 'Select from drop down list', '');
$this->db['listenerBinding'] = new DATTR_HELP_ITEM("Binding", 'Specifies which lslbd child process the listener is assigned to. Multiple child processes are spawned to take advantage of the multiple CPUs in an SMP system. Different child processes can be used to handle requests to different listeners by manually associating a listener with a process. By default, a listener is assigned to all child processes.', '', 'Select from checkbox', '');
$this->db['listenerIP'] = new DATTR_HELP_ITEM("IP Address", 'Specifies the IP of this listener. All available IP addresses are listed. IPv6 addresses are enclosed in &quot;[ ]&quot;.<br/><br/>To listen on all IPv4 IP addresses, select ANY. To listen on all IPv6 IP addresses, select [ANY] IPv6. If No is selected for setting &quot;Bind IPv6 Only&quot;, selecting [ANY] IPv6 will listen on IPv4 addresses as well.<br/><br/>By default, LiteSpeed uses separate listeners for IPv4 and IPv6 addresses. Should the need to serve both IPv4 and IPv6 arise, separate listeners should be created for each.', ' If your machine has multiple IPs on different sub-networks, you can select a specific IP to only allow traffic from the corresponding sub-network.', 'Select from drop down list', '');
$this->db['listenerName'] = new DATTR_HELP_ITEM("Listener Name", 'A unique name for this listener.', '', '', '');
$this->db['listenerPort'] = new DATTR_HELP_ITEM("Port", 'Specifies the TCP port of the listener. Only the super user (&quot;root&quot;) can use ports lower than 1024. Port 80 is the default HTTP port. Port 443 is the default HTTPS port.', '', 'Integer number', '');
$this->db['listenerSecure'] = new DATTR_HELP_ITEM("Secure", 'Specifies whether this is a secure (SSL) listener. For secure listeners, additional SSL settings need to be set properly.', '', 'Select from radio box', '');
$this->db['listenerType'] = new DATTR_HELP_ITEM("Type", 'The Layer 7 listener type.<br/><br/>An “http” listener treats requests as an HTTP Request, so it will parse the request data to use for load balancing.<br/><br/>A “tcp” listener will not parse request data. Only the client’s IP address and port are parsed for load balancing.', '', 'Select from drop down list', '');
$this->db['litemage'] = new DATTR_HELP_ITEM("Enable LiteMage", 'Enables LiteMage Cache for Magento Stores.<br/><br/>When set to &#039;On&#039; the server will also try to use shared private cache information to speed up page load time for first time visitors. Select &#039;Safe&#039; to disable this feature.', 'This setting will not work if your LiteSpeed license does not have the LiteMage module enabled.', 'Select from drop down list', '');
$this->db['lmap'] = new DATTR_HELP_ITEM("Virtual Hosts Mappings", 'Shows currently established mappings to virtual hosts from a particular listener.  The virtual host name appears in brackets and is followed by the matching domain name(s) for this listener.', 'If a virtual host has not been loaded successfully (fatal errors in the  virtual host configuration), the mapping to that virtual host will not be displayed.', '', '');
$this->db['lname'] = new DATTR_HELP_ITEM("Name - Listener", 'The unique name that identifies this listener. This is the  &quot;Listener Name&quot; you specified when setting up the listener.', '', '', '');
$this->db['loadBalancerContext'] = new DATTR_HELP_ITEM("Load Balancer Context", 'A Load Balancer Context can be used to forward one URI or a group of URIs to another location. The destination URI can be either on the same web site or an absolute URI pointing to another web site.', '', '', '');
$this->db['logUseServer'] = new DATTR_HELP_ITEM("Use Server's Log", 'Specifies whether to put log messages from this virtual host into the server  log file instead of creating its own log file.', '', 'Select from radio box', '');
$this->db['log_compressArchive'] = new DATTR_HELP_ITEM("Compress Archive", 'Specifies whether to compress rotated log files in order to save disk space.', 'Log files are highly compressible and this is recommended to reduce disk usage for old logs.', 'Select from radio box', '');
$this->db['log_debugLevel'] = new DATTR_HELP_ITEM("Debug Level", 'Specifies the level of debug logging.  &quot;Log Level&quot; must be set to DEBUG to use this feature.  Debug logging is disabled when &quot;Debug Level&quot; is set to NONE even if &quot;Log Level&quot; is set to DEBUG.  &quot;Toggle Debug Logging&quot; can be used to control debug level on a live server without restarting.', ' Important! Always set this to NONE if you do not need detailed debug logging. Active debug logging will severely degrade service performance and potentially saturate disk space in a very short time. Debug logging includes detailed information for each request and response.<br/><br/>It&#039;s recommended to set Log Level to DEBUG and Debug Level to NONE.  These settings mean that you will not fill up your hard disk with debug logging,  but you will be able to use the &quot;Toggle Debug Logging&quot; action to control debug output.  This action can turn debug logging on and off on the fly, and is useful for debugging busy production servers.', 'Select from drop down list', '');
$this->db['log_enableAioLog'] = new DATTR_HELP_ITEM("Enable AIO Logging", 'Specifies whether to enable AIO logging for server log and access log. If enabled, asynchronous I/O will be used for writing log messages.', 'Enabling AIO logging can help overall server performance when server I/O wait is high.', 'Select from radio box', '');
$this->db['log_enableStderrLog'] = new DATTR_HELP_ITEM("Enable stderr Log", 'Specifies whether to write to log when receiving stderr output from processes started by the server.<br/><br/>If enabled, stderr messages will be logged in the same directory as the server log with the fixed name &quot;stderr.log&quot;. If disabled, all stderr output will be discarded.<br/><br/>Functions like PHP&#039;s error_log() which do not write directly to stderr (file handle 2) are not affected by this setting and will write to the file set in PHP ini directive &#039;error_log&#039; or the server&#039;s &quot;error.log&quot; file with tag &#039;[STDERR]&#039; if that directive is not set.', 'Turn it on if you need to debug configured external applications: i.e. PHP, Ruby, Java, Python, Perl.', 'Select from radio box', '');
$this->db['log_fileName'] = new DATTR_HELP_ITEM("File Name", 'Specifies the path for the log file.', ' Place the log file on a separate disk.', 'Filename which can be an absolute path or a relative path to $SERVER_ROOT.', '');
$this->db['log_keepDays'] = new DATTR_HELP_ITEM("Keep Days", 'Specifies how many days the access log file will be kept on disk.  Only rotated log files older than the specified number of days will be deleted. The current  log file will not be touched regardless how many days worth of data it contains.  If you do not want to auto-delete stale and very old log files, set this to 0.', '', 'Integer number', '');
$this->db['log_logLevel'] = new DATTR_HELP_ITEM("Log Level", 'Specifies the level of logging to include in your log file.  Available levels (from high to low) are: ERROR,  WARNING, NOTICE, INFO and DEBUG.  Only messages with level higher or equal to the current setting will be logged.', ' Using DEBUG log level does not have any performance impact, unless &quot;Debug Level&quot; is set to a level other than NONE. It&#039;s recommended to set Log Level to DEBUG and Debug Level to NONE. These settings mean that you will not fill up your  hard disk with debug logging, but you will be able to use the &quot;Toggle Debug Logging&quot;  action to control debug output. This action can turn debug logging on and off on the fly,   and is useful for debugging busy production servers.', 'Select from drop down list', '');
$this->db['log_rollingSize'] = new DATTR_HELP_ITEM("Rolling Size (bytes)", 'Specifies when the current log file needs to be rolled over, also known as log rotation.  When the file size is over the rollover limit, the active log file will be renamed  to log_name.mm_dd_yyyy(.sequence) in the same directory and a new active log file will be created. The actual size of the rotated log file once it is created will sometimes be a little bigger than  this size limit. Set to 0 to disable log rotation.', 'Append &quot;K&quot;, &quot;M&quot;, &quot;G&quot; to the number for kilo-, mega- and giga- bytes.', 'Integer number', '');
$this->db['lslbdProcesses'] = new DATTR_HELP_ITEM("Number of Processes", '<b>[Only Available For Web ADC Ultimate Licenses]</b> <br /> Specifies the number of lslbd workers. Enter 0 to have this number be decided automatically.', ' Set an appropriate number to suit your needs. Adding more processes may not necessarily mean better performance.', 'Integer value between 0 and 128.', '');
$this->db['lsrecaptcha'] = new DATTR_HELP_ITEM("reCAPTCHA Protection", 'reCAPTCHA Protection is a service provided as a way to mitigate heavy server load. reCAPTCHA Protection will activate after one of the below situations is hit. Once active, all requests by NON TRUSTED(as configured) clients will be redirected to a reCAPTCHA validation page. After validation, the client will be redirected to their desired page.<br/><br/>The following situations will activate reCAPTCHA Protection:<br/>1. The server or vhost concurrent requests count passes the configured connection limit.<br/>2. Anti-DDoS is enabled and a client is hitting a url in a suspicious manner. The client will redirect to reCAPTCHA first instead of getting denied when triggered.<br/>3. WordPress Brute Force Attack Protection is enabled and action is set to &#039;CAPTCHA or Drop’. When a brute force attack is detected, the client will redirect to reCAPTCHA first. After max tries is reached, the connection will be dropped, as per the ‘drop’ option.<br/>4. WordPress Brute Force Attack Protection is enabled and action is set to &#039;WP Login CAPTCHA Full Protection&#039;. The client will always redirect to reCAPTCHA first.<br/>5. A new rewrite rule environment is provided to activate reCAPTCHA via RewriteRules. &#039;verifycaptcha&#039; can be set to redirect clients to reCAPTCHA. A special value &#039;: deny&#039; can be set to deny the client if it failed too many times. For example, [E=verifycaptcha] will always redirect to reCAPTCHA until verified. [E=verifycaptcha: deny] will redirect to reCAPTCHA until Max Tries is hit, after which the client will be denied.', '', '', '');
$this->db['lstatus'] = new DATTR_HELP_ITEM("Status - Listener", 'The current status of this listener. The status is either Running or Error.', 'If the listener is in the Error state, you can view the server log to find out why.', '', '');
$this->db['mappedListeners'] = new DATTR_HELP_ITEM("Mapped Listeners", 'Specifies the names of all listeners that this template maps to. A listener-to-virtual host mapping for this template&#039;s member virtual hosts will be added to the listeners specified in this field. This mapping will map listeners to virtual hosts based on the domain names and aliases set in the member virtual hosts&#039; individual configurations.', '', 'comma-separated list', '');
$this->db['mapped_L4_clusters'] = new DATTR_HELP_ITEM("Mapped Cluster", 'Specifies the cluster that the Layer 4 listener will use for load balancing. The mapped cluster must be a Layer 4 cluster, which is predefined in &quot;Clusters&quot; tab.', '', 'Select from drop down list', '');
$this->db['maxConnections'] = new DATTR_HELP_ITEM("Max Connections", 'Specifies the maximum number of concurrent connections that the server can accept. This includes both plain TCP connections and SSL connections. Once the maximum concurrent connections limit is reached, the server will close Keep-Alive connections when they complete active requests.', 'When the server is started by &quot;root&quot; user, the server will try to adjust the per-process file descriptor limits automatically, however, if this fails, you may need to increase this limit manually.', 'Integer number', '');
$this->db['maxConns'] = new DATTR_HELP_ITEM("Max Connections", 'Specifies the maximum number of concurrent connections that can be established between the server and an external application. This setting controls how many requests can be processed concurrently by an external application, however, the real limit also depends on the external application itself. Setting this value higher will not help if the external application is not fast enough or cannot scale to a large number of concurrent requests.', ' Setting a high value does not directly translate to higher performance. Setting the limit to a value that will not overload the external application will provide the best performance/throughput.', 'Integer number', '');
$this->db['maxConnsPerIp'] = new DATTR_HELP_ITEM("Max Connections Per IP", 'Overrides Server level setting &quot;Connection Hard Limit&quot; with a lower value. Setting this to a value higher than &quot;Connection Hard Limit&quot; will have no effect.<br/><br/>Once this limit is reached, a 403 response will be returned.<br/><br/>Default value: Not Set', '', 'Integer number', '');
$this->db['maxDynRespHeaderSize'] = new DATTR_HELP_ITEM("Max Response Header Size (bytes)", 'Specifies the maximum header size of a dynamically generated response. Static assets from a backend server are considered a dynamic response. Hard limit is 65530 bytes. Values larger than this, such as 64K (6 bytes larger), will be treated as if 65530 was used.<br/><br/>Default value: 32768 or 32K', ' Set it reasonably low to help recognize bad responses dynamically generated by external applications.', 'Integer number', '');
$this->db['maxDynRespSize'] = new DATTR_HELP_ITEM("Max Response Body Size (bytes)", 'Specifies the maximum body size of a dynamically generated response. Static assets from a backend server are considered a dynamic response.', ' Set the limit reasonably low to help identify bad responses. It is not uncommon to malformed scripts to contain an infinite loop which leads to infinity-sized responses.', 'Integer number', '');
$this->db['maxKeepAliveReq'] = new DATTR_HELP_ITEM("Max Keep-Alive Requests", 'Specifies the maximum number of requests that can be served through a keep-alive (persistent) session. The connection will be closed once this limit is reached. You can set this limit for each virtual host as well.', ' Set this to a reasonably high value. A value of &quot;1&quot; or &quot;0&quot; will disable keep-alive.', 'Integer number', '');
$this->db['maxMindDBEnv'] = new DATTR_HELP_ITEM("Environment Variables", 'Assign the results of database lookups to environment variables.', '', 'Variable_Name mapped_DB_data<br/><br/>One entry per line. Path to data can use map keys or 0-based array indexes, both being separated by /.', 'COUNTRY_CODE COUNTRY_DB/country/iso_code<br/>REGION_CODE  CITY_DB/subdivisions/0/iso_code');
$this->db['maxReqBodySize'] = new DATTR_HELP_ITEM("Max Request Body Size (bytes)", 'Specifies the maximum size of an HTTP request body. For a 32Bit OS, 2GB is the hard limit.  For a 64Bit OS, it is virtually unlimited.', ' To help prevent DoS attacks, try to constrain this limit to only what is really needed. Your swapping space must have enough free space to accommodate this limit.', 'Integer number', '');
$this->db['maxReqHeaderSize'] = new DATTR_HELP_ITEM("Max Request Header Size (bytes)", 'Specifies the maximum size of an HTTP request header including request URL. Hard limit is 65530 bytes. Values larger than this, such as 64K (6 bytes larger), will be treated as if 65530 was used.<br/><br/>Default value: 32768 or 32K', ' Set it reasonably low to reduce memory usage and help identify bogus requests and DoS attacks.<br/>4-8K is big enough for most web sites under normal circumstances.', 'Integer number', '');
$this->db['maxReqURLLen'] = new DATTR_HELP_ITEM("Max Request URL Length (bytes)", 'Specifies the maximum size of a request URL. URL is the full text address used to access a server resource including the query string. Hard limit is 65530 bytes. Values larger than this, such as 64K (6 bytes larger), will be treated as if 65530 was used.<br/><br/>Default value: 8192 or 8K.', ' Set it reasonably low to reduce memory usage and help identify bogus requests and DoS attacks.<br/>2-3K is big enough for most web sites unless the HTTP GET method is used with large query strings instead of POST.', 'Integer number', '');
$this->db['maxSSLConnections'] = new DATTR_HELP_ITEM("Max SSL Connections", 'Specifies the maximum number of concurrent SSL connections the server will accept. Since total concurrent SSL and non-SSL connections cannot exceed the limit specified by &quot;Max Connections&quot;, the actual number of concurrent SSL connections allowed must be lower than this limit.', '', 'Integer number', '');
$this->db['memberVHRoot'] = new DATTR_HELP_ITEM("Member Virtual Host Root", 'Specifies the root directory of this virtual host. If left blank, the default virtual host root for this template will be used.<br/><br/>Note: This is <b>NOT</b> the document root. It is recommended to place all files related to the virtual host (like virtual host configuration, log files, html files, CGI scripts, etc.) under this directory. Virtual host root can be referred to as $VH_ROOT.', '', 'path', '');
$this->db['noCacheDomain'] = new DATTR_HELP_ITEM("No Cache Domain", 'A comma-separated list of domains that will not be cached.', '', 'Comma-separated list. Domain names are case insensitive and the leading &quot;www.&quot; should be removed. The wildcard characters &quot;*&quot; and &quot;?&quot; are allowed. &quot;?&quot; only replaces one character. &quot;*&quot; replaces any number of characters. For example, &quot;*.mydomain.com&quot; will match all subdomains of mydomain.com. Duplicate domain names are not allowed.', '');
$this->db['noCacheUrl'] = new DATTR_HELP_ITEM("Do-Not-Cache URL", 'A list of URL segments where any URL containing these listed segments will not be cached. String matching is used. Regular expressions are not supported. Can be set at the server or virtual host level. URL segments listed at the server level are inherited by all virtual hosts and added to their <b>Do-Not-Cache URL</b> lists.', 'You can add comments by starting a line with &quot;#&quot;.', '', '');
$this->db['nodeAddresses'] = new DATTR_HELP_ITEM("Node Address List", 'Specifies the addresses of the nodes belonging to this group. Attributes that can be specified for a node are &quot;Node Tag&quot; (used to match &quot;JVM Route&quot;), &quot;Source IP&quot;,  &quot;Destination IP&quot;, and &quot;Destination Port&quot;. &quot;Destination IP&quot; address is mandatory while other attributes are optional.', '', '[(Node Tag)][SourceIP->]DestinationAddress[:port]<br/><br/>Note:(NodeTag), SourceIP->, and :port are optional here.<br/><br/>Note: IPv6 addresses must be surrounded by square brackets &quot;[ ]&quot;  as seen in the following example.', '192.168.0.11, (node1)192.168.0.11,<br/>(node1)192.168.0.10->192.168.0.11:80, [2a0b:4342:4000:bd::d627]');
$this->db['note'] = new DATTR_HELP_ITEM("Notes", 'Add notes for yourself.', '', '', '');
$this->db['ocspCACerts'] = new DATTR_HELP_ITEM("OCSP CA Certificates", 'Specifies the location of the file where OCSP certificate authority (CA) certificates are stored. These certificates are used to check responses from the OCSP responder (and make sure those responses are not spoofed or otherwise compromised). This file should contain the whole certificate chain. If this file does not contain the root certificate, LSWS should be able to find the root certificate in your system directory without you adding it to the file, but, if this validation fails, you should try adding your root certificate to this file.<br/><br/>This setting is optional. If this setting is not set, the server will automatically check &quot;CA Certificate File&quot;.', '', 'Filename which can be an absolute path or a relative path to $SERVER_ROOT.', '');
$this->db['ocspRespMaxAge'] = new DATTR_HELP_ITEM("OCSP Response Max Age (secs)", 'This option sets the maximum allowable age for an OCSP response. If an OCSP response is older than this maximum age, the server will contact the OCSP responder for a new response. The default value is 86400. Maximum age can be turned off by setting this value to -1.', '', 'Integer of seconds', '');
$this->db['ocspResponder'] = new DATTR_HELP_ITEM("OCSP Responder", 'Specifies the URL of the OCSP responder to be used. If not set, the server will attempt to contact the OCSP responder detailed in the certificate authority&#039;s issuer certificate. Some issuer certificates may not have an OCSP responder URL specified.', '', 'URL starting with http://', 'http://rapidssl-ocsp.geotrust.com ');
$this->db['outBandwidth'] = new DATTR_HELP_ITEM("Outbound Bandwidth (bytes/sec)", 'The maximum allowed outgoing throughput to a single IP address, regardless of the number of connections established. The real bandwidth may end up being slightly higher than this setting for efficiency reasons. Bandwidth is allocated in 4KB units. Set to 0 to disable throttling. Per-client bandwidth limits (bytes/sec) can be set at the server or virtual host level where virtual host level settings override server level settings.', ' Set the bandwidth in 8KB units for better performance.<br/><br/> Trusted IPs or sub-networks are not affected.', 'Integer number', '');
$this->db['pagespeedActivate'] = new DATTR_HELP_ITEM("Activate PageSpeed", 'Choose whether or not to activate PageSpeed capabilites.', '', 'Select from radio box', '');
$this->db['pagespeedEnabled'] = new DATTR_HELP_ITEM("Enable PageSpeed Optimization", 'Choose whether or not to enable PageSpeed optimization.', 'This can be set at the Server Level and overridden at the Virtual Host Level.', 'Select from radio box', '');
$this->db['pagespeedParams'] = new DATTR_HELP_ITEM("PageSpeed Settings", 'Set parameters using Google default filter sets.', '', '', '<br /> pagespeed FileCachePath /tmp/lshttpd/pagespeed;<br/>pagespeed RewriteLevel CoreFilters;');
$this->db['pcKeepAliveTimeout'] = new DATTR_HELP_ITEM("Connection Keepalive Timeout", 'Specifies the maximum time in seconds to keep an idle persistent connection open.<br/><br/>When set to -1, the connection will never timeout. When set to 0 or greater, the connection will be closed after this time in seconds has passed.<br/><br/>Default value: 30', '', 'int', '');
$this->db['perClientConnLimit'] = new DATTR_HELP_ITEM("Per Client Throttling", 'These are connection control setting on a per client/IP basis. These settings help to mitigate DoS (Denied of Service) and DDoS (Distributed Denied of Service) attacks.', '', '', '');
$this->db['persistConn'] = new DATTR_HELP_ITEM("Persistent Connection", 'Specifies whether to keep the connection open after a request has been processed. Persistent connections can increase performance, but some FastCGI external applications do not support persistent connections fully. The default is &quot;On&quot;.<br/><br/>Default value: Yes', '', 'Select from radio box', '');
$this->db['pid'] = new DATTR_HELP_ITEM("PID", 'PID (Process ID) of the current server process.', 'The PID will change each time the server is restarted.', '', '');
$this->db['pingInterval'] = new DATTR_HELP_ITEM("Ping Interval (secs)", 'Specifies how often to ping a backend worker. For web server backend, an http request based on &quot;Ping URL&quot; will be sent. For other types of backends, an TCP connection attempt will be made to the backend server, if successful, the backend will be used as a good node.<br/><br/>Note: Set to 0 to disable ping.', '', 'Integer number', '');
$this->db['pingPath'] = new DATTR_HELP_ITEM("Ping Path", 'Changes ping target path, http(s)://IP:port/ by default, to http(s)://IP:port/path_value when a path is configured and &quot;Ping Interval (secs)&quot; is set to a non-zero value.<br/><br/>Note: All ZeroConf configured backends use the same target path.<br/><br/>Default value: Not Set', '', 'A path starting with &#039;/&#039;.', '');
$this->db['pingSmartFactor'] = new DATTR_HELP_ITEM("Smart Ping Factor", 'When set to 0, a ping is sent out at the configured &quot;Ping Interval (secs)&quot;.<br/><br/>When set to a non-zero value, all successful requests to the backend are also counted as a ping, meaning that a standard ping will only occur when the backend has not actively served any requests at the configured &quot;Ping Interval (secs)&quot;. In addition to this, when there are no open connections to the backend server, the ping interval is multiplied by the configured value effectively lengthening the configured &quot;Ping Interval (secs)&quot;.<br/><br/>Default value: 0', '', 'Integer value from 0 to 255.', 'All examples assume a ping interval of 30 seconds.<br/><br/>pingSmartFactor = 0: A ping is sent out every 30 seconds.<br/><br/>For the below cases, successful requests to the backend will also count as a ping.<br/><br/>Smart Ping Factor = 1: A ping is sent out every 30 seconds. When idle, a ping is sent out every 30 seconds.<br/>Smart Ping Factor = 2: A ping is sent out every 30 seconds. When idle, a ping is sent out every 60 seconds.<br/>Smart Ping Factor = 3: A ping is sent out every 30 seconds. When idle, a ping is sent out every 90 seconds.');
$this->db['pingUrl'] = new DATTR_HELP_ITEM("Ping URL", 'Specifies an HTTP URL that is used to verify the availability of a web server backend worker. Has no effect to other type of workers.', '', 'URL', '');
$this->db['pubStoreExpireMinutes'] = new DATTR_HELP_ITEM("Public Storage Expire (minutes)", 'The maximum age of a cached file before the server will attempt to physically remove it. This removal operation will occur once per day to prevent cache storage from growing too large. Minimum setting is 60 minutes.', 'Set this value to a time greater than your longest TTL to help prevent the removal of still valid cache files.', 'Integer number', '');
$this->db['purgeNoHitTimeout'] = new DATTR_HELP_ITEM("No Hit Expire (minutes)", 'The maximum number of minutes a cached file will remain in cache storage without a cache hit before being physically removed by the server. Set to 0 to disable this feature.<br/><br/>Default value: 0', '', 'Integer number', '');
$this->db['quicBadPacketRate'] = new DATTR_HELP_ITEM("Bad Packet Rate", 'The number of bad packets X needed in an interval of Y seconds to trigger QUIC DoS Mitigation. Supplying a value of 0 for either X or Y will disable this feature.<br/><br/>Default value: 4000/4', '', 'X/Y where X is the number of events, Y is the interval in seconds (0 - 30)', '');
$this->db['quicBasePLPMTU'] = new DATTR_HELP_ITEM("PLPMTU Base Value", 'The maximum value of PLPMTU (maximum packet size without headers) in bytes that QUIC will use by default. Setting this to 0 will allow QUIC to pick the size.<br/><br/>This setting should be set lower than &quot;PLPMTU Max Value&quot;.<br/><br/>Default value: 0', '', '0 or integer number between 1200 and 65527', '');
$this->db['quicCfcw'] = new DATTR_HELP_ITEM("Connection Flow Control Window", 'The initial size of the buffer allocated for a QUIC connection. Default value is 1.5M.', 'A larger window size will use more memory.', 'Number between 64K and 512M', '');
$this->db['quicCongestionCtrl'] = new DATTR_HELP_ITEM("Congestion Control", 'The congestion control algorithm used. This can be set manually or left up to the QUIC library in use by selecting the &quot;Default&quot; option.<br/><br/>Default value: Default', '', 'Select from drop down list', '');
$this->db['quicDosMitigationDuration'] = new DATTR_HELP_ITEM("QUIC DoS Mitigation Duration (secs)", 'How long, once triggered, the server will stay in DoS mitigation mode. After this many seconds have passed, the server will revert to it&#039;s normal mode. Set this to 0 to disable DoS Mitigation mode.<br/><br/>In DoS Mitigation mode, new clients are required to verify their IP address with a special &#039;retry&#039; packet. Once verified, the requests proceed as normal.<br/><br/>Default value: 120', '', 'Integer number between 0 and 86400', '');
$this->db['quicEnable'] = new DATTR_HELP_ITEM("Enable HTTP3/QUIC", 'Enables the HTTP3/QUIC network protocol server wide. Default value is Yes.', 'When this setting is set to Yes, HTTP3/QUIC can still be disabled at the listener level through the &quot;Open HTTP3/QUIC (UDP) port&quot; setting, or at the virtual host level through the &quot;Enable HTTP3/QUIC&quot; setting.', 'Select from radio box', '');
$this->db['quicEnableDPLPMTUD'] = new DATTR_HELP_ITEM("Enable DPLPMTUD", 'Enable Datagram Packetization Layer Path Maximum Transmission Unit Discovery (DPLPMTUD).<br/><br/><b>   <a href="     https://tools.ietf.org/html/rfc8899   " target="_blank" rel="noopener noreferrer">     Background on DPLPMTUD (RFC 8899)   </a> </b><br/><br/>Default value: Yes', '', 'Select from radio box', '');
$this->db['quicHandshakeTimeout'] = new DATTR_HELP_ITEM("Handshake Timeout", 'The time in seconds a new QUIC connection is given to complete its handshake, after which the connection is aborted. Default value is 10.', '', 'Integer number between 1 and 15', '');
$this->db['quicHskNewRate'] = new DATTR_HELP_ITEM("New Handshake Rate", 'The number of new handshakes X needed in an interval of Y seconds to trigger QUIC DoS Mitigation. Supplying a value of 0 for either X or Y will disable this feature.<br/><br/>Default value: 90/3', '', 'X/Y where X is the number of events, Y is the interval in seconds (0 - 30)', '');
$this->db['quicHskTimeoutRate'] = new DATTR_HELP_ITEM("Timed Out Handshake Rate", 'The number of handshake timeouts X needed in an interval of Y seconds to trigger QUIC DoS Mitigation. Supplying a value of 0 for either X or Y will disable this feature.<br/><br/>Default value: 40/4', '', 'X/Y where X is the number of events, Y is the interval in seconds (0 - 30)', '');
$this->db['quicIdleTimeout'] = new DATTR_HELP_ITEM("Idle Timeout", 'The time in seconds after which an idle QUIC connection will be closed. Default value is 30.', '', 'Integer number between 10 and 30', '');
$this->db['quicInitMaxIncomingStreamsBidi'] = new DATTR_HELP_ITEM("HTTP/3 Initial Incoming Streams", 'The maximum number of incoming concurrent QUIC/H3 streams.<br/><br/>Default value: 100', ' This setting can be increased to help in situations where there are an abnormally large number of concurrent streams, such as inactive concurrent streams not closing when finished.', 'integer number between 10 and 1000.', '');
$this->db['quicMaxCfcw'] = new DATTR_HELP_ITEM("Max Connection Flow Control Window", 'Specifies the maximum size that a connection flow control window buffer is allowed to reach due to window auto-tuning.<br/><br/>Default value is 0, which means that the value of &quot;Connection Flow Control Window&quot; is used and no auto-tuning is performed.', 'A larger window size will use more memory.', '0 or a number between 64K and 512M', '');
$this->db['quicMaxPLPMTU'] = new DATTR_HELP_ITEM("PLPMTU Max Value", 'The PLPMTU (maximum packet size without headers) probe upper limit in bytes. This setting is used to limit the &quot;maximum packet size&quot; in the DPLPMTUD search space.  Setting this to 0 will allow QUIC to pick the size (By default LSQUIC assumes that MTU is 1,500 bytes (Ethernet)).<br/><br/>This setting should be set higher than &quot;PLPMTU Base Value&quot;.<br/>Default value: 0', '', '0 or integer number between 1200 and 65527', '');
$this->db['quicMaxSfcw'] = new DATTR_HELP_ITEM("Max Stream Flow Control Window", 'Specifies the maximum size that a stream flow control window is allowed to reach due to window auto-tuning.<br/><br/>Default value is 0, which means that the value of &quot;Stream Flow Control Window&quot; is used and no auto-tuning is performed.', 'A larger window size will use more memory.', '0 or a number between 64K and 128M', '');
$this->db['quicMaxStreams'] = new DATTR_HELP_ITEM("Max Concurrent Streams Per Connection", 'The maximum number of concurrent streams allowed per QUIC connection. Default value is 100.', '', 'Integer number between 10 and 1000', '');
$this->db['quicSfcw'] = new DATTR_HELP_ITEM("Stream Flow Control Window", 'The initial amount of data a QUIC connection is willing to receive per stream. Default value is 1M.', 'A larger window size will use more memory.', 'Number between 64K and 128M', '');
$this->db['quicShmDir'] = new DATTR_HELP_ITEM("QUIC SHM Directory", 'Specifies the directory used to save QUIC data to shared memory.<br/><br/>By default, the server&#039;s default SHM directory, /dev/shm, will be used.', 'A RAM based partition, such as /dev/shm, is recommended.', 'Path', '');
$this->db['quicVersions'] = new DATTR_HELP_ITEM("HTTP3/QUIC Versions", 'A list of enabled HTTP3/QUIC versions. This setting should only be used to limit HTTP3/QUIC support to the versions listed and is best left blank.', 'It is recommended to leave this setting blank to have the the best configuration applied automatically.', 'Comma-separated list', 'h3-29, h3-Q050');
$this->db['ramDiskPath'] = new DATTR_HELP_ITEM("RAM Disk Path", 'Setting the RAM Disk Path allows you to designate the location of a RAM disk. A RAM disk is a world-writable directory stored in memory. A server with excess RAM can reduce disk I/O by serving content from this RAM disk. Accessing content from RAM is much faster than reading data from the disk. LSWS will use this RAM disk to optimize performance when there is enough memory available.<br/><br/>(The RAM disk must be designated in your OS setup before it can be used by the web server. Many Linux distributions assign /dev/shm as a RAM disk by default, but these settings depend on your OS.)', '', 'path', '');
$this->db['rcvBufSize'] = new DATTR_HELP_ITEM("Receive Buffer Size (bytes)", 'The receiving buffer size of each TCP socket. 512K is the maximum allowed buffer size.', ' It is recommended to leave this value as &quot;Not Set&quot; or set to 0 to use the operating system&#039;s default buffer size.<br/> A large receive buffer will increase performance when processing  incoming requests with large payloads, i.e. file uploads.<br/> Setting this to a lower value will reduce throughput and memory usage per socket allowing the server to have more concurrent sockets when memory is a bottleneck.', 'Integer number', '');
$this->db['realm'] = new DATTR_HELP_ITEM("Realm", 'Specifies the authorization realm for this context. When specified, a valid username and password must be provided in order to access this context. &quot;Authorization Realms&quot; are set up in the &quot;Virtual Host Security&quot; section. This setting uses each realm&#039;s &quot;Realm Name&quot;.', '', 'Select from drop down list', '');
$this->db['realmName'] = new DATTR_HELP_ITEM("Realm Name", 'Specifies a unique name for the authorization realm.', '', '', '');
$this->db['realmType'] = new DATTR_HELP_ITEM("DB Type", 'Specifies how user/group data is stored for an authorization realm. Currently, user/group data can be stored in flat files or on a LDAP server.', '', 'Select from drop down list', '');
$this->db['realms'] = new DATTR_HELP_ITEM("Authorization Realms", 'Lists all authorization realms for this virtual host. Authorization realms are used to block unauthorized users from accessing protected web pages. A realm is a user directory containing usernames and passwords with optional group classifications. Authorization is performed at the context level. Because different contexts can share the same realm (user database), realms are defined separately from the contexts that use them. You can refer to a realm by these names in a contexts configuration.', '', '', '');
$this->db['realtimerpt'] = new DATTR_HELP_ITEM("Real-Time Statistics", 'The Real-Time Statistics link leads to a page with a real-time server status report. This is a convenient tool to monitor the system.    The report shows a snapshot of your server statistics. The refresh rate for this snapshot  is controlled by the Refresh Interval drop-down list in the upper righthand corner.   The report contains the following sections: <ul><li>Server Health shows the basic server statistics, uptime, load, and anti-DDoS blocked IPs.</li>   <li>Server lists current traffic throughput, connections, and requests statistics.</li>  <li>Virtual Host shows request processing statuses and external application statuses for each virtual host.</li>  <li>External Application lists the external applications currently running and their usage statistics.   The CGI daemon process lscgid is always running as an external application.</li> </ul>   Many of the rows in the Real-Time Statistics feature a graph icon.  Clicking on this icon will open a graph of that row&#039;s statistics updated in real-time.   In the Server section, next to Requests, there is a link labeled (Details).  This link takes you to the Requests Snapshot, where you can view detailed information  on which clients are making certain kinds of requests or which aspects of your site  are bottlenecking. The fields in the blue area allow you to filter the snapshot to isolate  certain parts of your server or look for clients that are performing certain actions.', '', '', '');
$this->db['recaptchaAllowedRobotHits'] = new DATTR_HELP_ITEM("Allowed Robot Hits", 'Number of hits per 10 seconds to allow ‘good bots’ to pass. Bots will still be throttled when the server is under load.<br/><br/>Default value is 3.', '', 'Integer number', '');
$this->db['recaptchaBotWhiteList'] = new DATTR_HELP_ITEM("Bot White List", 'List of custom user agents to allow access. Will be subject to the ‘good bots’ limitations, including allowedRobotHits.', '', 'List of user agents, one per line. Regex is supported.', '');
$this->db['recaptchaMaxTries'] = new DATTR_HELP_ITEM("Max Tries", 'Max Tries specifies the maximum number of reCAPTCHA attempts permitted before denying the visitor.<br/><br/>Default value is 3.', '', 'Integer number', '');
$this->db['recaptchaRegConnLimit'] = new DATTR_HELP_ITEM("Connection Limit", 'The number of concurrent connections (SSL & non-SSL) needed to activate reCAPTCHA. reCAPTCHA will be used until concurrent connections drop below this number.<br/><br/>Default value is 15000.', '', 'Integer number', '');
$this->db['recaptchaSecretKey'] = new DATTR_HELP_ITEM("Secret Key", 'The secret key is the private key provided by Google via its reCAPTCHA service. A default Secret Key will be used if not set.', '', '', '');
$this->db['recaptchaSiteKey'] = new DATTR_HELP_ITEM("Site Key", 'The site key is the public key provided by Google via its reCAPTCHA service. A default Site Key will be used if not set.', '', '', '');
$this->db['recaptchaSslConnLimit'] = new DATTR_HELP_ITEM("SSL Connection Limit", 'The number of concurrent SSL connections needed to activate reCAPTCHA. reCAPTCHA will be used until concurrent connections drop below this number.<br/><br/>Default value is 10000.', '', 'Integer number', '');
$this->db['recaptchaType'] = new DATTR_HELP_ITEM("reCAPTCHA Type", 'Specify the reCAPTCHA type to use with the key pairs.<br/>If a key pair has not been provided and this setting is set to Not Set, a default key pair of type Invisible will be used.<br/><br/>Checkbox will display a checkbox reCAPTCHA for the visitor to validate.<br/><br/>Invisible will attempt to validate the reCAPTCHA automatically and if successful, will redirect to the desired page.<br/><br/>hCaptcha can be used to support reCAPTCHA provider <a href="https://www.hcaptcha.com" target="_blank" rel="noopener noreferrer">hCaptcha</a>.<br/><br/>Default value is Invisible.', '', 'Select from drop down list', '');
$this->db['recaptchaVhReqLimit'] = new DATTR_HELP_ITEM("Concurrent Request Limit", 'The number of concurrent requests needed to activate reCAPTCHA. reCAPTCHA will be used until concurrent requests drop below this number.<br/><br/>Default value is 15000.', '', 'Integer number', '');
$this->db['redirectContext'] = new DATTR_HELP_ITEM("Redirect Context", 'A Redirect Context can be used to forward one URI or a group of URIs to another location. The destination URI can be either on the same web site (internal redirect) or an absolute URI pointing to another web site (external redirect).', '', '', '');
$this->db['renegProtection'] = new DATTR_HELP_ITEM("SSL Renegotiation Protection", 'Specifies whether to enable SSL Renegotiation Protection to defend against SSL handshake-based attacks. The default value is &quot;Yes&quot;.', 'This setting can be enabled at the listener and virtual host levels.', 'Select from radio box', '');
$this->db['replicationStatus'] = new DATTR_HELP_ITEM("Replication Status", 'Displays the status of currently &quot;live&quot; replicators in the replication cluster by their server addresses, as well as the number of active sessions on record for each replicator. The source replicator (usually the first to come online) will have a highlighted <b>SRC</b> tag in front of it&#039;s Server Address. It is this replicators job to actively sync it&#039;s data to the other replicators in the replication cluster. These other replicators will be compared against the source replicator to determine if they are &quot;in Sync&quot; or &quot;out of Sync&quot;. <br /><br /> <b>SSL Session</b> will show the number of currently cached SSL sessions for the current load balancer. <br /><br /> <b>ID Session</b> will show the session count in the session cache of each cluster defined in the load balancer. <br /><br /> Replication will happen in real-time as changes are written to shared memory.', '', '', '');
$this->db['reqCensorshipRule'] = new DATTR_HELP_ITEM("Web Application Firewall (WAF) Rule Set", 'Rules configured here only work for virtual hosts configured with a native LSWS configuration, not for virtual hosts using Apache httpd.conf.', '', '', '');
$this->db['required'] = new DATTR_HELP_ITEM("Require (Authorized Users/Groups)", 'Specifies which user/group can access this context. This allows you to use one user/group database (specified in &quot;Realm&quot;) across a number of contexts, but only allow certain users/groups from that database to access this context.', '', 'Syntax is compatible with Apache&#039;s Require directive. For example: <ul> <li>user username [username ...]<br/>Only listed users can access this context.</li> <li> group groupid [groupid ...]<br/>Only users belonging to the listed groups can access this context.</li> </ul> If this setting is not specified, all valid users will be allowed to access this resource.', '');
$this->db['respBuffer'] = new DATTR_HELP_ITEM("Response Buffering", 'Specifies whether to buffer responses received from external applications. If a &quot;nph-&quot; (Non-Parsed-Header) script is detected, buffering is turned off for responses with full HTTP headers.<br/><br/>Default value: Yes', '', 'Select from drop down list', '');
$this->db['respectCacheable'] = new DATTR_HELP_ITEM("Respect Cacheable", 'Respect the value of regular &quot;Cache-Control&quot; response headers when LiteSpeed-specific cache control has not been provided.<br/><br/>LiteSpeed-specific cache control includes the X-litespeed-cache-control response header and the cache-control environment variable set via rewrite rule.', 'This setting is enabled by default.', 'Select from radio box', '');
$this->db['restart'] = new DATTR_HELP_ITEM("Apply Changes/Graceful Restart", 'By clicking Graceful Restart, a new server process will be started.  For Graceful Restart, the old server process will only exit after all requests  to it have been finished (or the &quot;Graceful Restart Timeout (secs)&quot; limit has been reached).   Configuration changes are applied at the next restart.  Graceful Restart will apply these changes without any server downtime.', 'Graceful restart takes less than 2 seconds to generate a new server process.', '', '');
$this->db['retryTimeout'] = new DATTR_HELP_ITEM("Retry Timeout (secs)", 'Specifies the period of time that the server waits before retrying an external application that had a prior communication problem.<br/><br/>Default value: 10', '', 'Integer number', '');
$this->db['reverseDnsLookup'] = new DATTR_HELP_ITEM("Reverse DNS Lookup", 'Perform an IP -> Domain Name lookup for each client. This can be used in access logging.<br/><br/>Default value: No', '', 'Select from radio box', '');
$this->db['rewriteBase'] = new DATTR_HELP_ITEM("Rewrite Base", 'Specifies the base URL for rewrite rules.', '', 'URL', '');
$this->db['rewriteInherit'] = new DATTR_HELP_ITEM("Rewrite Inherit", 'Specifies whether to inherit rewrite rules from parent contexts. If rewrite is enabled and not inherited, rewrite base and rewrite rules defined in this context will be used.', '', 'Select from radio box', '');
$this->db['rewriteLogLevel'] = new DATTR_HELP_ITEM("Log Level", 'Specifies the log level of the rewrite engine debug output. Value ranges from 0 - 9, 0 will disable logging and 9 will produce the most detailed log. The log level of the server error log must be set to at least INFO for this option to take effect. This is useful when testing rewrite rules.', '', 'Integer number', '');
$this->db['rewriteMapLocation'] = new DATTR_HELP_ITEM("Location", 'Specifies the location of the rewrite map using the syntax MapType:MapSource.<br/>LiteSpeed&#039;s rewrite engine supports three types of rewrite maps: <ul> 	<li><b>Standard Plain Text</b> <blockquote> 		<b>MapType:</b> txt; <br/>		<b>MapSource:</b> file path to a valid plain ASCII file.  </blockquote> 		Each line of this file should contain two elements separated  		by blank spaces. The first element is the key and the second 		element is the value. Comments can be added with a leading &quot;#&quot; 		sign.  	</li> 	<li><b>Randomized Plain Text</b> <blockquote> 		<b>MapType:</b> rnd;<br/>		<b>MapSource:</b> file path of a valid plain ASCII file. </blockquote> 		File format is similar to the Standard Plain Text file, except that the 		second element can contain multiple choices separated by a &quot;|&quot; 		sign and chosen randomly by the rewrite engine. 	</li> 	<li><b>Internal Function</b> <blockquote> 	    <b>MapType:</b> int;<br/>		<b>MapSource:</b> Internal string function  </blockquote> 		4 functions are available: 		<ul> 			<li><b>toupper:</b> converts lookup key to upper cases.</li> 			<li><b>tolower:</b> converts lookup key to lower cases.</li> 			<li><b>escape:</b> perform URL encoding on lookup key.</li> 			<li><b>unescape:</b> perform URL decoding on lookup key.</li> 		</ul> 	</li> 	The following map types available in Apache 	have not been implemented in LiteSpeed:<br/>Hash File and External Rewriting Program. </ul> The implementation of LiteSpeed&#039;s rewrite engine follows the specifications of Apache&#039;s rewrite engine. For more details about rewrite map, please refer to <a href="http://httpd.apache.org/docs/current/mod/mod_rewrite.html" target="_blank" rel="noopener noreferrer">Apache&#039;s mod_rewrite document</a>.', '', 'String', '');
$this->db['rewriteMapName'] = new DATTR_HELP_ITEM("Name", 'Specifies a unique name for the rewrite map at the virtual host  level. This name will be used by a mapping-reference in rewrite rules. When referencing this name, one of the following syntaxes should be used: <blockquote><code> $\{MapName:LookupKey\}<br/>$\{MapName:LookupKey|DefaultValue\} </code></blockquote><br/>The implementation of LiteSpeed&#039;s rewrite engine follows the specifications of Apache&#039;s rewrite engine. For more details about rewrite maps, please refer to <a href="http://httpd.apache.org/docs/current/mod/mod_rewrite.html" target="_blank" rel="noopener noreferrer">Apache&#039;s mod_rewrite document</a>.', '', 'string', '');
$this->db['rewriteRules'] = new DATTR_HELP_ITEM("Rewrite Rules", 'Specifies a list of rewrite rules at the virtual host level.<br/><br/>Do NOT add any document root level rewrite rules here. If you have any document root level rewrite rules from .htaccess, you should instead create a static context with uri &quot;/&quot; and add the rewrite rules there.<br/><br/>A rewrite rule is comprised of one RewriteRule directive and optionally preceded by multiple RewriteCond directives. <ul>   <li>Each directive should take only one line.</li>   <li>     RewriteCond and RewriteRule follow Apache&#039;s rewrite     directive syntax. Just copy and paste rewrite directives from your Apache     configuration files.   </li>   <li>     There are minor differences between LiteSpeed and Apache mod_rewrite     implementation:     <ul>       <li>         %\{LA-U:variable\} and %\{LA-F:variable\} are ignored         by the LiteSpeed rewrite engine       </li>       <li>         Two new server variables are added in the LiteSpeed rewrite engine:         %\{CURRENT_URI\} represents the current URI being processed by         the rewrite engine and %\{SCRIPT_NAME\} has the same  meaning         as the corresponding CGI environment variable.       </li>       <li>         The LiteSpeed rewrite engine will stop processing rewrite rules after         encountering an [L] flag to avoid looping while Apache         mod_rewrite will stop processing rewrite rules for the current         iteration only. This behavior is similar to that of the [END]         flag in Apache mod_rewrite.       </li>     </ul>   </li> </ul><br/>The implementation of LiteSpeed&#039;s rewrite engine follows Apache&#039;s rewrite engine specifications. For more details about rewrite rules, please refer to <a href="https://httpd.apache.org/docs/current/mod/mod_rewrite.html" target="_blank" rel="noopener noreferrer">   Apache&#039;s mod_rewrite document </a> and <a href="https://httpd.apache.org/docs/current/rewrite/" target="_blank" rel="noopener noreferrer">   Apache&#039;s URL rewriting guide </a>.', '', 'string', '');
$this->db['ruleSetAction'] = new DATTR_HELP_ITEM("Rule Set Action", 'Specifies the actions that should be taken when a censoring rule in current ruleset is met. If not set, &quot;Default Action&quot; will be used.', '', 'String. This action string uses the same syntax as Apache&#039;s <a href="   https://github.com/SpiderLabs/ModSecurity/wiki/Reference-Manual#SecDefaultAction " target="_blank" rel="noopener noreferrer">   mod_security SecDefaultAction directive </a> .', '');
$this->db['runningAs'] = new DATTR_HELP_ITEM("Running As", 'Specifies the user/group that the server process runs as. This value is set during installation. In order to change it, you must download the installation package and perform an upgrade via the command line.', ' Server should not be run as a privileged user, such as &quot;root&quot;. It is critical that the server is configured to run as an un-privileged user/group combination that does not have login/shell access. A user and group of nobody is generally a good choice.', '', '');
$this->db['scanPOST'] = new DATTR_HELP_ITEM("Scan Request Body", 'Specifies whether to check the body of an HTTP POST request.  Default is &quot;No&quot;.', '', 'Select from radio box', '');
$this->db['secAuditLog'] = new DATTR_HELP_ITEM("Security Audit Log", 'Specifies the path of the security audit log, which gives more detailed information.   This extra information can be useful if, for example, you wish to track the actions of   a particular user. Use &quot;Enable Security Audit Log&quot; to turn on the logging.', '', 'Filename which can be an absolute path or a relative path to $SERVER_ROOT.', '');
$this->db['secAuditLogEngine'] = new DATTR_HELP_ITEM("Enable Security Audit Log", 'Specifies whether to enable audit logging and in what format (Native, JSON, or Pretty JSON). This feature is equivalent to Apache&#039;s mod_security audit engine.<br/><br/>If this setting is enabled and the &quot;Security Audit Log&quot; setting is set, detailed request information will be saved.', '', 'Select from drop down list', '');
$this->db['servAction'] = new DATTR_HELP_ITEM("Actions", 'Six actions are available from this menu: Graceful Restart, Toggle Debug Logging, Server Log Viewer, Real-Time Statistics,  Version Manager, and Compile PHP.  <ul><li>&quot;Apply Changes/Graceful Restart&quot; restarts server process gracefully without interrupting requests in process.</li> 	<li>&quot;Toggle Debug Logging&quot; turns debug logging on or off.</li> 	<li>&quot;Server Log Viewer&quot; allows you to view the server log through the log viewer.</li> 	<li>&quot;Real-Time Statistics&quot; allows you to view real-time server status.</li> 	<li>&quot;Version Management&quot; allows you to download new versions of LSWS and switch between different versions. 	<li>Compile PHP allows you to compile PHP for LiteSpeed Web Server. </ul>', 'The shell utility $SERVER_ROOT/bin/lswsctrl can be used to control the server processes as well,  but requires a login shell.', '', '');
$this->db['servChrootPath'] = new DATTR_HELP_ITEM("Chroot Path", ' Specifies the directory where the chroot environment is rooted. Only &quot;root&quot; user can run the server in chroot mode. Whether to run in chroot mode is controlled by &quot;Enable chroot&quot; option. The installer program will set up the initial chroot environment automatically. This entry is read-only, and if you want to change it, please run the installer again from the command line.<br/><br/>In the chroot environment, the server and its child processes cannot access file systems outside of the chroot jail. Chroot is an advanced security feature and additional administration may be required to make it work properly. All required executables, libraries, configuration files, and device files should be recreated within the chroot jail.<br/><br/>As the root directory is changed, you need to pay special attention to path configuration when an absolute path is used. A Unix domain socket or swapping directory is always relative to the new root directory. All other path configurations are always relative to the real root.', ' Use chroot for better security.', '', '');
$this->db['serverName'] = new DATTR_HELP_ITEM("Server Name", 'A unique name for this server. You can use $HOSTNAME as value.', '', '', '');
$this->db['serverPriority'] = new DATTR_HELP_ITEM("Priority", 'Specifies priority of the server processes. Value ranges from -20 to 20. A lower number equates to a higher priority.', ' Usually a higher priority leads to slightly higher web performance on a busy server. Do not set priority higher than that of database processes.', 'Integer number', '');
$this->db['sessionExMethod'] = new DATTR_HELP_ITEM("Session Extraction", 'Specify how to extract session ID from request.<br/><br/><b>IP Address:</b> Uses Client IP as session ID.<br/><br/><b>Basic Authentication:</b> Uses username in the basic authentication as session ID.<br/><br/><b>Query String:</b> Uses a Parameter in request query string as session ID.<br/><br/><b>Cookies:</b> Uses a Parameter in cookie as session ID.<br/><br/><b>SSL Session:</b> Uses SSL Session ID as session ID.<br/><br/><b>JVM Route:</b> JVM Route is an extra section appended to a Servlet session ID, which used to identify servlet backend. <b>Example:</b> JSESSIONID=344BA8002DE6FBE2QDF25.tomcat1<br/><br/><b>URL Path Parameter:</b> Uses a URL Path Parameter as session ID.', 'For Layer 4 Load Balancers, only the IP Address extraction method will work.  For Layer 7 Load Balancers, any of the above methods will work.', 'Select from checkbox', '');
$this->db['sessionId'] = new DATTR_HELP_ITEM("Session ID String", 'Specifies the Session ID string. The string is used to extract the session id value from cookie, query string and URL path parameter.', '', '', '');
$this->db['sessionTimeout'] = new DATTR_HELP_ITEM("Session Timeout", 'Specify for how long a session will be valid, in seconds.', '', 'Integer number', '');
$this->db['shmDefaultDir'] = new DATTR_HELP_ITEM("Default SHM Directory", 'Changes shared memory&#039;s default directory to the specified path. If the directory does not exist, it will be created. All SHM data will be stored in this directory unless otherwise specified.', '', 'path', '');
$this->db['showBackend'] = new DATTR_HELP_ITEM("Show Backend In Header", 'Add response header &#039;x-lsadc-backend&#039; which indicates that backend server that served the request. The header&#039;s value is a concatenation of the cluster name and the backend IP and port.<br/><br/>Default value: No', '', 'Select from radio box', '&quot;x-lsadc-backend: clusterHTTP_10.10.15.11:443&quot;');
$this->db['showVersionNumber'] = new DATTR_HELP_ITEM("Server Signature", 'Specifies whether to show the server signature and version number in the response header&#039;s &quot;Server&quot; value. There are three options: when set to Hide Version, only LiteSpeed is shown. When set to Show Version, LiteSpeed and the version number are shown.  When set to Hide Full Header, the entire Server header will not be shown in the response header.', ' Set to Hide Version if you do not wish to expose the server version number.', 'Select from drop down list', '');
$this->db['sname'] = new DATTR_HELP_ITEM("Name - Server", 'The unique name that identifies this server. This is the  &quot;Server Name&quot; specified in the general configuration.', '', '', '');
$this->db['sndBufSize'] = new DATTR_HELP_ITEM("Send Buffer Size (bytes)", 'The sending buffer size of each TCP socket. 512K is the maximum allowed buffer size.', ' It is recommended to leave this value as &quot;Not Set&quot; or set to 0 to use the operating system&#039;s default buffer size.<br/> If your web site serves large static files, increase the send buffer  size to improve performance.<br/> Setting this to a lower value will reduce throughput and memory usage per socket allowing the server to have more concurrent sockets when memory is a bottleneck.', 'Integer number', '');
$this->db['softLimit'] = new DATTR_HELP_ITEM("Connection Soft Limit", 'Specifies the soft limit of concurrent connections allowed from one IP. This soft limit can be exceeded temporarily during &quot;Grace Period (sec)&quot; as long as the number is below the &quot;Connection Hard Limit&quot;, but Keep-Alive connections will be closed as soon as possible until the number of connections is lower than the limit. If number of connections is still over the limit after the &quot;Grace Period (sec)&quot;, that IP will be blocked for the &quot;Banned Period (sec)&quot;.<br/><br/>For example, if a page contains many small graphs, the browser may try to set up many connections at same time, especially for HTTP/1.0 clients. You would want to allow those connections for a short period.<br/><br/>HTTP/1.1 clients may also set up multiple connections to speed up downloading and SSL  requires separate connections from non-SSL connections. Make sure the limit is set properly,  as not to adversely affect normal service. The recommended limit is between 5 and 10.', ' A lower number will enable serving more distinct clients.<br/> Trusted IPs or sub-networks are not affected.<br/> Set to a high value when you are performing benchmark tests with a large number of concurrent client machines.', 'Integer number', '');
$this->db['sourceIP'] = new DATTR_HELP_ITEM("Source IP", 'Specifies a Source IP for connecting to the backend worker. It can be overridden in worker configuration.', '', 'Select from drop down list', '');
$this->db['sslCert'] = new DATTR_HELP_ITEM("SSL Private Key & Certificate", 'Every SSL listener requires a paired SSL private key and SSL certificate. Multiple SSL listeners can share the same key and certificate.<br/><br/>You can generate SSL private keys yourself using an SSL software package, such as OpenSSL. SSL certificates can also be purchased from an authorized certificate issuer like VeriSign or Thawte. You can also sign the certificate yourself. Self-signed certificates will not be trusted by web browsers and should not be used on public websites containing critical data. However, a self-signed certificate is good enough for internal use, e.g. for encrypting traffic to LiteSpeed Web Server&#039;s WebAdmin Console.', '', '', '');
$this->db['sslDefaultCiphers'] = new DATTR_HELP_ITEM("Default Cipher Suite", 'Default cipher suite for SSL certificates.<br/><br/>Default value: Server Internal Default (Based on current best practices)', '', 'Colon-separated string of cipher specifications.', '');
$this->db['sslDynCertsBaseDir'] = new DATTR_HELP_ITEM("SSL Dynamic Certificates Base Dir", 'Sets the base directory that dynamic ssl certificates will be stored in. Certificates, keys, and CA Bundles are expected to be named &quot;cert&quot;, &quot;key&quot;, and &quot;ca&quot;, respectively.', '', 'Path', '$SERVER_ROOT/certStore/');
$this->db['sslDynCertsCiphers'] = new DATTR_HELP_ITEM("SSL Dynamic Certificates Cipher Suite", 'Specifies a custom cipher suite for the Dynamic SNI certificates.<br/><br/>Default value: Use server default ciphers', '', 'Colon-separated string of cipher specifications.', '');
$this->db['sslDynCertsExpire'] = new DATTR_HELP_ITEM("SSL Dynamic Certificates Expire Time (secs)", 'Sets the expire time of a dynamically loaded certificate before it is invalidated.', '', 'Integer number', '');
$this->db['sslDynCertsNumLevels'] = new DATTR_HELP_ITEM("SSL Dynamic Certificates Levels", 'The number of directory levels the certificate files will be in.<br/><br/>This is similar to PHP&#039;s <b>   <a href="     http://php.net/manual/en/session.configuration.php#ini.session.save-path   " target="_blank" rel="noopener noreferrer">     Session.save_path   </a> </b>', '', 'Integer number', 'If set to 2, &quot;example.com&quot; would be in BaseDir/e/x/example.com/');
$this->db['sslDynCertsRefresh'] = new DATTR_HELP_ITEM("SSL Dynamic Certificates Refresh Time (secs)", 'Sets the refresh time of a dynamically loaded certificate before it will check for file validity. If the file is removed before refresh time, the cert will be invalidated. If the file is updated before refresh time, the cert will be updated.', '', 'Integer number', '');
$this->db['sslDynSNI'] = new DATTR_HELP_ITEM("SSL Dynamic SNI", 'SSL Dynamic SNI enables you to avoid using the load balancer&#039;s generic certificates by specifying a directory that the load balancer can then use to serve clients site specific certificates when handling requests.', '', '', '');
$this->db['sslEnableMultiCerts'] = new DATTR_HELP_ITEM("Enable Multiple SSL Certificates", 'Allows listeners/vhosts to set multiple SSL certificates.  If multiple certificates are enabled, the certificates/keys are expected to follow a naming scheme.  If the cert is named server.crt, other possible cert names are server.crt.rsa, server.crt.dsa, server.crt.ecc. If &quot;Not Set&quot;, defaults to &quot;No&quot;.', '', 'Select from radio box', '');
$this->db['sslOCSP'] = new DATTR_HELP_ITEM("OCSP Stapling", 'Online Certificate Status Protocol (OCSP) is a more efficient method of checking whether a digital certificate is valid. It works by communicating with another server — the OCSP responder — to get verification that the certificate is valid instead of checking through certificate revocation lists (CRL).<br/><br/>OCSP stapling is a further improvement on this protocol, allowing the server to check with the OCSP responder at regular intervals instead of every time a certificate is requested. See the <a href="http://en.wikipedia.org/wiki/OCSP_Stapling" target="_blank" rel="noopener noreferrer">OCSP Wikipedia page</a> for more details.', '', '', '');
$this->db['sslOcspProxy'] = new DATTR_HELP_ITEM("OCSP Proxy", 'Socket address used as the proxy server address for OCSP verification. Leave this setting unset If not using a proxy.<br/><br/>Default value: not set', '', 'Socket Address', '');
$this->db['sslProtocolSetting'] = new DATTR_HELP_ITEM("SSL Protocol", 'Customizes SSL protocols accepted by the listener.', '', '', '');
$this->db['sslSessionCache'] = new DATTR_HELP_ITEM("Enable Session Cache", 'Enables session id caching using OpenSSL&#039;s default setting. Default value is &quot;No&quot;.', '', 'Select from radio box', '');
$this->db['sslSessionCacheSize'] = new DATTR_HELP_ITEM("Session Cache Size (bytes)", 'Sets the maximum number of SSL session IDs to store in the cache. Default is 1,000,000.', '', 'Integer number', '');
$this->db['sslSessionCacheTimeout'] = new DATTR_HELP_ITEM("Session Cache Timeout (secs)", 'This value determines how long a session ID will be valid within the cache before renegotiation is required. Default is 3,600.', '', 'Integer number', '');
$this->db['sslSessionTicketKeyFile'] = new DATTR_HELP_ITEM("SSL Session Ticket Key File", 'Allows the SSL Ticket Key to be created/maintained by an administrator. The file must be 48 bytes long. If this option is left empty, the load balancer will generate and rotate its own set of keys.<br/><br/>IMPORTANT: To maintain forward secrecy, it is strongly recommended to change the key every <b>SSL Session Ticket Lifetime</b> seconds. If this cannot be done, it is recommended to leave this field empty.', '', 'Path', '');
$this->db['sslSessionTicketLifetime'] = new DATTR_HELP_ITEM("SSL Session Ticket Lifetime (secs)", 'This value determines how long a session ticket will be valid before a renegotiation is required. Default is 3,600.', '', 'Integer number', '');
$this->db['sslSessionTickets'] = new DATTR_HELP_ITEM("Enable Session Tickets", 'Enables session tickets using OpenSSL&#039;s default session ticket setting. Server-level setting must be set to &quot;Yes&quot; for Virtual Host setting to take effect.<br/><br/>Default values:<br/><b>Server-level:</b> Yes<br/><b>VH-Level:</b> Yes', '', 'Select from radio box', '');
$this->db['sslStrictSni'] = new DATTR_HELP_ITEM("Strict SNI Certificate", 'Specifies whether to strictly require a dedicated virtual host certificate configuration. When enabled, SSL connections to virtual hosts without a dedicated certificate configuration will fail instead of using a default catch-all certificate.<br/><br/>Default value: No', '', 'Select from radio box', '');
$this->db['sslStrongDhKey'] = new DATTR_HELP_ITEM("SSL Strong DH Key", 'Specifies whether to use 2048 or 1024 bit DH keys for SSL handshakes. If set to &quot;Yes&quot;, 2048 bit DH keys will be used for 2048 bit SSL keys and certificates. 1024 bit DH keys will still be used in other situations. Default is &quot;Yes&quot;.<br/><br/>Earlier versions of Java do not support DH key size higher than 1024 bits. If Java client compatibility is required, this should be set to &quot;No&quot;.', '', 'radio', '');
$this->db['statuscode'] = new DATTR_HELP_ITEM("Status Code", 'Specifies the response status code of the external redirection. If the status code is between 300 and 399, &quot;Destination URI&quot; can be specified.', '', 'Select from drop down list', '');
$this->db['strategy'] = new DATTR_HELP_ITEM("Strategy", 'Select load balancing strategy from the list.<br/><ul>   <li>The round-robin algorithm cycles through a list of backend Server instances in order.</li>   <li>     The least-load algorithm improves on the round-robin algorithm by also taking into account the current work load of     each server.   </li>   <li>The least-session algorithm choose the server with fewest session associated.</li>   <li>     The Fastest Response algorithm chooses the Worker Group node that responds the fastest to a backend worker ping.   </li>   <li>     The Failover algorithm chooses the Worker Group node that is configured with the highest priority. When that node     becomes unhealthy, the next highest priority node is selected. If multiple nodes are configured with the same     priority, then the first node configured will be selected. When an unhealthy node with a higher priority recovers,     it will return as the highest priority node choice.   </li> </ul>', '', 'Select from drop down list', '');
$this->db['swappingDir'] = new DATTR_HELP_ITEM("Swapping Directory", 'Specifies the directory where the swapping files should be placed. When the server is started in chroot mode, this directory is relative to the new root directory, otherwise it is relative to the real root directory.<br/><br/>The server uses its own virtual memory to reduce system memory usage. Virtual memory and disk swapping are used to store large request bodies and dynamically generated responses. The swapping directory should be placed on a disk with enough space.<br/><br/>Default value: /tmp/lslbd/swap', ' Place the swapping directory on a separate disk or increase Max I/O Buffer Size to eliminate swapping.', 'Absolute path', '');
$this->db['templateFile'] = new DATTR_HELP_ITEM("Template File", 'Specifies the path to the configuration file of this template. The file must be located within $SERVER_ROOT/conf/templates/ with a &quot;.xml&quot; filename. If the file you designate does not exist, after trying to save the template an error will appear with the link &quot;CLICK TO CREATE&quot;. This link will generate a new empty template file. When you delete the template, the entry will be removed from your configurations, but the actual template config file will not be deleted.', '', 'path', '');
$this->db['templateFileRef'] = new DATTR_HELP_ITEM("Config File", 'Specifies the unique path for each member virtual host&#039;s configuration file. Variable $VH_NAME or $VH_ROOT must appear in the path so each member virtual host will have its own configuration file.', '', 'path with $VH_NAME or $VH_ROOT variable', '');
$this->db['templateName'] = new DATTR_HELP_ITEM("Template Name", 'A unique name for the template.', '', '', '');
$this->db['templateVHAliases'] = new DATTR_HELP_ITEM("Aliases", 'Specifies alternate names for the virtual host. All possible hostnames and IP addresses should be added to this list. The wildcard characters * and ? are allowed in the name. Append :<port> for web sites not on port 80.<br/><br/>Aliases will be used in the following situations: <ol>   <li>To match the hostname in the Host header when processing a   request.</li>   <li>To populate domain name/alias configurations for add-ons   like FrontPage or AWstats.</li>   <li>To configure listener-to-virtual host mappings based on the virtual host template.</li> </ol>', '', 'Comma-separated list of domain names.', '');
$this->db['templateVHDomain'] = new DATTR_HELP_ITEM("Domain", 'Specifies the main domain name for this member virtual host. If left blank, the virtual host name will be used. This should be a fully qualified domain name, but you can use an IP address as well. It is recommended to append :<port> for web sites not on port 80. For configurations containing domain names, this domain can be referenced with variable $VH_DOMAIN.<br/><br/>This domain name will be used in the following situations: <ol>   <li>To match the hostname in the Host header when processing a   request.</li>   <li>To populate domain name configurations for add-ons   like FrontPage or AWstats.</li>  <li>To configure listener-to-virtual host mappings based on the virtual host template.</li> </ol>', '', 'domain name', '');
$this->db['templateVHName'] = new DATTR_HELP_ITEM("Virtual Host Name", 'A unique name for this virtual host. This name must be unique among all template member virtual hosts and standalone virtual hosts. Inside a directory path configuration, this name can be referenced by the variable $VH_NAME.<br/><br/>If a standalone virtual host with the same name is also configured, then the member virtual host configuration will be ignored.', '', '', '');
$this->db['templateVHRoot'] = new DATTR_HELP_ITEM("Default Virtual Host Root", 'Specifies the default root directory for member virtual hosts using this template.  Variable $VH_NAME must appear in the path. This will allow each member template  to be automatically assigned a separate root directory based on its name.', '', 'path', '');
$this->db['toggleDebugLog'] = new DATTR_HELP_ITEM("Toggle Debug Logging", 'Toggle Debug Logging toggles the value of &quot;Debug Level&quot; between NONE and HIGH.  As debug logging has an impact on performance and can fill up the hard drive quickly, so &quot;Debug Level&quot; should usually be set to NONE on a production server.  This feature can be used instead to turn debug logging on and off quickly  in order to debug a problem on a production server. Debug logging turned on or  off in this way will not change anything shown in your server configurations.', '&quot;Toggle Debug Logging&quot; will only work if &quot;Log Level&quot;  is set to DEBUG.   Important! Debug logging includes detailed information for each  request and response. Active debug logging will severely degrade service performance and potentially saturate disk space in a very short time. This feature should only be  used for a short period of time when trying to diagnose server issues.', '', '');
$this->db['totalBandwidth'] = new DATTR_HELP_ITEM("Total Output Bandwidth (KB/sec)", 'Sets a limit for the total output bandwidth in KB/s for this virtual host. Once this limit is reached throttling will occur.', '', '', '');
$this->db['tpzconf_enabled'] = new DATTR_HELP_ITEM("Used by ZeroConf", 'Allow ZeroConf configurations to specify this template for use as a base for created VHosts.<br/><br/>Default value: Yes', '', 'Select from radio box', '');
$this->db['tpzconf_vhostPerDomain'] = new DATTR_HELP_ITEM("Separate VHost Per Domain", 'Create a VHost for each domain configured through ZeroConf. If set to &quot;No&quot;, all domains that share the same list of backends will share a VHost.<br/><br/>The server level <b>Separate VHost Per Domain</b> setting is ignored for VHosts created with this template.<br/><br/>Warning: When set to &quot;Yes&quot;, this could be very memory expensive if there are many domains.<br/><br/>Default value: No', '', 'Select from radio box', '');
$this->db['trustJetpack'] = new DATTR_HELP_ITEM("Trust Jetpack", 'Automatically set Jetpack IPs as VHost trusted. Jetpack IPs list is updated dynamically on a daily basis.<br/><br/>Default values:<br/><b>Server level:</b> No<br/><b>VH level:</b> Inherit Server level setting.', '', 'Select from drop down list', '');
$this->db['uploadTmpDir'] = new DATTR_HELP_ITEM("Temporary File Path", 'Temporary directory where files being uploaded to server will be stored  while request body parser is working. Default value is /tmp.', '', 'Absolute path or path starting with $SERVER_ROOT (for Server and VHost levels).', '');
$this->db['uploadTmpFilePermission'] = new DATTR_HELP_ITEM("Temporary File Permissions", 'Global setting determining file permissions used for files stored in the <b>Temporary File Path</b> directory.', '', '3 digits octet number. Default value is 666.', '');
$this->db['useIpInProxyHeader'] = new DATTR_HELP_ITEM("Use Client IP in Header", 'Specifies whether to use the first most valid IP IP address listed in the &quot;X-Forwarded-For&quot; HTTP request header for all IP address-related features, including connection/bandwidth throttling, access control, and IP geolocation.<br/><br/>This feature is useful if your web server is behind a load balancer or a proxy server. If you select Trusted IP Only, then X-Forwarded-For IP will be used only when the request is coming from trusted IPs defined in the server-level &quot;Allowed List&quot;.<br/><br/>Keep Header from Trusted IP is the same as Trusted IP Only, but the X-Forwarded-For header used for the backend will not be modified to include the connecting peer address.<br/><br/>Use Last IP (for AWS ELB) will use the last IP address in the &quot;X-Forwarded-For&quot; list. Select this option if you are using AWS Elastic Load Balancer or expect the real IP to appended to the end of the &quot;X-Forwarded-For&quot; list.', '', 'Select from drop down list', '');
$this->db['useRe2'] = new DATTR_HELP_ITEM("Use RE2 regex engine", 'Use RE2 when evaluating regular expressions instead of PCRE.<br/><br/>Default value: No', ' While PCRE provides more features than RE2, RE2 allows for a defined maximum memory usage and has a more predictable runtime than PCRE making it more suited for use in server applications.<br/> Unlike PCRE, RE2 uses a fixed stack and guarantees that run-time increases linearly (not exponentially) with the size of the input.', 'Select from radio box', '');
$this->db['userDBCacheTimeout'] = new DATTR_HELP_ITEM("User DB Cache Timeout (secs)", 'Specifies how often the backend user database will be checked for changes. Every entry in the cache has a timestamp. When cached data is older than the specified timeout, the backend database will be checked for changes. If there is no change, the timestamp will be reset to the current time, otherwise the new data will be loaded. Sevrer reload and graceful restart will clear the cache immediately.', ' If the backend database does not change very often, set a longer timeout for better performance.', 'Integer number', '');
$this->db['userDBLocation'] = new DATTR_HELP_ITEM("User DB Location", 'Specifies the location of the user database. For DB type Password File, it is the path to the flat file containing user/password definitions. You can edit this file through the WebAdmin console by clicking on the filename.<br/><br/>Each line of the user file contains a username followed by a colon, followed by a crypt() encrypted password, optionally followed by a colon and group names that user belongs to. Group names are delimitated by commas. If group information is specified in the user database, then the group database will not be checked.<br/><br/>Example:<blockquote><code>john:HZ.U8kgjnMOHo:admin,user</code></blockquote><br/><br/>For DB type LDAP, it is the LDAP URL to query for the user information. For each valid user, the authentication data stored in the LDAP server should contain at least the user id and user password. One and only one record should be returned in the LDAP search request based on the URL and username received in the HTTP Authentication header. &quot;$k&quot; must be specified in the filter part of the URL and it will be replaced with the username. The user password attribute must be returned in the query result. The attribute name of the user password is specified by &quot;Password Attribute&quot;. Group information can be optionally specified by the &quot;Member-of Attribute&quot;.<br/><br/>Example: At minimum, a user can be defined in LDAP with object classes: uidObject, simpleSecurityObject and organizationalRole. The following URL could be used:<br/><br/><blockquote><code>ldap://localhost/ou=UserDB,dc=example,dc=com???(&(objectClass=*)(uid=$k))</code></blockquote>', ' It is recommended to store user password files outside of the document tree. If a user password file has to be placed inside document tree, simply name it with a leading &quot;.ht&quot; like .htuser to prevent it being served as a static file.  LiteSpeed Web Server does not serve files prefixed with &quot;.ht&quot;.', 'Path to user DB file or LDAP URL (RFC 2255).', '');
$this->db['userDBMaxCacheSize'] = new DATTR_HELP_ITEM("User DB Max Cache Size", 'Specifies the maximum cache size of the user database. Recently accessed user authentication data will be cached in memory to provide maximum performance.', ' As a larger cache will consume more memory, a higher value may or may not provide better performance. Set it to an appropriate size according to your user database size and site usage.', 'Integer number', '');
$this->db['userDB_attrMemberOf'] = new DATTR_HELP_ITEM("Member-of Attribute", 'Specifies the name of the &quot;Member-of&quot; attribute for a user record stored in an LDAP server. The default value is memberOf. The &quot;Member-of&quot; attribute can be used to specify the group name that the user belongs to.', '', 'string', '');
$this->db['userDB_attrPasswd'] = new DATTR_HELP_ITEM("Password Attribute", 'Specifies the name of the password attribute for a user record stored in an LDAP server. The default value is userPassword.', '', 'string', '');
$this->db['vaction'] = new DATTR_HELP_ITEM("Actions - Virtual Host", 'This field shows buttons to disable, enable, or restart the virtual host.   Actions taken on one virtual host do not affect the rest of the web server.', 'It is good idea to disable a virtual host temporarily when updating its content.', '', '');
$this->db['vdisable'] = new DATTR_HELP_ITEM("Disable", 'The Disable action stops a running virtual host. New requests will not be accepted, but requests being processed will finish as usual.', '', '', '');
$this->db['venable'] = new DATTR_HELP_ITEM("Enable", 'The Enable action starts up a stopped virtual host.   This allows new requests to be accepted.', '', '', '');
$this->db['verifyDepth'] = new DATTR_HELP_ITEM("Verify Depth", ' Specifies how deeply a certificate should be verified before determining that the client does not have a valid certificate. The default is &quot;1&quot;.', '', 'Select from drop down list', '');
$this->db['verifyExpires'] = new DATTR_HELP_ITEM("Verification Expires (secs)", 'Sets the expire time of a successful reCAPTCHA submission, after which reCAPTCHA protection will re-trigger for that visitor.<br/><br/>Default value: 86,400 (1 day).', '', 'Integer value between 30 and 31,536,000 (1 year).', '');
$this->db['verifyGoogleBot'] = new DATTR_HELP_ITEM("Verify Google Bot", 'Perform a PTR lookup to ensure that the reverse DNS of an IP matches Google&#039;s crawler information and bypass reCAPTCHA verification if so.  Bad Google bot IPs are logged.<br/><br/>Default value: No', '', 'Select from radio box', '');
$this->db['vermgr'] = new DATTR_HELP_ITEM("Version Management", 'Version Management (found by clicking on the the version number at  the top of the page) is a convenient tool to manage LSWS versions. It shows license info and information on all installed versions and available new releases.   <ul><li>If a new version has been released on the LiteSpeed website, and &quot;Check For Update&quot; is  enabled, the new version will be listed with a Download link. If &quot;Download Updates&quot; is enabled, new versions will be automatically downloaded and the new version  will be listed with an Upgrade link. Upgrade  installs the new package and restarts the web server. </li> <li>You return to a previous version by clicking the Switch To link. This will restart the web server with that version.</li> <li>If you are sure that you no longer need an old installation, you can remove it by clicking the Delete link. This will permanently remove that copy.</li></ul>  Please note, service will not be interrupted during an upgrade or restart.', '', '', '');
$this->db['vhEnableGzip'] = new DATTR_HELP_ITEM("Enable Compression", 'Specifies whether to enable GZIP/Brotli compression for this virtual host. This setting is only effective when compression is enabled at the server level. Compression settings are configured at the server level (Tuning > GZIP/Brotli Compression).', '', 'Select from radio box', '');
$this->db['vhEnableQuic'] = new DATTR_HELP_ITEM("Enable HTTP3/QUIC", 'Enables the HTTP3/QUIC network protocol for this virtual host. For this setting to take effect, both &quot;Enable HTTP3/QUIC&quot; and &quot;Open HTTP3/QUIC (UDP) port&quot; must also be set to Yes at the server and listener levels respectively. Default value is Yes.', 'When this setting is set to No, the HTTP3/QUIC advertisement will no longer be sent. If a browser still contains cached HTTP3/QUIC information and HTTP3/QUIC is still enabled at the server and listener levels, an HTTP3/QUIC connection will continue to be used until this information is no longer cached or an HTTP3/QUIC protocol error is encountered.', 'Select from radio box', '');
$this->db['vhMaxKeepAliveReq'] = new DATTR_HELP_ITEM("Max Keep-Alive Requests", 'Specifies the maximum requests that can be served through a keep-alive (persistent) connection. Connections will be closed once this limit is reached. You can specify a different limit for each virtual hosts. This number cannot exceed the server-level &quot;Max Keep-Alive Requests&quot; limit.', ' Set to a reasonably high value. A value of &quot;1&quot; or less will disable keep-alive connections.', 'Integer number', '');
$this->db['vhName'] = new DATTR_HELP_ITEM("Virtual Host Name", 'A unique name for a virtual host. It is recommended to use the virtual host&#039;s domain name as the Virtual Host Name. Virtual Host Name can be referred to using the variable $VH_NAME.', '', '', '');
$this->db['vhaccessLog_fileName'] = new DATTR_HELP_ITEM("File Name", 'The access log filename.', ' Put the access log file on a separate disk.', 'Filename which can be an absolute path or a relative path to $SERVER_ROOT, $VH_ROOT.', '');
$this->db['vhlog_fileName'] = new DATTR_HELP_ITEM("File Name", 'Specifies the path for the log file.', ' Place the log file on a separate disk.', 'Filename which can be an absolute path or a relative path to $SERVER_ROOT, $VH_ROOT.', '');
$this->db['vhlog_logLevel'] = new DATTR_HELP_ITEM("Log Level", 'Specifies the level of logging. Available levels (from high to low) are ERROR,  WARNING, NOTICE, INFO, and DEBUG.  Only messages with a level higher than or equal to the current setting will be logged.  If you want to set it to DEBUG, you must set the server log level to DEBUG as well.  The level of debugging is controlled solely at the server level by &quot;Debug Level&quot;.', ' Unless &quot;Debug Level&quot; is set to a level other than NONE, DEBUG log level does not have any performance impact and is recommended.', 'Select from drop down list', '');
$this->db['viewlog'] = new DATTR_HELP_ITEM("Server Log Viewer", 'The Server Log Viewer is a convenient tool for browsing the  current server log to check for errors or problems.  The log viewer  searches the server log file in blocks for the specified log level.    The default block size is 20KB. You can use the Begin, End, Next, and Prev buttons to navigate a large log file.', 'The size of a dynamically generated page is limited by &quot;Max Response Body Size (bytes)&quot;.   So if the block is too big, the page might be truncated.', '', '');
$this->db['virtualHostMapping'] = new DATTR_HELP_ITEM("Virtual Host Mappings", 'Specifies the relationship between the listener and virtual hosts. Listeners and virtual hosts are associated by domain names. An HTTP request will be routed to a virtual host with a matching domain name. One listener can map to multiple virtual hosts for different domain names. One virtual host can also be mapped from different listeners. One listener can allow one catchall virtual host with the domain name value &quot;*&quot;. When there is no explicitly matched domain name in the listener&#039;s mapping, the listener will forward the request to that catchall virtual host.', ' Only add necessary mappings. If the listener is mapped to only one virtual host, then only set up a catchall mapping &quot;*&quot;.', '', '');
$this->db['virtualHostName'] = new DATTR_HELP_ITEM("Virtual Host", 'Specifies the name of a virtual host.', '', 'Select from drop down list', '');
$this->db['vname'] = new DATTR_HELP_ITEM("Name - Virtual Host", 'The unique name that identifies this virtual host. This is the &quot;Virtual Host Name&quot;  you specified when setting up this virtual host.', '', '', '');
$this->db['vreload'] = new DATTR_HELP_ITEM("Restart - Virtual Host", 'The Restart action causes the web server to load the newest configuration  for this virtual host. Requests being processed will finish with the old configuration.  The new configuration will only apply for new requests. All changes to a virtual host  can be applied on the fly this way.', '', '', '');
$this->db['vstatus'] = new DATTR_HELP_ITEM("Status - Virtual Host", 'The current status of a virtual host.   The status can be: Running, Stopped, Restart Required,   or Running - Removed from Configuration.  <ul>     <li>Running means the virtual host is loaded and in service.</li>     <li>Stopped means the virtual host is loaded but not in service (disabled). </li>     <li> Restart Required means this is a newly added virtual host and          the server has not yet loaded its configuration. </li>     <li>Running - Removed from Configuration means the virtual host has been deleted      from the server&#039;s configuration but it is still in service. </li> </ul>', '', '', '');
$this->db['workerGroupEnabled'] = new DATTR_HELP_ITEM("Enabled", 'Specifies whether to enable this worker group.', '', 'Select from radio box', '');
$this->db['workerName'] = new DATTR_HELP_ITEM("Name", 'A unique name for a group of workers.', '', '', '');
$this->db['workerProtocol'] = new DATTR_HELP_ITEM("Additional HTTPS Protocols", 'Additional HTTP protocols used to communicate with the backend server when supported. For this setting to take effect, &quot;Type&quot; must be set to HTTPS Proxy.<br/><br/>HTTP/1 will be used by default if no additional protocols are selected or if the selected protocols are not supported by the backend server.<br/><br/>Default value: All Unchecked (HTTP/1)', '', 'Select from checkbox', '');
$this->db['workergroup_priority'] = new DATTR_HELP_ITEM("Priority", 'Specifies the priority value for the configured node group. Only useful when &quot;Strategy&quot; is set to Failover.<br/><br/>Default value: 100', '', 'Integer value from 0 to 255. Higher value means higher priority.', '');
$this->db['wpProtectAction'] = new DATTR_HELP_ITEM("Protection Mode", 'Specifies the action to be taken when the specified Allowed Login Attempts limit is reached within 5 minutes.<br/><br/>Throttle gradually slows down the speed of the server response, Drop severs the connection without any reply, Deny returns a 403 response, and CAPTCHA or Drop redirects to a CAPTCHA if reCAPTCHA Protection is enabled and drops otherwise.<br/><br/>WP Login CAPTCHA Full Protection can also be selected. This setting will redirect to a CAPTCHA if ReCAPTCHA Protection is enabled regardless of Allowed Login Attempts limit and falls back to use Throttle otherwise.<br/><br/>Default values:<br/><b>Server level:</b> Throttle<br/><b>VH level:</b> Inherit Server level setting. If Server level is set to Disable, Throttle will be used.', ' Trusted IPs or sub-networks are not affected.<br/> This can be set at the Server level and overwritten at the Virtual Host level. If not overridden at the Virtual Host level, this setting can also be overridden in a user&#039;s docroot .htaccess file using Apache configuration directive WordPressProtect with value 0 (disabled), 1 (use server level setting), throttle, deny, or drop.', 'Select from drop down list', '');
$this->db['wpProtectLimit'] = new DATTR_HELP_ITEM("Allowed Login Attempts", 'Specifies the maximum number of wp-login.php and xmlrpc.php POST attempts allowed by an IP within 5 minutes before the action specified in &quot;Protection Mode&quot; is taken.<br/><br/>This limit is handled using a quota system where remaining attempts = limit. Each POST attempt will decrease the number of remaining attempts by 1, with the number of remaining attempts increasing back to the set limit over time. An IP will be throttled once the number of remaining attempts for that IP falls to 1/2 the set limit, throttling more as the remaining attempts drops further below the 1/2 mark. When remaining attempts reaches 0, the specified action is taken toward the IP.<br/><br/>In addition to this, if &quot;Enable reCAPTCHA&quot; is also enabled, an additional per worker protection will be added. If wp-login.php and xmlrpc.php are visited by the same worker at a rate of 4x the set limit in a 30 second time frame, those URLs will be put into reCAPTCHA mode until the number of visits to these files decreases.<br/><br/>Resetting the server will clear blocked IPs.<br/><br/>Default values:<br/><b>Server-level:</b> 10<br/><b>VH-Level:</b> Inherit Server level setting', ' Trusted IPs or sub-networks are not affected.<br/><br/> This can be set at the Server level and overwritten at the Virtual Host level. If not overridden at the Virtual Host level, this setting can also be overridden in a user&#039;s docroot .htaccess file using Apache configuration directive WordPressProtect with integer value between 3 and 1000.', 'Valid Range: 3 - 1000.', 'With an Attempt limit of 10, and a Mode of drop:<br/><br/>After the first POST attempt, the quota is decreased to 9.<br/><br/>Quota decreases by 1 for each POST attempt.<br/><br/>After Quota reaches half of the limit (5), the IP will be throttled.<br/><br/>Throttling will get worse with each POST attempt.<br/><br/>Once the quota reaches 0, the connection will be dropped.');
$this->db['zconfEnabled'] = new DATTR_HELP_ITEM("Enable ZeroConf", 'Use ZeroConf managed load balancing and accept traffic bound for ZeroConf enabled backends.', 'In order for this setting to take effect, ZeroConf must also be enabled at the server level.', 'Select from radio box', '');
$this->db['zconfShmDir'] = new DATTR_HELP_ITEM("ZeroConf SHM Directory", 'The location where ZeroConf shared memory files are stored. The default directory is $SERVER_ROOT/zconf.', '', 'path', '');
$this->db['zconf_accessControl'] = new DATTR_HELP_ITEM("Access Control", 'Specifies what sub networks and/or IP addresses can send ZeroConf messages to LiteSpeed Web ADC when ZeroConf is enabled.', '', '', '');
$this->db['zconf_accessControl_allow'] = new DATTR_HELP_ITEM("Allowed List", 'Specifies the list of IPs or sub-networks allowed. * or ALL are accepted.', '', 'Comma delimited list of IP addresses or sub-networks. A trailing &quot;T&quot; can be used to indicate a trusted IP or sub-network, such as 192.168.1.*T.', '<b>Sub-networks:</b> 192.168.1.0/255.255.255.0, 192.168.1.0/24, 192.168.1, or 192.168.1.*<br/><b>IPv6 addresses:</b> ::1 or [::1]<br/><b>IPv6 subnets:</b> 3ffe:302:11:2:20f:1fff:fe29:717c/64 or [3ffe:302:11:2:20f:1fff:fe29:717c]/64');
$this->db['zconf_accessControl_deny'] = new DATTR_HELP_ITEM("Denied List", 'Specifies the list of IPs or sub-networks disallowed.', '', 'Comma delimited list of IP addresses or sub-networks. * or ALL are accepted.', '<b>Sub-networks:</b> 192.168.1.0/255.255.255.0, 192.168.1.0/24, 192.168.1, or 192.168.1.*<br/><b>IPv6 addresses:</b> ::1 or [::1]<br/><b>IPv6 subnets:</b> 3ffe:302:11:2:20f:1fff:fe29:717c/64 or [3ffe:302:11:2:20f:1fff:fe29:717c]/64');
$this->db['zconf_domCiphers'] = new DATTR_HELP_ITEM("ZeroConf Domain Ciphers", 'Specifies a custom cipher suite for ZeroConf domains.<br/><br/>Default value: Use server default ciphers', '', 'Colon-separated string of cipher specifications.', '');
$this->db['zconf_domLogDir'] = new DATTR_HELP_ITEM("Domain Log Directory", 'Directory in which to create logs for ZeroConf domains.<br/>Note: This directory must be writeable for the LSLBD runtime user set in &quot;Running As&quot; for logs to be written.<br/><br/>Default value: Not Set', '', 'An absolute path or a relative path to $SERVER_ROOT.', '');
$this->db['zconf_enabled'] = new DATTR_HELP_ITEM("Enable ZeroConf", 'Choose whether or not to enable the ZeroConf feature.', 'Once enabled at the server level, this feature can be enabled individually per listener.', 'Select from radio box', '');
$this->db['zconf_groupFile'] = new DATTR_HELP_ITEM("Group Password File", 'The location of an HTTP basic authentication group password file.', '', 'path', '');
$this->db['zconf_laddr'] = new DATTR_HELP_ITEM("Address", 'Address of listener that will only accept ZeroConf configuration and control messages.', '', 'IP:port', '');
$this->db['zconf_listeners'] = new DATTR_HELP_ITEM("ZeroConf Listeners", 'Secure SSL listeners that will listen for ZeroConf messages only.', '', '', '');
$this->db['zconf_logPerDomain'] = new DATTR_HELP_ITEM("Separate Log Per Domain", 'Indicate whether to log ZeroConf configured VHosts separately. This configuration only takes effect when &quot;Separate VHost Per Domain&quot; is set for the domain.<br/><br/>For example, if &quot;Separate VHost Per Domain&quot; is not set at the Server level but is set in a VHost Template, this will only take effect for the VHost Template&#039;s domains.<br/><br/>Note: &quot;Domain Log Directory&quot; must also be set for this option to be saved.<br/><br/>Default value: All unchecked', '', 'Select from checkbox', '');
$this->db['zconf_mode'] = new DATTR_HELP_ITEM("Mode", 'Specifies which mode the ZeroConf cluster operates in, &quot;Stateless&quot; or &quot;Stateful&quot;.<br/><br/>&quot;Stateful&quot; mode track sessions associated with each back-end server. It also called &quot;Session Affinity&quot;.<br/><br/>&quot;Stateless&quot; mode does not care about sessions.<br/><br/>Default value: Stateful', '', 'Select from drop down list', '');
$this->db['zconf_passwdFile'] = new DATTR_HELP_ITEM("User Password File", 'The location of an HTTP basic authentication user password file.', '', 'path', '');
$this->db['zconf_vhostPerDomain'] = new DATTR_HELP_ITEM("Separate VHost Per Domain", 'Create a VHost for each domain configured through ZeroConf. If set to No, all domains that share the same list of backends will share a VHost.<br/><br/>Warning: When set to Yes, this could be very memory expensive if there are many domains.<br/><br/>Default value: No', '', 'Select from radio box', '');
$this->db['zconf_workerMaxConns'] = new DATTR_HELP_ITEM("Worker Max Connections", 'Maximum number of connections per ZeroConf worker. There is one worker created per backend listener per ADC worker process.<br/><br/>Default value: 100', '', 'Integer number', 'Suppose the ADC has four worker processes. Three backend servers send their configurations to the ADC and each of them have an HTTP (:80) and HTTPS (:443) listener. Using the default value of Worker Max Connections value of 100, the maximum number of connections made between the ADC and backend nodes will be:<br/><br/>100 (default per worker) x 4 (ADC workers with a &quot;Web ADC Large&quot; license),  x 3 (backend ZeroConf servers) x 2 (HTTP and HTTPS ports) = 2,400');
$this->edb['UDBgroup'] = array('If group information is added here, this information will be used for resource authorization and any group database settings involving this user will be ignored.','You can enter multiple groups, using a comma to separate them. Space characters will be treated as part of a group name.');
$this->edb['accessControl_allow'] = array('You can set up access control at server, virtual host and context levels. If there is access control at server level, the virtual host rules will be applied after the server rules are satisfied.','Input format can be an IP like 192.168.0.2, a sub-network like 192.168.*, or a subnet/netmask like 192.168.128.5/255.255.128.0.','If you have trusted IP or sub-network, then you must specify them in allowed list by adding a trailing &quot;T&quot; such as 192.168.1.*T. Trusted IP or sub-network is not limited by connection/throttling limit.');
$this->edb['accessControl_deny'] = array('To deny access from certain address, put &quot;ALL&quot; in allowed list, and put subnet or IP in denied list. To allow only certain IP or subnet to access the site, put &quot;ALL&quot; in denied list and specify the address in the allowed list.');
$this->edb['accessLog_fileName'] = array('Log file path can be an absolute path or relative to $SERVER_ROOT.');
$this->edb['aclogUseServer'] = array('When required, you can disable access logging for this virtual host to save on disk i/o.');
$this->edb['adminEmails'] = array('You can enter multiple admin emails: use comma to separate.');
$this->edb['adminOldPass'] = array('For security reasons, if you forget the admin password, you will be unable to change it from the WebAdmin Console.  Please use the following shell command instead:  <br><br> /usr/local/lsws/admin/misc/admpass.sh.  <br><br> This script will remove all entered admin user IDs and overwrite them with a single admin user.');
$this->edb['compressibleTypes'] = array('Compressible Types is a list of MIME types that are compressible, separated by commas. You can use wildcard &quot;*&quot; for MIME types, like */*, text/*. You can put &quot;!&quot; in front to exclude certain types. The order of the list is important if you use &quot;!&quot;. For e.g., a list like &quot;text/*, !text/css, !text/js&quot; will compress all text file except for css and js.');
$this->edb['ctxType'] = array('The <b>Load Balancer</b> context is used to assign a different cluster for that context.','The <b>Redirect</b> context is used to set up an internal or external redirect URI.');
$this->edb['defaultCluster'] = array('Set up the default cluster here, all traffic will be served by this cluster unless contexts has been defined.');
$this->edb['domainName'] = array('Enter all the domains that you want this listener to respond to. Use comma &quot;,&quot; to separate individual domain.','You can choose only one virtual host to handle all unspecified domains, put &quot;*&quot; in domains.');
$this->edb['enableAntiddos'] = array('');
$this->edb['enableRecaptcha'] = array('When this setting is set to <b>Yes</b> at the Server level, reCAPTCHA Protection can still be disabled at the Virtual Host level.');
$this->edb['externalredirect'] = array('Set up redirect URI here. If it is an external redirect, you can specify the status code. Internal redirect has to start with &quot;/&quot;, external redirect can either start with &quot;/&quot; or with &quot;http(s)://&quot;.');
$this->edb['extraHeaders'] = array('The Header Operations setting is backwards compatible with the old &#039;header_name: value1,value2,...&#039; syntax, which is equivalent to setting the header + values using the &#039;Header&#039; directive.');
$this->edb['firewallEnable'] = array('');
$this->edb['gdb_groupname'] = array('Group Name should comprise of letter and numbers only.');
$this->edb['gzipCompressLevel'] = array('GZIP Compression level ranges from 1 (Minimum) to 9 (Maximum).');
$this->edb['haInterfaceId'] = array('Additions/Deletions/Changes made will not take effect until applied through HA -> Status page.');
$this->edb['hardLimit'] = array('Set concurrent connection Limits coming from one client (per IP address). This helps against DoS attack.');
$this->edb['listenerIP'] = array('Select an IP address from the list, if you don&#039;t specify a particular address, the system will bind to all the available IP address on this machine.');
$this->edb['listenerName'] = array('Give listener a name that is easy to understand and remember.');
$this->edb['listenerPort'] = array('Input a unique port number on this IP for this listener. Only super user (root) can use ports lower than 1024. Port 80 is the default HTTP port; port 443 is the default HTTPS port.');
$this->edb['listenerSecure'] = array('Selecting &quot;Yes&quot; for <b>Secure</b> will make this listener use https. You must then configure this further in SSL settings.');
$this->edb['logUseServer'] = array('If you select &quot;Yes&quot; for <b>Use Server&#039;s Log</b>, the log will be written to the server file set up at the server level.');
$this->edb['log_enableStderrLog'] = array('Stderr Log is located in the same directory as the Server Log. If enabled, all External Application output to stderr will be logged in this file.');
$this->edb['log_fileName'] = array('Log file path can be an absolute path or relative to $SERVER_ROOT.');
$this->edb['log_rollingSize'] = array('A new log file will be created if current log file exceeds the rolling size. File size is in bytes and can be in multiple input formats: 10240, 10K or 1M.');
$this->edb['maxReqHeaderSize'] = array('Numbers can be represented as 10240 or 10K.');
$this->edb['pagespeedActivate'] = array('');
$this->edb['pagespeedEnabled'] = array('');
$this->edb['pagespeedParams'] = array('');
$this->edb['realm'] = array('A Context can be protected with a predefined realm, which is set up in the virtual host security section. Optionally, an alternative name and additional requirements can be specified.');
$this->edb['realmName'] = array('Define your HT Access realm here, this can be used for contexts.');
$this->edb['realmType'] = array('Currently password file and LDAP are supported for user DB and group DB.');
$this->edb['recaptchaAllowedRobotHits'] = array('');
$this->edb['recaptchaBotWhiteList'] = array('');
$this->edb['recaptchaMaxTries'] = array('');
$this->edb['recaptchaRegConnLimit'] = array('');
$this->edb['recaptchaSecretKey'] = array('');
$this->edb['recaptchaSiteKey'] = array('The server level site/secret key pair must be configured to skip domain checking if the server manages multiple domains. Otherwise, the reCAPTCHA verification will not work properly.');
$this->edb['recaptchaSslConnLimit'] = array('');
$this->edb['recaptchaType'] = array('');
$this->edb['recaptchaVhReqLimit'] = array('');
$this->edb['rewriteMapLocation'] = array('Enter URI for location. URI must start with &quot;/&quot;.');
$this->edb['rewriteRules'] = array('Only virtual host level rewrite rules should be used here, such as those found in an Apache virtual host config file. Do NOT add any document root level rewrite rules here. If you have any document root level rewrite rules from .htaccess, you should instead create a static context with uri &quot;/&quot; and add the rewrite rules there.');
$this->edb['serverName'] = array('The user and group setting of the server process cannot be modified. This was set up during installation. You have to reinstall to change this option.');
$this->edb['sndBufSize'] = array('Numbers can be represented as 10240, 10K or 1M.','If send/receive buffer size is 0, OS default TCP buffer size will be used.');
$this->edb['softLimit'] = array('Set IP level throttle limit here. The number will be rounded up to 4K units. Set to &quot;0&quot; to disable throttling.','Number of connections can temporarily exceed Soft Limit during Grace Period as long as under Hard Limit. After Grace Period, if it is still above Soft Limit, then no more connections will be allowed from that IP for time of Banned Period.');
$this->edb['sslSessionCache'] = array('Session caching allows a client to resume a session within a set amount of time without having to re-perform an SSL handshake. You can do this by assigning clients a session ID using  <b>Enable Session Cache</b>, or by creating and using session tickets.');
$this->edb['sslSessionTicketKeyFile'] = array('Session tickets will be rotated automatically if the tickets are being generated by the server. If using the <b>SSL Session Ticket Key File</b> option to create and manage your own session tickets, you must be rotate the tickets yourself using a cron job.','<b>SSL Session Ticket Key file</b> should be used for high availability setups to avoid re-issuing tickets when a client is handled by different load balancers.');
$this->edb['swappingDir'] = array('Swapping directory is recommended to be placed on a local disk such as /tmp. Network drive should be avoided at all cost. Swap will be when configured memory i/o buffer is exhausted.');
$this->edb['verifyExpires'] = array('');
$this->edb['vhlog_fileName'] = array('Log file path can be an absolute path or relative to $SERVER_ROOT, $VH_ROOT.','If you want to set Log Level to DEBUG, you must set the server log level to DEBUG as well. The level of  debugging is controlled by Server DEBUG Level. Use DEBUG only if you have to as it has a large impact on server performance and can fill up disk space quickly.');
$this->edb['virtualHostName'] = array('Select the virtual hosts that you want to map to this listener.','If you have not set up the virtual host you want to map, you can skip this step and come back later.');
$this->edb['zconfEnabled'] = array('');
$this->edb['zconf_accessControl_allow'] = array('Input format can be an IP like 192.168.0.2, a sub-network like 192.168.*, or a subnet/netmask like 192.168.128.5/255.255.128.0.','If you have trusted IP or sub-network, then you must specify them in allowed list by adding a trailing &quot;T&quot; such as 192.168.1.*T. Trusted IP or sub-network is not limited by connection/throttling limit.');
$this->edb['zconf_accessControl_deny'] = array('To deny access from certain address, put &quot;ALL&quot; in allowed list, and put subnet or IP in denied list. To allow only certain IP or subnet to access the site, put &quot;ALL&quot; in denied list and specify the address in the allowed list.');
